// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/beyondcorp/appgateways/v1/app_gateways_service.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fbeyondcorp_2fappgateways_2fv1_2fapp_5fgateways_5fservice_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fbeyondcorp_2fappgateways_2fv1_2fapp_5fgateways_5fservice_2eproto__INCLUDED

#include "google/cloud/beyondcorp/appgateways/v1/app_gateways_service.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>
#include <grpcpp/ports_def.inc>

namespace google {
namespace cloud {
namespace beyondcorp {
namespace appgateways {
namespace v1 {

// API Overview:
//
// The `beyondcorp.googleapis.com` service implements the Google Cloud
// BeyondCorp API.
//
// Data Model:
//
// The AppGatewaysService exposes the following resources:
//
// * AppGateways, named as follows:
//   `projects/{project_id}/locations/{location_id}/appGateways/{app_gateway_id}`.
//
// The AppGatewaysService service provides methods to manage
// (create/read/update/delete) BeyondCorp AppGateways.
class AppGatewaysService final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.beyondcorp.appgateways.v1.AppGatewaysService";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Lists AppGateways in a given project and location.
    virtual ::grpc::Status ListAppGateways(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appgateways::v1::ListAppGatewaysRequest& request, ::google::cloud::beyondcorp::appgateways::v1::ListAppGatewaysResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::beyondcorp::appgateways::v1::ListAppGatewaysResponse>> AsyncListAppGateways(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appgateways::v1::ListAppGatewaysRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::beyondcorp::appgateways::v1::ListAppGatewaysResponse>>(AsyncListAppGatewaysRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::beyondcorp::appgateways::v1::ListAppGatewaysResponse>> PrepareAsyncListAppGateways(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appgateways::v1::ListAppGatewaysRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::beyondcorp::appgateways::v1::ListAppGatewaysResponse>>(PrepareAsyncListAppGatewaysRaw(context, request, cq));
    }
    // Gets details of a single AppGateway.
    virtual ::grpc::Status GetAppGateway(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appgateways::v1::GetAppGatewayRequest& request, ::google::cloud::beyondcorp::appgateways::v1::AppGateway* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::beyondcorp::appgateways::v1::AppGateway>> AsyncGetAppGateway(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appgateways::v1::GetAppGatewayRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::beyondcorp::appgateways::v1::AppGateway>>(AsyncGetAppGatewayRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::beyondcorp::appgateways::v1::AppGateway>> PrepareAsyncGetAppGateway(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appgateways::v1::GetAppGatewayRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::beyondcorp::appgateways::v1::AppGateway>>(PrepareAsyncGetAppGatewayRaw(context, request, cq));
    }
    // Creates a new AppGateway in a given project and location.
    virtual ::grpc::Status CreateAppGateway(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appgateways::v1::CreateAppGatewayRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateAppGateway(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appgateways::v1::CreateAppGatewayRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateAppGatewayRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateAppGateway(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appgateways::v1::CreateAppGatewayRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateAppGatewayRaw(context, request, cq));
    }
    // Deletes a single AppGateway.
    virtual ::grpc::Status DeleteAppGateway(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appgateways::v1::DeleteAppGatewayRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteAppGateway(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appgateways::v1::DeleteAppGatewayRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteAppGatewayRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteAppGateway(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appgateways::v1::DeleteAppGatewayRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteAppGatewayRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Lists AppGateways in a given project and location.
      virtual void ListAppGateways(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appgateways::v1::ListAppGatewaysRequest* request, ::google::cloud::beyondcorp::appgateways::v1::ListAppGatewaysResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListAppGateways(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appgateways::v1::ListAppGatewaysRequest* request, ::google::cloud::beyondcorp::appgateways::v1::ListAppGatewaysResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets details of a single AppGateway.
      virtual void GetAppGateway(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appgateways::v1::GetAppGatewayRequest* request, ::google::cloud::beyondcorp::appgateways::v1::AppGateway* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetAppGateway(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appgateways::v1::GetAppGatewayRequest* request, ::google::cloud::beyondcorp::appgateways::v1::AppGateway* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new AppGateway in a given project and location.
      virtual void CreateAppGateway(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appgateways::v1::CreateAppGatewayRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateAppGateway(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appgateways::v1::CreateAppGatewayRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a single AppGateway.
      virtual void DeleteAppGateway(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appgateways::v1::DeleteAppGatewayRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteAppGateway(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appgateways::v1::DeleteAppGatewayRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::beyondcorp::appgateways::v1::ListAppGatewaysResponse>* AsyncListAppGatewaysRaw(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appgateways::v1::ListAppGatewaysRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::beyondcorp::appgateways::v1::ListAppGatewaysResponse>* PrepareAsyncListAppGatewaysRaw(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appgateways::v1::ListAppGatewaysRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::beyondcorp::appgateways::v1::AppGateway>* AsyncGetAppGatewayRaw(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appgateways::v1::GetAppGatewayRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::beyondcorp::appgateways::v1::AppGateway>* PrepareAsyncGetAppGatewayRaw(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appgateways::v1::GetAppGatewayRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateAppGatewayRaw(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appgateways::v1::CreateAppGatewayRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateAppGatewayRaw(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appgateways::v1::CreateAppGatewayRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteAppGatewayRaw(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appgateways::v1::DeleteAppGatewayRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteAppGatewayRaw(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appgateways::v1::DeleteAppGatewayRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status ListAppGateways(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appgateways::v1::ListAppGatewaysRequest& request, ::google::cloud::beyondcorp::appgateways::v1::ListAppGatewaysResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::beyondcorp::appgateways::v1::ListAppGatewaysResponse>> AsyncListAppGateways(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appgateways::v1::ListAppGatewaysRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::beyondcorp::appgateways::v1::ListAppGatewaysResponse>>(AsyncListAppGatewaysRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::beyondcorp::appgateways::v1::ListAppGatewaysResponse>> PrepareAsyncListAppGateways(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appgateways::v1::ListAppGatewaysRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::beyondcorp::appgateways::v1::ListAppGatewaysResponse>>(PrepareAsyncListAppGatewaysRaw(context, request, cq));
    }
    ::grpc::Status GetAppGateway(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appgateways::v1::GetAppGatewayRequest& request, ::google::cloud::beyondcorp::appgateways::v1::AppGateway* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::beyondcorp::appgateways::v1::AppGateway>> AsyncGetAppGateway(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appgateways::v1::GetAppGatewayRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::beyondcorp::appgateways::v1::AppGateway>>(AsyncGetAppGatewayRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::beyondcorp::appgateways::v1::AppGateway>> PrepareAsyncGetAppGateway(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appgateways::v1::GetAppGatewayRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::beyondcorp::appgateways::v1::AppGateway>>(PrepareAsyncGetAppGatewayRaw(context, request, cq));
    }
    ::grpc::Status CreateAppGateway(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appgateways::v1::CreateAppGatewayRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateAppGateway(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appgateways::v1::CreateAppGatewayRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateAppGatewayRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateAppGateway(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appgateways::v1::CreateAppGatewayRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateAppGatewayRaw(context, request, cq));
    }
    ::grpc::Status DeleteAppGateway(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appgateways::v1::DeleteAppGatewayRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteAppGateway(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appgateways::v1::DeleteAppGatewayRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteAppGatewayRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteAppGateway(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appgateways::v1::DeleteAppGatewayRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteAppGatewayRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void ListAppGateways(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appgateways::v1::ListAppGatewaysRequest* request, ::google::cloud::beyondcorp::appgateways::v1::ListAppGatewaysResponse* response, std::function<void(::grpc::Status)>) override;
      void ListAppGateways(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appgateways::v1::ListAppGatewaysRequest* request, ::google::cloud::beyondcorp::appgateways::v1::ListAppGatewaysResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetAppGateway(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appgateways::v1::GetAppGatewayRequest* request, ::google::cloud::beyondcorp::appgateways::v1::AppGateway* response, std::function<void(::grpc::Status)>) override;
      void GetAppGateway(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appgateways::v1::GetAppGatewayRequest* request, ::google::cloud::beyondcorp::appgateways::v1::AppGateway* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateAppGateway(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appgateways::v1::CreateAppGatewayRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateAppGateway(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appgateways::v1::CreateAppGatewayRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteAppGateway(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appgateways::v1::DeleteAppGatewayRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteAppGateway(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appgateways::v1::DeleteAppGatewayRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::beyondcorp::appgateways::v1::ListAppGatewaysResponse>* AsyncListAppGatewaysRaw(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appgateways::v1::ListAppGatewaysRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::beyondcorp::appgateways::v1::ListAppGatewaysResponse>* PrepareAsyncListAppGatewaysRaw(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appgateways::v1::ListAppGatewaysRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::beyondcorp::appgateways::v1::AppGateway>* AsyncGetAppGatewayRaw(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appgateways::v1::GetAppGatewayRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::beyondcorp::appgateways::v1::AppGateway>* PrepareAsyncGetAppGatewayRaw(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appgateways::v1::GetAppGatewayRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateAppGatewayRaw(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appgateways::v1::CreateAppGatewayRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateAppGatewayRaw(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appgateways::v1::CreateAppGatewayRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteAppGatewayRaw(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appgateways::v1::DeleteAppGatewayRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteAppGatewayRaw(::grpc::ClientContext* context, const ::google::cloud::beyondcorp::appgateways::v1::DeleteAppGatewayRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_ListAppGateways_;
    const ::grpc::internal::RpcMethod rpcmethod_GetAppGateway_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateAppGateway_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteAppGateway_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Lists AppGateways in a given project and location.
    virtual ::grpc::Status ListAppGateways(::grpc::ServerContext* context, const ::google::cloud::beyondcorp::appgateways::v1::ListAppGatewaysRequest* request, ::google::cloud::beyondcorp::appgateways::v1::ListAppGatewaysResponse* response);
    // Gets details of a single AppGateway.
    virtual ::grpc::Status GetAppGateway(::grpc::ServerContext* context, const ::google::cloud::beyondcorp::appgateways::v1::GetAppGatewayRequest* request, ::google::cloud::beyondcorp::appgateways::v1::AppGateway* response);
    // Creates a new AppGateway in a given project and location.
    virtual ::grpc::Status CreateAppGateway(::grpc::ServerContext* context, const ::google::cloud::beyondcorp::appgateways::v1::CreateAppGatewayRequest* request, ::google::longrunning::Operation* response);
    // Deletes a single AppGateway.
    virtual ::grpc::Status DeleteAppGateway(::grpc::ServerContext* context, const ::google::cloud::beyondcorp::appgateways::v1::DeleteAppGatewayRequest* request, ::google::longrunning::Operation* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_ListAppGateways : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListAppGateways() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_ListAppGateways() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAppGateways(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appgateways::v1::ListAppGatewaysRequest* /*request*/, ::google::cloud::beyondcorp::appgateways::v1::ListAppGatewaysResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListAppGateways(::grpc::ServerContext* context, ::google::cloud::beyondcorp::appgateways::v1::ListAppGatewaysRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::beyondcorp::appgateways::v1::ListAppGatewaysResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetAppGateway : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetAppGateway() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_GetAppGateway() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAppGateway(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appgateways::v1::GetAppGatewayRequest* /*request*/, ::google::cloud::beyondcorp::appgateways::v1::AppGateway* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetAppGateway(::grpc::ServerContext* context, ::google::cloud::beyondcorp::appgateways::v1::GetAppGatewayRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::beyondcorp::appgateways::v1::AppGateway>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateAppGateway : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateAppGateway() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_CreateAppGateway() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAppGateway(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appgateways::v1::CreateAppGatewayRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateAppGateway(::grpc::ServerContext* context, ::google::cloud::beyondcorp::appgateways::v1::CreateAppGatewayRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteAppGateway : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteAppGateway() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_DeleteAppGateway() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAppGateway(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appgateways::v1::DeleteAppGatewayRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteAppGateway(::grpc::ServerContext* context, ::google::cloud::beyondcorp::appgateways::v1::DeleteAppGatewayRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_ListAppGateways<WithAsyncMethod_GetAppGateway<WithAsyncMethod_CreateAppGateway<WithAsyncMethod_DeleteAppGateway<Service > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_ListAppGateways : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListAppGateways() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::beyondcorp::appgateways::v1::ListAppGatewaysRequest, ::google::cloud::beyondcorp::appgateways::v1::ListAppGatewaysResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::beyondcorp::appgateways::v1::ListAppGatewaysRequest* request, ::google::cloud::beyondcorp::appgateways::v1::ListAppGatewaysResponse* response) { return this->ListAppGateways(context, request, response); }));}
    void SetMessageAllocatorFor_ListAppGateways(
        ::grpc::MessageAllocator< ::google::cloud::beyondcorp::appgateways::v1::ListAppGatewaysRequest, ::google::cloud::beyondcorp::appgateways::v1::ListAppGatewaysResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::beyondcorp::appgateways::v1::ListAppGatewaysRequest, ::google::cloud::beyondcorp::appgateways::v1::ListAppGatewaysResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListAppGateways() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAppGateways(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appgateways::v1::ListAppGatewaysRequest* /*request*/, ::google::cloud::beyondcorp::appgateways::v1::ListAppGatewaysResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListAppGateways(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::beyondcorp::appgateways::v1::ListAppGatewaysRequest* /*request*/, ::google::cloud::beyondcorp::appgateways::v1::ListAppGatewaysResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetAppGateway : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetAppGateway() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::beyondcorp::appgateways::v1::GetAppGatewayRequest, ::google::cloud::beyondcorp::appgateways::v1::AppGateway>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::beyondcorp::appgateways::v1::GetAppGatewayRequest* request, ::google::cloud::beyondcorp::appgateways::v1::AppGateway* response) { return this->GetAppGateway(context, request, response); }));}
    void SetMessageAllocatorFor_GetAppGateway(
        ::grpc::MessageAllocator< ::google::cloud::beyondcorp::appgateways::v1::GetAppGatewayRequest, ::google::cloud::beyondcorp::appgateways::v1::AppGateway>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::beyondcorp::appgateways::v1::GetAppGatewayRequest, ::google::cloud::beyondcorp::appgateways::v1::AppGateway>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetAppGateway() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAppGateway(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appgateways::v1::GetAppGatewayRequest* /*request*/, ::google::cloud::beyondcorp::appgateways::v1::AppGateway* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetAppGateway(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::beyondcorp::appgateways::v1::GetAppGatewayRequest* /*request*/, ::google::cloud::beyondcorp::appgateways::v1::AppGateway* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateAppGateway : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateAppGateway() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::beyondcorp::appgateways::v1::CreateAppGatewayRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::beyondcorp::appgateways::v1::CreateAppGatewayRequest* request, ::google::longrunning::Operation* response) { return this->CreateAppGateway(context, request, response); }));}
    void SetMessageAllocatorFor_CreateAppGateway(
        ::grpc::MessageAllocator< ::google::cloud::beyondcorp::appgateways::v1::CreateAppGatewayRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::beyondcorp::appgateways::v1::CreateAppGatewayRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateAppGateway() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAppGateway(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appgateways::v1::CreateAppGatewayRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateAppGateway(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::beyondcorp::appgateways::v1::CreateAppGatewayRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteAppGateway : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteAppGateway() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::beyondcorp::appgateways::v1::DeleteAppGatewayRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::beyondcorp::appgateways::v1::DeleteAppGatewayRequest* request, ::google::longrunning::Operation* response) { return this->DeleteAppGateway(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteAppGateway(
        ::grpc::MessageAllocator< ::google::cloud::beyondcorp::appgateways::v1::DeleteAppGatewayRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::beyondcorp::appgateways::v1::DeleteAppGatewayRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteAppGateway() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAppGateway(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appgateways::v1::DeleteAppGatewayRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteAppGateway(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::beyondcorp::appgateways::v1::DeleteAppGatewayRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_ListAppGateways<WithCallbackMethod_GetAppGateway<WithCallbackMethod_CreateAppGateway<WithCallbackMethod_DeleteAppGateway<Service > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_ListAppGateways : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListAppGateways() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_ListAppGateways() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAppGateways(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appgateways::v1::ListAppGatewaysRequest* /*request*/, ::google::cloud::beyondcorp::appgateways::v1::ListAppGatewaysResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetAppGateway : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetAppGateway() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_GetAppGateway() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAppGateway(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appgateways::v1::GetAppGatewayRequest* /*request*/, ::google::cloud::beyondcorp::appgateways::v1::AppGateway* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateAppGateway : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateAppGateway() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_CreateAppGateway() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAppGateway(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appgateways::v1::CreateAppGatewayRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteAppGateway : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteAppGateway() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_DeleteAppGateway() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAppGateway(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appgateways::v1::DeleteAppGatewayRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListAppGateways : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListAppGateways() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_ListAppGateways() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAppGateways(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appgateways::v1::ListAppGatewaysRequest* /*request*/, ::google::cloud::beyondcorp::appgateways::v1::ListAppGatewaysResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListAppGateways(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetAppGateway : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetAppGateway() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_GetAppGateway() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAppGateway(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appgateways::v1::GetAppGatewayRequest* /*request*/, ::google::cloud::beyondcorp::appgateways::v1::AppGateway* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetAppGateway(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateAppGateway : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateAppGateway() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_CreateAppGateway() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAppGateway(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appgateways::v1::CreateAppGatewayRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateAppGateway(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteAppGateway : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteAppGateway() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_DeleteAppGateway() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAppGateway(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appgateways::v1::DeleteAppGatewayRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteAppGateway(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListAppGateways : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListAppGateways() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListAppGateways(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListAppGateways() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAppGateways(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appgateways::v1::ListAppGatewaysRequest* /*request*/, ::google::cloud::beyondcorp::appgateways::v1::ListAppGatewaysResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListAppGateways(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetAppGateway : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetAppGateway() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetAppGateway(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetAppGateway() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAppGateway(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appgateways::v1::GetAppGatewayRequest* /*request*/, ::google::cloud::beyondcorp::appgateways::v1::AppGateway* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetAppGateway(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateAppGateway : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateAppGateway() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateAppGateway(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateAppGateway() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAppGateway(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appgateways::v1::CreateAppGatewayRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateAppGateway(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteAppGateway : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteAppGateway() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteAppGateway(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteAppGateway() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAppGateway(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appgateways::v1::DeleteAppGatewayRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteAppGateway(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListAppGateways : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListAppGateways() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::beyondcorp::appgateways::v1::ListAppGatewaysRequest, ::google::cloud::beyondcorp::appgateways::v1::ListAppGatewaysResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::beyondcorp::appgateways::v1::ListAppGatewaysRequest, ::google::cloud::beyondcorp::appgateways::v1::ListAppGatewaysResponse>* streamer) {
                       return this->StreamedListAppGateways(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListAppGateways() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListAppGateways(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appgateways::v1::ListAppGatewaysRequest* /*request*/, ::google::cloud::beyondcorp::appgateways::v1::ListAppGatewaysResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListAppGateways(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::beyondcorp::appgateways::v1::ListAppGatewaysRequest,::google::cloud::beyondcorp::appgateways::v1::ListAppGatewaysResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetAppGateway : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetAppGateway() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::beyondcorp::appgateways::v1::GetAppGatewayRequest, ::google::cloud::beyondcorp::appgateways::v1::AppGateway>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::beyondcorp::appgateways::v1::GetAppGatewayRequest, ::google::cloud::beyondcorp::appgateways::v1::AppGateway>* streamer) {
                       return this->StreamedGetAppGateway(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetAppGateway() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetAppGateway(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appgateways::v1::GetAppGatewayRequest* /*request*/, ::google::cloud::beyondcorp::appgateways::v1::AppGateway* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetAppGateway(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::beyondcorp::appgateways::v1::GetAppGatewayRequest,::google::cloud::beyondcorp::appgateways::v1::AppGateway>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateAppGateway : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateAppGateway() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::beyondcorp::appgateways::v1::CreateAppGatewayRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::beyondcorp::appgateways::v1::CreateAppGatewayRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateAppGateway(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateAppGateway() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateAppGateway(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appgateways::v1::CreateAppGatewayRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateAppGateway(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::beyondcorp::appgateways::v1::CreateAppGatewayRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteAppGateway : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteAppGateway() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::beyondcorp::appgateways::v1::DeleteAppGatewayRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::beyondcorp::appgateways::v1::DeleteAppGatewayRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteAppGateway(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteAppGateway() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteAppGateway(::grpc::ServerContext* /*context*/, const ::google::cloud::beyondcorp::appgateways::v1::DeleteAppGatewayRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteAppGateway(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::beyondcorp::appgateways::v1::DeleteAppGatewayRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_ListAppGateways<WithStreamedUnaryMethod_GetAppGateway<WithStreamedUnaryMethod_CreateAppGateway<WithStreamedUnaryMethod_DeleteAppGateway<Service > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_ListAppGateways<WithStreamedUnaryMethod_GetAppGateway<WithStreamedUnaryMethod_CreateAppGateway<WithStreamedUnaryMethod_DeleteAppGateway<Service > > > > StreamedService;
};

}  // namespace v1
}  // namespace appgateways
}  // namespace beyondcorp
}  // namespace cloud
}  // namespace google


#include <grpcpp/ports_undef.inc>
#endif  // GRPC_google_2fcloud_2fbeyondcorp_2fappgateways_2fv1_2fapp_5fgateways_5fservice_2eproto__INCLUDED
