// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/contentwarehouse/v1/synonymset_service.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fcontentwarehouse_2fv1_2fsynonymset_5fservice_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fcontentwarehouse_2fv1_2fsynonymset_5fservice_2eproto__INCLUDED

#include "google/cloud/contentwarehouse/v1/synonymset_service.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>
#include <grpcpp/ports_def.inc>

namespace google {
namespace cloud {
namespace contentwarehouse {
namespace v1 {

// A Service that manage/custom customer specified SynonymSets.
class SynonymSetService final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.contentwarehouse.v1.SynonymSetService";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Creates a SynonymSet for a single context.
    // Throws an ALREADY_EXISTS exception if a synonymset already exists
    // for the context.
    virtual ::grpc::Status CreateSynonymSet(::grpc::ClientContext* context, const ::google::cloud::contentwarehouse::v1::CreateSynonymSetRequest& request, ::google::cloud::contentwarehouse::v1::SynonymSet* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::contentwarehouse::v1::SynonymSet>> AsyncCreateSynonymSet(::grpc::ClientContext* context, const ::google::cloud::contentwarehouse::v1::CreateSynonymSetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::contentwarehouse::v1::SynonymSet>>(AsyncCreateSynonymSetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::contentwarehouse::v1::SynonymSet>> PrepareAsyncCreateSynonymSet(::grpc::ClientContext* context, const ::google::cloud::contentwarehouse::v1::CreateSynonymSetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::contentwarehouse::v1::SynonymSet>>(PrepareAsyncCreateSynonymSetRaw(context, request, cq));
    }
    // Gets a SynonymSet for a particular context.
    // Throws a NOT_FOUND exception if the Synonymset
    // does not exist
    virtual ::grpc::Status GetSynonymSet(::grpc::ClientContext* context, const ::google::cloud::contentwarehouse::v1::GetSynonymSetRequest& request, ::google::cloud::contentwarehouse::v1::SynonymSet* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::contentwarehouse::v1::SynonymSet>> AsyncGetSynonymSet(::grpc::ClientContext* context, const ::google::cloud::contentwarehouse::v1::GetSynonymSetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::contentwarehouse::v1::SynonymSet>>(AsyncGetSynonymSetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::contentwarehouse::v1::SynonymSet>> PrepareAsyncGetSynonymSet(::grpc::ClientContext* context, const ::google::cloud::contentwarehouse::v1::GetSynonymSetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::contentwarehouse::v1::SynonymSet>>(PrepareAsyncGetSynonymSetRaw(context, request, cq));
    }
    // Remove the existing SynonymSet for the context and replaces it
    // with a new one.
    // Throws a NOT_FOUND exception if the SynonymSet is not found.
    virtual ::grpc::Status UpdateSynonymSet(::grpc::ClientContext* context, const ::google::cloud::contentwarehouse::v1::UpdateSynonymSetRequest& request, ::google::cloud::contentwarehouse::v1::SynonymSet* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::contentwarehouse::v1::SynonymSet>> AsyncUpdateSynonymSet(::grpc::ClientContext* context, const ::google::cloud::contentwarehouse::v1::UpdateSynonymSetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::contentwarehouse::v1::SynonymSet>>(AsyncUpdateSynonymSetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::contentwarehouse::v1::SynonymSet>> PrepareAsyncUpdateSynonymSet(::grpc::ClientContext* context, const ::google::cloud::contentwarehouse::v1::UpdateSynonymSetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::contentwarehouse::v1::SynonymSet>>(PrepareAsyncUpdateSynonymSetRaw(context, request, cq));
    }
    // Deletes a SynonymSet for a given context.
    // Throws a NOT_FOUND exception if the SynonymSet is not found.
    virtual ::grpc::Status DeleteSynonymSet(::grpc::ClientContext* context, const ::google::cloud::contentwarehouse::v1::DeleteSynonymSetRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncDeleteSynonymSet(::grpc::ClientContext* context, const ::google::cloud::contentwarehouse::v1::DeleteSynonymSetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncDeleteSynonymSetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncDeleteSynonymSet(::grpc::ClientContext* context, const ::google::cloud::contentwarehouse::v1::DeleteSynonymSetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncDeleteSynonymSetRaw(context, request, cq));
    }
    // Returns all SynonymSets (for all contexts) for the specified location.
    virtual ::grpc::Status ListSynonymSets(::grpc::ClientContext* context, const ::google::cloud::contentwarehouse::v1::ListSynonymSetsRequest& request, ::google::cloud::contentwarehouse::v1::ListSynonymSetsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::contentwarehouse::v1::ListSynonymSetsResponse>> AsyncListSynonymSets(::grpc::ClientContext* context, const ::google::cloud::contentwarehouse::v1::ListSynonymSetsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::contentwarehouse::v1::ListSynonymSetsResponse>>(AsyncListSynonymSetsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::contentwarehouse::v1::ListSynonymSetsResponse>> PrepareAsyncListSynonymSets(::grpc::ClientContext* context, const ::google::cloud::contentwarehouse::v1::ListSynonymSetsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::contentwarehouse::v1::ListSynonymSetsResponse>>(PrepareAsyncListSynonymSetsRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Creates a SynonymSet for a single context.
      // Throws an ALREADY_EXISTS exception if a synonymset already exists
      // for the context.
      virtual void CreateSynonymSet(::grpc::ClientContext* context, const ::google::cloud::contentwarehouse::v1::CreateSynonymSetRequest* request, ::google::cloud::contentwarehouse::v1::SynonymSet* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateSynonymSet(::grpc::ClientContext* context, const ::google::cloud::contentwarehouse::v1::CreateSynonymSetRequest* request, ::google::cloud::contentwarehouse::v1::SynonymSet* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets a SynonymSet for a particular context.
      // Throws a NOT_FOUND exception if the Synonymset
      // does not exist
      virtual void GetSynonymSet(::grpc::ClientContext* context, const ::google::cloud::contentwarehouse::v1::GetSynonymSetRequest* request, ::google::cloud::contentwarehouse::v1::SynonymSet* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetSynonymSet(::grpc::ClientContext* context, const ::google::cloud::contentwarehouse::v1::GetSynonymSetRequest* request, ::google::cloud::contentwarehouse::v1::SynonymSet* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Remove the existing SynonymSet for the context and replaces it
      // with a new one.
      // Throws a NOT_FOUND exception if the SynonymSet is not found.
      virtual void UpdateSynonymSet(::grpc::ClientContext* context, const ::google::cloud::contentwarehouse::v1::UpdateSynonymSetRequest* request, ::google::cloud::contentwarehouse::v1::SynonymSet* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateSynonymSet(::grpc::ClientContext* context, const ::google::cloud::contentwarehouse::v1::UpdateSynonymSetRequest* request, ::google::cloud::contentwarehouse::v1::SynonymSet* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a SynonymSet for a given context.
      // Throws a NOT_FOUND exception if the SynonymSet is not found.
      virtual void DeleteSynonymSet(::grpc::ClientContext* context, const ::google::cloud::contentwarehouse::v1::DeleteSynonymSetRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteSynonymSet(::grpc::ClientContext* context, const ::google::cloud::contentwarehouse::v1::DeleteSynonymSetRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Returns all SynonymSets (for all contexts) for the specified location.
      virtual void ListSynonymSets(::grpc::ClientContext* context, const ::google::cloud::contentwarehouse::v1::ListSynonymSetsRequest* request, ::google::cloud::contentwarehouse::v1::ListSynonymSetsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListSynonymSets(::grpc::ClientContext* context, const ::google::cloud::contentwarehouse::v1::ListSynonymSetsRequest* request, ::google::cloud::contentwarehouse::v1::ListSynonymSetsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::contentwarehouse::v1::SynonymSet>* AsyncCreateSynonymSetRaw(::grpc::ClientContext* context, const ::google::cloud::contentwarehouse::v1::CreateSynonymSetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::contentwarehouse::v1::SynonymSet>* PrepareAsyncCreateSynonymSetRaw(::grpc::ClientContext* context, const ::google::cloud::contentwarehouse::v1::CreateSynonymSetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::contentwarehouse::v1::SynonymSet>* AsyncGetSynonymSetRaw(::grpc::ClientContext* context, const ::google::cloud::contentwarehouse::v1::GetSynonymSetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::contentwarehouse::v1::SynonymSet>* PrepareAsyncGetSynonymSetRaw(::grpc::ClientContext* context, const ::google::cloud::contentwarehouse::v1::GetSynonymSetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::contentwarehouse::v1::SynonymSet>* AsyncUpdateSynonymSetRaw(::grpc::ClientContext* context, const ::google::cloud::contentwarehouse::v1::UpdateSynonymSetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::contentwarehouse::v1::SynonymSet>* PrepareAsyncUpdateSynonymSetRaw(::grpc::ClientContext* context, const ::google::cloud::contentwarehouse::v1::UpdateSynonymSetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncDeleteSynonymSetRaw(::grpc::ClientContext* context, const ::google::cloud::contentwarehouse::v1::DeleteSynonymSetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncDeleteSynonymSetRaw(::grpc::ClientContext* context, const ::google::cloud::contentwarehouse::v1::DeleteSynonymSetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::contentwarehouse::v1::ListSynonymSetsResponse>* AsyncListSynonymSetsRaw(::grpc::ClientContext* context, const ::google::cloud::contentwarehouse::v1::ListSynonymSetsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::contentwarehouse::v1::ListSynonymSetsResponse>* PrepareAsyncListSynonymSetsRaw(::grpc::ClientContext* context, const ::google::cloud::contentwarehouse::v1::ListSynonymSetsRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status CreateSynonymSet(::grpc::ClientContext* context, const ::google::cloud::contentwarehouse::v1::CreateSynonymSetRequest& request, ::google::cloud::contentwarehouse::v1::SynonymSet* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::contentwarehouse::v1::SynonymSet>> AsyncCreateSynonymSet(::grpc::ClientContext* context, const ::google::cloud::contentwarehouse::v1::CreateSynonymSetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::contentwarehouse::v1::SynonymSet>>(AsyncCreateSynonymSetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::contentwarehouse::v1::SynonymSet>> PrepareAsyncCreateSynonymSet(::grpc::ClientContext* context, const ::google::cloud::contentwarehouse::v1::CreateSynonymSetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::contentwarehouse::v1::SynonymSet>>(PrepareAsyncCreateSynonymSetRaw(context, request, cq));
    }
    ::grpc::Status GetSynonymSet(::grpc::ClientContext* context, const ::google::cloud::contentwarehouse::v1::GetSynonymSetRequest& request, ::google::cloud::contentwarehouse::v1::SynonymSet* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::contentwarehouse::v1::SynonymSet>> AsyncGetSynonymSet(::grpc::ClientContext* context, const ::google::cloud::contentwarehouse::v1::GetSynonymSetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::contentwarehouse::v1::SynonymSet>>(AsyncGetSynonymSetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::contentwarehouse::v1::SynonymSet>> PrepareAsyncGetSynonymSet(::grpc::ClientContext* context, const ::google::cloud::contentwarehouse::v1::GetSynonymSetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::contentwarehouse::v1::SynonymSet>>(PrepareAsyncGetSynonymSetRaw(context, request, cq));
    }
    ::grpc::Status UpdateSynonymSet(::grpc::ClientContext* context, const ::google::cloud::contentwarehouse::v1::UpdateSynonymSetRequest& request, ::google::cloud::contentwarehouse::v1::SynonymSet* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::contentwarehouse::v1::SynonymSet>> AsyncUpdateSynonymSet(::grpc::ClientContext* context, const ::google::cloud::contentwarehouse::v1::UpdateSynonymSetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::contentwarehouse::v1::SynonymSet>>(AsyncUpdateSynonymSetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::contentwarehouse::v1::SynonymSet>> PrepareAsyncUpdateSynonymSet(::grpc::ClientContext* context, const ::google::cloud::contentwarehouse::v1::UpdateSynonymSetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::contentwarehouse::v1::SynonymSet>>(PrepareAsyncUpdateSynonymSetRaw(context, request, cq));
    }
    ::grpc::Status DeleteSynonymSet(::grpc::ClientContext* context, const ::google::cloud::contentwarehouse::v1::DeleteSynonymSetRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncDeleteSynonymSet(::grpc::ClientContext* context, const ::google::cloud::contentwarehouse::v1::DeleteSynonymSetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncDeleteSynonymSetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncDeleteSynonymSet(::grpc::ClientContext* context, const ::google::cloud::contentwarehouse::v1::DeleteSynonymSetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncDeleteSynonymSetRaw(context, request, cq));
    }
    ::grpc::Status ListSynonymSets(::grpc::ClientContext* context, const ::google::cloud::contentwarehouse::v1::ListSynonymSetsRequest& request, ::google::cloud::contentwarehouse::v1::ListSynonymSetsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::contentwarehouse::v1::ListSynonymSetsResponse>> AsyncListSynonymSets(::grpc::ClientContext* context, const ::google::cloud::contentwarehouse::v1::ListSynonymSetsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::contentwarehouse::v1::ListSynonymSetsResponse>>(AsyncListSynonymSetsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::contentwarehouse::v1::ListSynonymSetsResponse>> PrepareAsyncListSynonymSets(::grpc::ClientContext* context, const ::google::cloud::contentwarehouse::v1::ListSynonymSetsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::contentwarehouse::v1::ListSynonymSetsResponse>>(PrepareAsyncListSynonymSetsRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void CreateSynonymSet(::grpc::ClientContext* context, const ::google::cloud::contentwarehouse::v1::CreateSynonymSetRequest* request, ::google::cloud::contentwarehouse::v1::SynonymSet* response, std::function<void(::grpc::Status)>) override;
      void CreateSynonymSet(::grpc::ClientContext* context, const ::google::cloud::contentwarehouse::v1::CreateSynonymSetRequest* request, ::google::cloud::contentwarehouse::v1::SynonymSet* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetSynonymSet(::grpc::ClientContext* context, const ::google::cloud::contentwarehouse::v1::GetSynonymSetRequest* request, ::google::cloud::contentwarehouse::v1::SynonymSet* response, std::function<void(::grpc::Status)>) override;
      void GetSynonymSet(::grpc::ClientContext* context, const ::google::cloud::contentwarehouse::v1::GetSynonymSetRequest* request, ::google::cloud::contentwarehouse::v1::SynonymSet* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateSynonymSet(::grpc::ClientContext* context, const ::google::cloud::contentwarehouse::v1::UpdateSynonymSetRequest* request, ::google::cloud::contentwarehouse::v1::SynonymSet* response, std::function<void(::grpc::Status)>) override;
      void UpdateSynonymSet(::grpc::ClientContext* context, const ::google::cloud::contentwarehouse::v1::UpdateSynonymSetRequest* request, ::google::cloud::contentwarehouse::v1::SynonymSet* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteSynonymSet(::grpc::ClientContext* context, const ::google::cloud::contentwarehouse::v1::DeleteSynonymSetRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void DeleteSynonymSet(::grpc::ClientContext* context, const ::google::cloud::contentwarehouse::v1::DeleteSynonymSetRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListSynonymSets(::grpc::ClientContext* context, const ::google::cloud::contentwarehouse::v1::ListSynonymSetsRequest* request, ::google::cloud::contentwarehouse::v1::ListSynonymSetsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListSynonymSets(::grpc::ClientContext* context, const ::google::cloud::contentwarehouse::v1::ListSynonymSetsRequest* request, ::google::cloud::contentwarehouse::v1::ListSynonymSetsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::contentwarehouse::v1::SynonymSet>* AsyncCreateSynonymSetRaw(::grpc::ClientContext* context, const ::google::cloud::contentwarehouse::v1::CreateSynonymSetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::contentwarehouse::v1::SynonymSet>* PrepareAsyncCreateSynonymSetRaw(::grpc::ClientContext* context, const ::google::cloud::contentwarehouse::v1::CreateSynonymSetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::contentwarehouse::v1::SynonymSet>* AsyncGetSynonymSetRaw(::grpc::ClientContext* context, const ::google::cloud::contentwarehouse::v1::GetSynonymSetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::contentwarehouse::v1::SynonymSet>* PrepareAsyncGetSynonymSetRaw(::grpc::ClientContext* context, const ::google::cloud::contentwarehouse::v1::GetSynonymSetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::contentwarehouse::v1::SynonymSet>* AsyncUpdateSynonymSetRaw(::grpc::ClientContext* context, const ::google::cloud::contentwarehouse::v1::UpdateSynonymSetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::contentwarehouse::v1::SynonymSet>* PrepareAsyncUpdateSynonymSetRaw(::grpc::ClientContext* context, const ::google::cloud::contentwarehouse::v1::UpdateSynonymSetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncDeleteSynonymSetRaw(::grpc::ClientContext* context, const ::google::cloud::contentwarehouse::v1::DeleteSynonymSetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncDeleteSynonymSetRaw(::grpc::ClientContext* context, const ::google::cloud::contentwarehouse::v1::DeleteSynonymSetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::contentwarehouse::v1::ListSynonymSetsResponse>* AsyncListSynonymSetsRaw(::grpc::ClientContext* context, const ::google::cloud::contentwarehouse::v1::ListSynonymSetsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::contentwarehouse::v1::ListSynonymSetsResponse>* PrepareAsyncListSynonymSetsRaw(::grpc::ClientContext* context, const ::google::cloud::contentwarehouse::v1::ListSynonymSetsRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_CreateSynonymSet_;
    const ::grpc::internal::RpcMethod rpcmethod_GetSynonymSet_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateSynonymSet_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteSynonymSet_;
    const ::grpc::internal::RpcMethod rpcmethod_ListSynonymSets_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Creates a SynonymSet for a single context.
    // Throws an ALREADY_EXISTS exception if a synonymset already exists
    // for the context.
    virtual ::grpc::Status CreateSynonymSet(::grpc::ServerContext* context, const ::google::cloud::contentwarehouse::v1::CreateSynonymSetRequest* request, ::google::cloud::contentwarehouse::v1::SynonymSet* response);
    // Gets a SynonymSet for a particular context.
    // Throws a NOT_FOUND exception if the Synonymset
    // does not exist
    virtual ::grpc::Status GetSynonymSet(::grpc::ServerContext* context, const ::google::cloud::contentwarehouse::v1::GetSynonymSetRequest* request, ::google::cloud::contentwarehouse::v1::SynonymSet* response);
    // Remove the existing SynonymSet for the context and replaces it
    // with a new one.
    // Throws a NOT_FOUND exception if the SynonymSet is not found.
    virtual ::grpc::Status UpdateSynonymSet(::grpc::ServerContext* context, const ::google::cloud::contentwarehouse::v1::UpdateSynonymSetRequest* request, ::google::cloud::contentwarehouse::v1::SynonymSet* response);
    // Deletes a SynonymSet for a given context.
    // Throws a NOT_FOUND exception if the SynonymSet is not found.
    virtual ::grpc::Status DeleteSynonymSet(::grpc::ServerContext* context, const ::google::cloud::contentwarehouse::v1::DeleteSynonymSetRequest* request, ::google::protobuf::Empty* response);
    // Returns all SynonymSets (for all contexts) for the specified location.
    virtual ::grpc::Status ListSynonymSets(::grpc::ServerContext* context, const ::google::cloud::contentwarehouse::v1::ListSynonymSetsRequest* request, ::google::cloud::contentwarehouse::v1::ListSynonymSetsResponse* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateSynonymSet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateSynonymSet() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_CreateSynonymSet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateSynonymSet(::grpc::ServerContext* /*context*/, const ::google::cloud::contentwarehouse::v1::CreateSynonymSetRequest* /*request*/, ::google::cloud::contentwarehouse::v1::SynonymSet* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateSynonymSet(::grpc::ServerContext* context, ::google::cloud::contentwarehouse::v1::CreateSynonymSetRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::contentwarehouse::v1::SynonymSet>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetSynonymSet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetSynonymSet() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_GetSynonymSet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSynonymSet(::grpc::ServerContext* /*context*/, const ::google::cloud::contentwarehouse::v1::GetSynonymSetRequest* /*request*/, ::google::cloud::contentwarehouse::v1::SynonymSet* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetSynonymSet(::grpc::ServerContext* context, ::google::cloud::contentwarehouse::v1::GetSynonymSetRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::contentwarehouse::v1::SynonymSet>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateSynonymSet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateSynonymSet() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_UpdateSynonymSet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateSynonymSet(::grpc::ServerContext* /*context*/, const ::google::cloud::contentwarehouse::v1::UpdateSynonymSetRequest* /*request*/, ::google::cloud::contentwarehouse::v1::SynonymSet* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateSynonymSet(::grpc::ServerContext* context, ::google::cloud::contentwarehouse::v1::UpdateSynonymSetRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::contentwarehouse::v1::SynonymSet>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteSynonymSet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteSynonymSet() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_DeleteSynonymSet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteSynonymSet(::grpc::ServerContext* /*context*/, const ::google::cloud::contentwarehouse::v1::DeleteSynonymSetRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteSynonymSet(::grpc::ServerContext* context, ::google::cloud::contentwarehouse::v1::DeleteSynonymSetRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListSynonymSets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListSynonymSets() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_ListSynonymSets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSynonymSets(::grpc::ServerContext* /*context*/, const ::google::cloud::contentwarehouse::v1::ListSynonymSetsRequest* /*request*/, ::google::cloud::contentwarehouse::v1::ListSynonymSetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListSynonymSets(::grpc::ServerContext* context, ::google::cloud::contentwarehouse::v1::ListSynonymSetsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::contentwarehouse::v1::ListSynonymSetsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_CreateSynonymSet<WithAsyncMethod_GetSynonymSet<WithAsyncMethod_UpdateSynonymSet<WithAsyncMethod_DeleteSynonymSet<WithAsyncMethod_ListSynonymSets<Service > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_CreateSynonymSet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateSynonymSet() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::contentwarehouse::v1::CreateSynonymSetRequest, ::google::cloud::contentwarehouse::v1::SynonymSet>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::contentwarehouse::v1::CreateSynonymSetRequest* request, ::google::cloud::contentwarehouse::v1::SynonymSet* response) { return this->CreateSynonymSet(context, request, response); }));}
    void SetMessageAllocatorFor_CreateSynonymSet(
        ::grpc::MessageAllocator< ::google::cloud::contentwarehouse::v1::CreateSynonymSetRequest, ::google::cloud::contentwarehouse::v1::SynonymSet>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::contentwarehouse::v1::CreateSynonymSetRequest, ::google::cloud::contentwarehouse::v1::SynonymSet>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateSynonymSet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateSynonymSet(::grpc::ServerContext* /*context*/, const ::google::cloud::contentwarehouse::v1::CreateSynonymSetRequest* /*request*/, ::google::cloud::contentwarehouse::v1::SynonymSet* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateSynonymSet(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::contentwarehouse::v1::CreateSynonymSetRequest* /*request*/, ::google::cloud::contentwarehouse::v1::SynonymSet* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetSynonymSet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetSynonymSet() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::contentwarehouse::v1::GetSynonymSetRequest, ::google::cloud::contentwarehouse::v1::SynonymSet>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::contentwarehouse::v1::GetSynonymSetRequest* request, ::google::cloud::contentwarehouse::v1::SynonymSet* response) { return this->GetSynonymSet(context, request, response); }));}
    void SetMessageAllocatorFor_GetSynonymSet(
        ::grpc::MessageAllocator< ::google::cloud::contentwarehouse::v1::GetSynonymSetRequest, ::google::cloud::contentwarehouse::v1::SynonymSet>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::contentwarehouse::v1::GetSynonymSetRequest, ::google::cloud::contentwarehouse::v1::SynonymSet>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetSynonymSet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSynonymSet(::grpc::ServerContext* /*context*/, const ::google::cloud::contentwarehouse::v1::GetSynonymSetRequest* /*request*/, ::google::cloud::contentwarehouse::v1::SynonymSet* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetSynonymSet(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::contentwarehouse::v1::GetSynonymSetRequest* /*request*/, ::google::cloud::contentwarehouse::v1::SynonymSet* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateSynonymSet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateSynonymSet() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::contentwarehouse::v1::UpdateSynonymSetRequest, ::google::cloud::contentwarehouse::v1::SynonymSet>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::contentwarehouse::v1::UpdateSynonymSetRequest* request, ::google::cloud::contentwarehouse::v1::SynonymSet* response) { return this->UpdateSynonymSet(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateSynonymSet(
        ::grpc::MessageAllocator< ::google::cloud::contentwarehouse::v1::UpdateSynonymSetRequest, ::google::cloud::contentwarehouse::v1::SynonymSet>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::contentwarehouse::v1::UpdateSynonymSetRequest, ::google::cloud::contentwarehouse::v1::SynonymSet>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateSynonymSet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateSynonymSet(::grpc::ServerContext* /*context*/, const ::google::cloud::contentwarehouse::v1::UpdateSynonymSetRequest* /*request*/, ::google::cloud::contentwarehouse::v1::SynonymSet* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateSynonymSet(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::contentwarehouse::v1::UpdateSynonymSetRequest* /*request*/, ::google::cloud::contentwarehouse::v1::SynonymSet* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteSynonymSet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteSynonymSet() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::contentwarehouse::v1::DeleteSynonymSetRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::contentwarehouse::v1::DeleteSynonymSetRequest* request, ::google::protobuf::Empty* response) { return this->DeleteSynonymSet(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteSynonymSet(
        ::grpc::MessageAllocator< ::google::cloud::contentwarehouse::v1::DeleteSynonymSetRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::contentwarehouse::v1::DeleteSynonymSetRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteSynonymSet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteSynonymSet(::grpc::ServerContext* /*context*/, const ::google::cloud::contentwarehouse::v1::DeleteSynonymSetRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteSynonymSet(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::contentwarehouse::v1::DeleteSynonymSetRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListSynonymSets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListSynonymSets() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::contentwarehouse::v1::ListSynonymSetsRequest, ::google::cloud::contentwarehouse::v1::ListSynonymSetsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::contentwarehouse::v1::ListSynonymSetsRequest* request, ::google::cloud::contentwarehouse::v1::ListSynonymSetsResponse* response) { return this->ListSynonymSets(context, request, response); }));}
    void SetMessageAllocatorFor_ListSynonymSets(
        ::grpc::MessageAllocator< ::google::cloud::contentwarehouse::v1::ListSynonymSetsRequest, ::google::cloud::contentwarehouse::v1::ListSynonymSetsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::contentwarehouse::v1::ListSynonymSetsRequest, ::google::cloud::contentwarehouse::v1::ListSynonymSetsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListSynonymSets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSynonymSets(::grpc::ServerContext* /*context*/, const ::google::cloud::contentwarehouse::v1::ListSynonymSetsRequest* /*request*/, ::google::cloud::contentwarehouse::v1::ListSynonymSetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListSynonymSets(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::contentwarehouse::v1::ListSynonymSetsRequest* /*request*/, ::google::cloud::contentwarehouse::v1::ListSynonymSetsResponse* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_CreateSynonymSet<WithCallbackMethod_GetSynonymSet<WithCallbackMethod_UpdateSynonymSet<WithCallbackMethod_DeleteSynonymSet<WithCallbackMethod_ListSynonymSets<Service > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_CreateSynonymSet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateSynonymSet() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_CreateSynonymSet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateSynonymSet(::grpc::ServerContext* /*context*/, const ::google::cloud::contentwarehouse::v1::CreateSynonymSetRequest* /*request*/, ::google::cloud::contentwarehouse::v1::SynonymSet* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetSynonymSet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetSynonymSet() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_GetSynonymSet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSynonymSet(::grpc::ServerContext* /*context*/, const ::google::cloud::contentwarehouse::v1::GetSynonymSetRequest* /*request*/, ::google::cloud::contentwarehouse::v1::SynonymSet* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateSynonymSet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateSynonymSet() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_UpdateSynonymSet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateSynonymSet(::grpc::ServerContext* /*context*/, const ::google::cloud::contentwarehouse::v1::UpdateSynonymSetRequest* /*request*/, ::google::cloud::contentwarehouse::v1::SynonymSet* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteSynonymSet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteSynonymSet() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_DeleteSynonymSet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteSynonymSet(::grpc::ServerContext* /*context*/, const ::google::cloud::contentwarehouse::v1::DeleteSynonymSetRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListSynonymSets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListSynonymSets() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_ListSynonymSets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSynonymSets(::grpc::ServerContext* /*context*/, const ::google::cloud::contentwarehouse::v1::ListSynonymSetsRequest* /*request*/, ::google::cloud::contentwarehouse::v1::ListSynonymSetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateSynonymSet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateSynonymSet() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_CreateSynonymSet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateSynonymSet(::grpc::ServerContext* /*context*/, const ::google::cloud::contentwarehouse::v1::CreateSynonymSetRequest* /*request*/, ::google::cloud::contentwarehouse::v1::SynonymSet* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateSynonymSet(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetSynonymSet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetSynonymSet() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_GetSynonymSet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSynonymSet(::grpc::ServerContext* /*context*/, const ::google::cloud::contentwarehouse::v1::GetSynonymSetRequest* /*request*/, ::google::cloud::contentwarehouse::v1::SynonymSet* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetSynonymSet(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateSynonymSet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateSynonymSet() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_UpdateSynonymSet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateSynonymSet(::grpc::ServerContext* /*context*/, const ::google::cloud::contentwarehouse::v1::UpdateSynonymSetRequest* /*request*/, ::google::cloud::contentwarehouse::v1::SynonymSet* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateSynonymSet(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteSynonymSet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteSynonymSet() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_DeleteSynonymSet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteSynonymSet(::grpc::ServerContext* /*context*/, const ::google::cloud::contentwarehouse::v1::DeleteSynonymSetRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteSynonymSet(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListSynonymSets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListSynonymSets() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_ListSynonymSets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSynonymSets(::grpc::ServerContext* /*context*/, const ::google::cloud::contentwarehouse::v1::ListSynonymSetsRequest* /*request*/, ::google::cloud::contentwarehouse::v1::ListSynonymSetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListSynonymSets(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateSynonymSet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateSynonymSet() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateSynonymSet(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateSynonymSet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateSynonymSet(::grpc::ServerContext* /*context*/, const ::google::cloud::contentwarehouse::v1::CreateSynonymSetRequest* /*request*/, ::google::cloud::contentwarehouse::v1::SynonymSet* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateSynonymSet(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetSynonymSet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetSynonymSet() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetSynonymSet(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetSynonymSet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSynonymSet(::grpc::ServerContext* /*context*/, const ::google::cloud::contentwarehouse::v1::GetSynonymSetRequest* /*request*/, ::google::cloud::contentwarehouse::v1::SynonymSet* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetSynonymSet(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateSynonymSet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateSynonymSet() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateSynonymSet(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateSynonymSet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateSynonymSet(::grpc::ServerContext* /*context*/, const ::google::cloud::contentwarehouse::v1::UpdateSynonymSetRequest* /*request*/, ::google::cloud::contentwarehouse::v1::SynonymSet* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateSynonymSet(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteSynonymSet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteSynonymSet() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteSynonymSet(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteSynonymSet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteSynonymSet(::grpc::ServerContext* /*context*/, const ::google::cloud::contentwarehouse::v1::DeleteSynonymSetRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteSynonymSet(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListSynonymSets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListSynonymSets() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListSynonymSets(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListSynonymSets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListSynonymSets(::grpc::ServerContext* /*context*/, const ::google::cloud::contentwarehouse::v1::ListSynonymSetsRequest* /*request*/, ::google::cloud::contentwarehouse::v1::ListSynonymSetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListSynonymSets(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateSynonymSet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateSynonymSet() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::contentwarehouse::v1::CreateSynonymSetRequest, ::google::cloud::contentwarehouse::v1::SynonymSet>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::contentwarehouse::v1::CreateSynonymSetRequest, ::google::cloud::contentwarehouse::v1::SynonymSet>* streamer) {
                       return this->StreamedCreateSynonymSet(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateSynonymSet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateSynonymSet(::grpc::ServerContext* /*context*/, const ::google::cloud::contentwarehouse::v1::CreateSynonymSetRequest* /*request*/, ::google::cloud::contentwarehouse::v1::SynonymSet* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateSynonymSet(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::contentwarehouse::v1::CreateSynonymSetRequest,::google::cloud::contentwarehouse::v1::SynonymSet>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetSynonymSet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetSynonymSet() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::contentwarehouse::v1::GetSynonymSetRequest, ::google::cloud::contentwarehouse::v1::SynonymSet>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::contentwarehouse::v1::GetSynonymSetRequest, ::google::cloud::contentwarehouse::v1::SynonymSet>* streamer) {
                       return this->StreamedGetSynonymSet(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetSynonymSet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetSynonymSet(::grpc::ServerContext* /*context*/, const ::google::cloud::contentwarehouse::v1::GetSynonymSetRequest* /*request*/, ::google::cloud::contentwarehouse::v1::SynonymSet* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetSynonymSet(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::contentwarehouse::v1::GetSynonymSetRequest,::google::cloud::contentwarehouse::v1::SynonymSet>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateSynonymSet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateSynonymSet() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::contentwarehouse::v1::UpdateSynonymSetRequest, ::google::cloud::contentwarehouse::v1::SynonymSet>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::contentwarehouse::v1::UpdateSynonymSetRequest, ::google::cloud::contentwarehouse::v1::SynonymSet>* streamer) {
                       return this->StreamedUpdateSynonymSet(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateSynonymSet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateSynonymSet(::grpc::ServerContext* /*context*/, const ::google::cloud::contentwarehouse::v1::UpdateSynonymSetRequest* /*request*/, ::google::cloud::contentwarehouse::v1::SynonymSet* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateSynonymSet(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::contentwarehouse::v1::UpdateSynonymSetRequest,::google::cloud::contentwarehouse::v1::SynonymSet>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteSynonymSet : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteSynonymSet() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::contentwarehouse::v1::DeleteSynonymSetRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::contentwarehouse::v1::DeleteSynonymSetRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedDeleteSynonymSet(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteSynonymSet() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteSynonymSet(::grpc::ServerContext* /*context*/, const ::google::cloud::contentwarehouse::v1::DeleteSynonymSetRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteSynonymSet(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::contentwarehouse::v1::DeleteSynonymSetRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListSynonymSets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListSynonymSets() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::contentwarehouse::v1::ListSynonymSetsRequest, ::google::cloud::contentwarehouse::v1::ListSynonymSetsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::contentwarehouse::v1::ListSynonymSetsRequest, ::google::cloud::contentwarehouse::v1::ListSynonymSetsResponse>* streamer) {
                       return this->StreamedListSynonymSets(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListSynonymSets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListSynonymSets(::grpc::ServerContext* /*context*/, const ::google::cloud::contentwarehouse::v1::ListSynonymSetsRequest* /*request*/, ::google::cloud::contentwarehouse::v1::ListSynonymSetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListSynonymSets(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::contentwarehouse::v1::ListSynonymSetsRequest,::google::cloud::contentwarehouse::v1::ListSynonymSetsResponse>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_CreateSynonymSet<WithStreamedUnaryMethod_GetSynonymSet<WithStreamedUnaryMethod_UpdateSynonymSet<WithStreamedUnaryMethod_DeleteSynonymSet<WithStreamedUnaryMethod_ListSynonymSets<Service > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_CreateSynonymSet<WithStreamedUnaryMethod_GetSynonymSet<WithStreamedUnaryMethod_UpdateSynonymSet<WithStreamedUnaryMethod_DeleteSynonymSet<WithStreamedUnaryMethod_ListSynonymSets<Service > > > > > StreamedService;
};

}  // namespace v1
}  // namespace contentwarehouse
}  // namespace cloud
}  // namespace google


#include <grpcpp/ports_undef.inc>
#endif  // GRPC_google_2fcloud_2fcontentwarehouse_2fv1_2fsynonymset_5fservice_2eproto__INCLUDED
