// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/kms/v1/ekm_service.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_KMS_V1_EKM_CONNECTION_IDEMPOTENCY_POLICY_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_KMS_V1_EKM_CONNECTION_IDEMPOTENCY_POLICY_H

#include "google/cloud/idempotency.h"
#include "google/cloud/version.h"
#include <google/cloud/kms/v1/ekm_service.grpc.pb.h>
#include <google/cloud/location/locations.grpc.pb.h>
#include <google/iam/v1/iam_policy.grpc.pb.h>
#include <google/longrunning/operations.grpc.pb.h>
#include <memory>

namespace google {
namespace cloud {
namespace kms_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

class EkmServiceConnectionIdempotencyPolicy {
 public:
  virtual ~EkmServiceConnectionIdempotencyPolicy();

  /// Create a new copy of this object.
  virtual std::unique_ptr<EkmServiceConnectionIdempotencyPolicy> clone() const;

  virtual google::cloud::Idempotency ListEkmConnections(
      google::cloud::kms::v1::ListEkmConnectionsRequest request);

  virtual google::cloud::Idempotency GetEkmConnection(
      google::cloud::kms::v1::GetEkmConnectionRequest const& request);

  virtual google::cloud::Idempotency CreateEkmConnection(
      google::cloud::kms::v1::CreateEkmConnectionRequest const& request);

  virtual google::cloud::Idempotency UpdateEkmConnection(
      google::cloud::kms::v1::UpdateEkmConnectionRequest const& request);

  virtual google::cloud::Idempotency GetEkmConfig(
      google::cloud::kms::v1::GetEkmConfigRequest const& request);

  virtual google::cloud::Idempotency UpdateEkmConfig(
      google::cloud::kms::v1::UpdateEkmConfigRequest const& request);

  virtual google::cloud::Idempotency VerifyConnectivity(
      google::cloud::kms::v1::VerifyConnectivityRequest const& request);

  virtual google::cloud::Idempotency ListLocations(
      google::cloud::location::ListLocationsRequest request);

  virtual google::cloud::Idempotency GetLocation(
      google::cloud::location::GetLocationRequest const& request);

  virtual google::cloud::Idempotency SetIamPolicy(
      google::iam::v1::SetIamPolicyRequest const& request);

  virtual google::cloud::Idempotency GetIamPolicy(
      google::iam::v1::GetIamPolicyRequest const& request);

  virtual google::cloud::Idempotency TestIamPermissions(
      google::iam::v1::TestIamPermissionsRequest const& request);

  virtual google::cloud::Idempotency GetOperation(
      google::longrunning::GetOperationRequest const& request);
};

std::unique_ptr<EkmServiceConnectionIdempotencyPolicy>
MakeDefaultEkmServiceConnectionIdempotencyPolicy();

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace kms_v1
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_KMS_V1_EKM_CONNECTION_IDEMPOTENCY_POLICY_H
