// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/osconfig/v1/osconfig_service.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_OSCONFIG_V1_MOCKS_MOCK_OS_CONFIG_CONNECTION_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_OSCONFIG_V1_MOCKS_MOCK_OS_CONFIG_CONNECTION_H

#include "google/cloud/osconfig/v1/os_config_connection.h"
#include <gmock/gmock.h>

namespace google {
namespace cloud {
namespace osconfig_v1_mocks {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

/**
 * A class to mock `OsConfigServiceConnection`.
 *
 * Application developers may want to test their code with simulated responses,
 * including errors, from an object of type `OsConfigServiceClient`. To do so,
 * construct an object of type `OsConfigServiceClient` with an instance of this
 * class. Then use the Google Test framework functions to program the behavior
 * of this mock.
 *
 * @see [This example][bq-mock] for how to test your application with GoogleTest.
 * While the example showcases types from the BigQuery library, the underlying
 * principles apply for any pair of `*Client` and `*Connection`.
 *
 * [bq-mock]: @cloud_cpp_docs_link{bigquery,bigquery-read-mock}
 */
class MockOsConfigServiceConnection
    : public osconfig_v1::OsConfigServiceConnection {
 public:
  MOCK_METHOD(Options, options, (), (override));

  MOCK_METHOD(
      StatusOr<google::cloud::osconfig::v1::PatchJob>, ExecutePatchJob,
      (google::cloud::osconfig::v1::ExecutePatchJobRequest const& request),
      (override));

  MOCK_METHOD(StatusOr<google::cloud::osconfig::v1::PatchJob>, GetPatchJob,
              (google::cloud::osconfig::v1::GetPatchJobRequest const& request),
              (override));

  MOCK_METHOD(
      StatusOr<google::cloud::osconfig::v1::PatchJob>, CancelPatchJob,
      (google::cloud::osconfig::v1::CancelPatchJobRequest const& request),
      (override));

  MOCK_METHOD((StreamRange<google::cloud::osconfig::v1::PatchJob>),
              ListPatchJobs,
              (google::cloud::osconfig::v1::ListPatchJobsRequest request),
              (override));

  MOCK_METHOD(
      (StreamRange<google::cloud::osconfig::v1::PatchJobInstanceDetails>),
      ListPatchJobInstanceDetails,
      (google::cloud::osconfig::v1::ListPatchJobInstanceDetailsRequest request),
      (override));

  MOCK_METHOD(StatusOr<google::cloud::osconfig::v1::PatchDeployment>,
              CreatePatchDeployment,
              (google::cloud::osconfig::v1::CreatePatchDeploymentRequest const&
                   request),
              (override));

  MOCK_METHOD(
      StatusOr<google::cloud::osconfig::v1::PatchDeployment>,
      GetPatchDeployment,
      (google::cloud::osconfig::v1::GetPatchDeploymentRequest const& request),
      (override));

  MOCK_METHOD(
      (StreamRange<google::cloud::osconfig::v1::PatchDeployment>),
      ListPatchDeployments,
      (google::cloud::osconfig::v1::ListPatchDeploymentsRequest request),
      (override));

  MOCK_METHOD(Status, DeletePatchDeployment,
              (google::cloud::osconfig::v1::DeletePatchDeploymentRequest const&
                   request),
              (override));

  MOCK_METHOD(StatusOr<google::cloud::osconfig::v1::PatchDeployment>,
              UpdatePatchDeployment,
              (google::cloud::osconfig::v1::UpdatePatchDeploymentRequest const&
                   request),
              (override));

  MOCK_METHOD(
      StatusOr<google::cloud::osconfig::v1::PatchDeployment>,
      PausePatchDeployment,
      (google::cloud::osconfig::v1::PausePatchDeploymentRequest const& request),
      (override));

  MOCK_METHOD(StatusOr<google::cloud::osconfig::v1::PatchDeployment>,
              ResumePatchDeployment,
              (google::cloud::osconfig::v1::ResumePatchDeploymentRequest const&
                   request),
              (override));
};

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace osconfig_v1_mocks
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_OSCONFIG_V1_MOCKS_MOCK_OS_CONFIG_CONNECTION_H
