// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/oslogin/v1/oslogin.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2foslogin_2fv1_2foslogin_2eproto__INCLUDED
#define GRPC_google_2fcloud_2foslogin_2fv1_2foslogin_2eproto__INCLUDED

#include "google/cloud/oslogin/v1/oslogin.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>
#include <grpcpp/ports_def.inc>

namespace google {
namespace cloud {
namespace oslogin {
namespace v1 {

// Cloud OS Login API
//
// The Cloud OS Login API allows you to manage users and their associated SSH
// public keys for logging into virtual machines on Google Cloud Platform.
class OsLoginService final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.oslogin.v1.OsLoginService";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Create an SSH public key
    virtual ::grpc::Status CreateSshPublicKey(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::CreateSshPublicKeyRequest& request, ::google::cloud::oslogin::common::SshPublicKey* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::oslogin::common::SshPublicKey>> AsyncCreateSshPublicKey(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::CreateSshPublicKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::oslogin::common::SshPublicKey>>(AsyncCreateSshPublicKeyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::oslogin::common::SshPublicKey>> PrepareAsyncCreateSshPublicKey(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::CreateSshPublicKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::oslogin::common::SshPublicKey>>(PrepareAsyncCreateSshPublicKeyRaw(context, request, cq));
    }
    // Deletes a POSIX account.
    virtual ::grpc::Status DeletePosixAccount(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::DeletePosixAccountRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncDeletePosixAccount(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::DeletePosixAccountRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncDeletePosixAccountRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncDeletePosixAccount(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::DeletePosixAccountRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncDeletePosixAccountRaw(context, request, cq));
    }
    // Deletes an SSH public key.
    virtual ::grpc::Status DeleteSshPublicKey(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::DeleteSshPublicKeyRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncDeleteSshPublicKey(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::DeleteSshPublicKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncDeleteSshPublicKeyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncDeleteSshPublicKey(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::DeleteSshPublicKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncDeleteSshPublicKeyRaw(context, request, cq));
    }
    // Retrieves the profile information used for logging in to a virtual machine
    // on Google Compute Engine.
    virtual ::grpc::Status GetLoginProfile(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::GetLoginProfileRequest& request, ::google::cloud::oslogin::v1::LoginProfile* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::oslogin::v1::LoginProfile>> AsyncGetLoginProfile(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::GetLoginProfileRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::oslogin::v1::LoginProfile>>(AsyncGetLoginProfileRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::oslogin::v1::LoginProfile>> PrepareAsyncGetLoginProfile(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::GetLoginProfileRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::oslogin::v1::LoginProfile>>(PrepareAsyncGetLoginProfileRaw(context, request, cq));
    }
    // Retrieves an SSH public key.
    virtual ::grpc::Status GetSshPublicKey(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::GetSshPublicKeyRequest& request, ::google::cloud::oslogin::common::SshPublicKey* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::oslogin::common::SshPublicKey>> AsyncGetSshPublicKey(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::GetSshPublicKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::oslogin::common::SshPublicKey>>(AsyncGetSshPublicKeyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::oslogin::common::SshPublicKey>> PrepareAsyncGetSshPublicKey(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::GetSshPublicKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::oslogin::common::SshPublicKey>>(PrepareAsyncGetSshPublicKeyRaw(context, request, cq));
    }
    // Adds an SSH public key and returns the profile information. Default POSIX
    // account information is set when no username and UID exist as part of the
    // login profile.
    virtual ::grpc::Status ImportSshPublicKey(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::ImportSshPublicKeyRequest& request, ::google::cloud::oslogin::v1::ImportSshPublicKeyResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::oslogin::v1::ImportSshPublicKeyResponse>> AsyncImportSshPublicKey(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::ImportSshPublicKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::oslogin::v1::ImportSshPublicKeyResponse>>(AsyncImportSshPublicKeyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::oslogin::v1::ImportSshPublicKeyResponse>> PrepareAsyncImportSshPublicKey(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::ImportSshPublicKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::oslogin::v1::ImportSshPublicKeyResponse>>(PrepareAsyncImportSshPublicKeyRaw(context, request, cq));
    }
    // Updates an SSH public key and returns the profile information. This method
    // supports patch semantics.
    virtual ::grpc::Status UpdateSshPublicKey(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::UpdateSshPublicKeyRequest& request, ::google::cloud::oslogin::common::SshPublicKey* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::oslogin::common::SshPublicKey>> AsyncUpdateSshPublicKey(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::UpdateSshPublicKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::oslogin::common::SshPublicKey>>(AsyncUpdateSshPublicKeyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::oslogin::common::SshPublicKey>> PrepareAsyncUpdateSshPublicKey(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::UpdateSshPublicKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::oslogin::common::SshPublicKey>>(PrepareAsyncUpdateSshPublicKeyRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Create an SSH public key
      virtual void CreateSshPublicKey(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::CreateSshPublicKeyRequest* request, ::google::cloud::oslogin::common::SshPublicKey* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateSshPublicKey(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::CreateSshPublicKeyRequest* request, ::google::cloud::oslogin::common::SshPublicKey* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a POSIX account.
      virtual void DeletePosixAccount(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::DeletePosixAccountRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeletePosixAccount(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::DeletePosixAccountRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes an SSH public key.
      virtual void DeleteSshPublicKey(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::DeleteSshPublicKeyRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteSshPublicKey(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::DeleteSshPublicKeyRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Retrieves the profile information used for logging in to a virtual machine
      // on Google Compute Engine.
      virtual void GetLoginProfile(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::GetLoginProfileRequest* request, ::google::cloud::oslogin::v1::LoginProfile* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetLoginProfile(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::GetLoginProfileRequest* request, ::google::cloud::oslogin::v1::LoginProfile* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Retrieves an SSH public key.
      virtual void GetSshPublicKey(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::GetSshPublicKeyRequest* request, ::google::cloud::oslogin::common::SshPublicKey* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetSshPublicKey(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::GetSshPublicKeyRequest* request, ::google::cloud::oslogin::common::SshPublicKey* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Adds an SSH public key and returns the profile information. Default POSIX
      // account information is set when no username and UID exist as part of the
      // login profile.
      virtual void ImportSshPublicKey(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::ImportSshPublicKeyRequest* request, ::google::cloud::oslogin::v1::ImportSshPublicKeyResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ImportSshPublicKey(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::ImportSshPublicKeyRequest* request, ::google::cloud::oslogin::v1::ImportSshPublicKeyResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates an SSH public key and returns the profile information. This method
      // supports patch semantics.
      virtual void UpdateSshPublicKey(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::UpdateSshPublicKeyRequest* request, ::google::cloud::oslogin::common::SshPublicKey* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateSshPublicKey(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::UpdateSshPublicKeyRequest* request, ::google::cloud::oslogin::common::SshPublicKey* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::oslogin::common::SshPublicKey>* AsyncCreateSshPublicKeyRaw(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::CreateSshPublicKeyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::oslogin::common::SshPublicKey>* PrepareAsyncCreateSshPublicKeyRaw(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::CreateSshPublicKeyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncDeletePosixAccountRaw(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::DeletePosixAccountRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncDeletePosixAccountRaw(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::DeletePosixAccountRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncDeleteSshPublicKeyRaw(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::DeleteSshPublicKeyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncDeleteSshPublicKeyRaw(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::DeleteSshPublicKeyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::oslogin::v1::LoginProfile>* AsyncGetLoginProfileRaw(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::GetLoginProfileRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::oslogin::v1::LoginProfile>* PrepareAsyncGetLoginProfileRaw(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::GetLoginProfileRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::oslogin::common::SshPublicKey>* AsyncGetSshPublicKeyRaw(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::GetSshPublicKeyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::oslogin::common::SshPublicKey>* PrepareAsyncGetSshPublicKeyRaw(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::GetSshPublicKeyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::oslogin::v1::ImportSshPublicKeyResponse>* AsyncImportSshPublicKeyRaw(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::ImportSshPublicKeyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::oslogin::v1::ImportSshPublicKeyResponse>* PrepareAsyncImportSshPublicKeyRaw(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::ImportSshPublicKeyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::oslogin::common::SshPublicKey>* AsyncUpdateSshPublicKeyRaw(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::UpdateSshPublicKeyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::oslogin::common::SshPublicKey>* PrepareAsyncUpdateSshPublicKeyRaw(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::UpdateSshPublicKeyRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status CreateSshPublicKey(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::CreateSshPublicKeyRequest& request, ::google::cloud::oslogin::common::SshPublicKey* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::oslogin::common::SshPublicKey>> AsyncCreateSshPublicKey(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::CreateSshPublicKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::oslogin::common::SshPublicKey>>(AsyncCreateSshPublicKeyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::oslogin::common::SshPublicKey>> PrepareAsyncCreateSshPublicKey(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::CreateSshPublicKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::oslogin::common::SshPublicKey>>(PrepareAsyncCreateSshPublicKeyRaw(context, request, cq));
    }
    ::grpc::Status DeletePosixAccount(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::DeletePosixAccountRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncDeletePosixAccount(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::DeletePosixAccountRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncDeletePosixAccountRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncDeletePosixAccount(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::DeletePosixAccountRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncDeletePosixAccountRaw(context, request, cq));
    }
    ::grpc::Status DeleteSshPublicKey(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::DeleteSshPublicKeyRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncDeleteSshPublicKey(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::DeleteSshPublicKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncDeleteSshPublicKeyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncDeleteSshPublicKey(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::DeleteSshPublicKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncDeleteSshPublicKeyRaw(context, request, cq));
    }
    ::grpc::Status GetLoginProfile(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::GetLoginProfileRequest& request, ::google::cloud::oslogin::v1::LoginProfile* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::oslogin::v1::LoginProfile>> AsyncGetLoginProfile(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::GetLoginProfileRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::oslogin::v1::LoginProfile>>(AsyncGetLoginProfileRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::oslogin::v1::LoginProfile>> PrepareAsyncGetLoginProfile(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::GetLoginProfileRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::oslogin::v1::LoginProfile>>(PrepareAsyncGetLoginProfileRaw(context, request, cq));
    }
    ::grpc::Status GetSshPublicKey(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::GetSshPublicKeyRequest& request, ::google::cloud::oslogin::common::SshPublicKey* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::oslogin::common::SshPublicKey>> AsyncGetSshPublicKey(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::GetSshPublicKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::oslogin::common::SshPublicKey>>(AsyncGetSshPublicKeyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::oslogin::common::SshPublicKey>> PrepareAsyncGetSshPublicKey(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::GetSshPublicKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::oslogin::common::SshPublicKey>>(PrepareAsyncGetSshPublicKeyRaw(context, request, cq));
    }
    ::grpc::Status ImportSshPublicKey(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::ImportSshPublicKeyRequest& request, ::google::cloud::oslogin::v1::ImportSshPublicKeyResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::oslogin::v1::ImportSshPublicKeyResponse>> AsyncImportSshPublicKey(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::ImportSshPublicKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::oslogin::v1::ImportSshPublicKeyResponse>>(AsyncImportSshPublicKeyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::oslogin::v1::ImportSshPublicKeyResponse>> PrepareAsyncImportSshPublicKey(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::ImportSshPublicKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::oslogin::v1::ImportSshPublicKeyResponse>>(PrepareAsyncImportSshPublicKeyRaw(context, request, cq));
    }
    ::grpc::Status UpdateSshPublicKey(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::UpdateSshPublicKeyRequest& request, ::google::cloud::oslogin::common::SshPublicKey* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::oslogin::common::SshPublicKey>> AsyncUpdateSshPublicKey(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::UpdateSshPublicKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::oslogin::common::SshPublicKey>>(AsyncUpdateSshPublicKeyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::oslogin::common::SshPublicKey>> PrepareAsyncUpdateSshPublicKey(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::UpdateSshPublicKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::oslogin::common::SshPublicKey>>(PrepareAsyncUpdateSshPublicKeyRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void CreateSshPublicKey(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::CreateSshPublicKeyRequest* request, ::google::cloud::oslogin::common::SshPublicKey* response, std::function<void(::grpc::Status)>) override;
      void CreateSshPublicKey(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::CreateSshPublicKeyRequest* request, ::google::cloud::oslogin::common::SshPublicKey* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeletePosixAccount(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::DeletePosixAccountRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void DeletePosixAccount(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::DeletePosixAccountRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteSshPublicKey(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::DeleteSshPublicKeyRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void DeleteSshPublicKey(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::DeleteSshPublicKeyRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetLoginProfile(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::GetLoginProfileRequest* request, ::google::cloud::oslogin::v1::LoginProfile* response, std::function<void(::grpc::Status)>) override;
      void GetLoginProfile(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::GetLoginProfileRequest* request, ::google::cloud::oslogin::v1::LoginProfile* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetSshPublicKey(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::GetSshPublicKeyRequest* request, ::google::cloud::oslogin::common::SshPublicKey* response, std::function<void(::grpc::Status)>) override;
      void GetSshPublicKey(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::GetSshPublicKeyRequest* request, ::google::cloud::oslogin::common::SshPublicKey* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ImportSshPublicKey(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::ImportSshPublicKeyRequest* request, ::google::cloud::oslogin::v1::ImportSshPublicKeyResponse* response, std::function<void(::grpc::Status)>) override;
      void ImportSshPublicKey(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::ImportSshPublicKeyRequest* request, ::google::cloud::oslogin::v1::ImportSshPublicKeyResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateSshPublicKey(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::UpdateSshPublicKeyRequest* request, ::google::cloud::oslogin::common::SshPublicKey* response, std::function<void(::grpc::Status)>) override;
      void UpdateSshPublicKey(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::UpdateSshPublicKeyRequest* request, ::google::cloud::oslogin::common::SshPublicKey* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::oslogin::common::SshPublicKey>* AsyncCreateSshPublicKeyRaw(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::CreateSshPublicKeyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::oslogin::common::SshPublicKey>* PrepareAsyncCreateSshPublicKeyRaw(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::CreateSshPublicKeyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncDeletePosixAccountRaw(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::DeletePosixAccountRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncDeletePosixAccountRaw(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::DeletePosixAccountRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncDeleteSshPublicKeyRaw(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::DeleteSshPublicKeyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncDeleteSshPublicKeyRaw(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::DeleteSshPublicKeyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::oslogin::v1::LoginProfile>* AsyncGetLoginProfileRaw(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::GetLoginProfileRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::oslogin::v1::LoginProfile>* PrepareAsyncGetLoginProfileRaw(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::GetLoginProfileRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::oslogin::common::SshPublicKey>* AsyncGetSshPublicKeyRaw(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::GetSshPublicKeyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::oslogin::common::SshPublicKey>* PrepareAsyncGetSshPublicKeyRaw(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::GetSshPublicKeyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::oslogin::v1::ImportSshPublicKeyResponse>* AsyncImportSshPublicKeyRaw(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::ImportSshPublicKeyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::oslogin::v1::ImportSshPublicKeyResponse>* PrepareAsyncImportSshPublicKeyRaw(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::ImportSshPublicKeyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::oslogin::common::SshPublicKey>* AsyncUpdateSshPublicKeyRaw(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::UpdateSshPublicKeyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::oslogin::common::SshPublicKey>* PrepareAsyncUpdateSshPublicKeyRaw(::grpc::ClientContext* context, const ::google::cloud::oslogin::v1::UpdateSshPublicKeyRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_CreateSshPublicKey_;
    const ::grpc::internal::RpcMethod rpcmethod_DeletePosixAccount_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteSshPublicKey_;
    const ::grpc::internal::RpcMethod rpcmethod_GetLoginProfile_;
    const ::grpc::internal::RpcMethod rpcmethod_GetSshPublicKey_;
    const ::grpc::internal::RpcMethod rpcmethod_ImportSshPublicKey_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateSshPublicKey_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Create an SSH public key
    virtual ::grpc::Status CreateSshPublicKey(::grpc::ServerContext* context, const ::google::cloud::oslogin::v1::CreateSshPublicKeyRequest* request, ::google::cloud::oslogin::common::SshPublicKey* response);
    // Deletes a POSIX account.
    virtual ::grpc::Status DeletePosixAccount(::grpc::ServerContext* context, const ::google::cloud::oslogin::v1::DeletePosixAccountRequest* request, ::google::protobuf::Empty* response);
    // Deletes an SSH public key.
    virtual ::grpc::Status DeleteSshPublicKey(::grpc::ServerContext* context, const ::google::cloud::oslogin::v1::DeleteSshPublicKeyRequest* request, ::google::protobuf::Empty* response);
    // Retrieves the profile information used for logging in to a virtual machine
    // on Google Compute Engine.
    virtual ::grpc::Status GetLoginProfile(::grpc::ServerContext* context, const ::google::cloud::oslogin::v1::GetLoginProfileRequest* request, ::google::cloud::oslogin::v1::LoginProfile* response);
    // Retrieves an SSH public key.
    virtual ::grpc::Status GetSshPublicKey(::grpc::ServerContext* context, const ::google::cloud::oslogin::v1::GetSshPublicKeyRequest* request, ::google::cloud::oslogin::common::SshPublicKey* response);
    // Adds an SSH public key and returns the profile information. Default POSIX
    // account information is set when no username and UID exist as part of the
    // login profile.
    virtual ::grpc::Status ImportSshPublicKey(::grpc::ServerContext* context, const ::google::cloud::oslogin::v1::ImportSshPublicKeyRequest* request, ::google::cloud::oslogin::v1::ImportSshPublicKeyResponse* response);
    // Updates an SSH public key and returns the profile information. This method
    // supports patch semantics.
    virtual ::grpc::Status UpdateSshPublicKey(::grpc::ServerContext* context, const ::google::cloud::oslogin::v1::UpdateSshPublicKeyRequest* request, ::google::cloud::oslogin::common::SshPublicKey* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateSshPublicKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateSshPublicKey() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_CreateSshPublicKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateSshPublicKey(::grpc::ServerContext* /*context*/, const ::google::cloud::oslogin::v1::CreateSshPublicKeyRequest* /*request*/, ::google::cloud::oslogin::common::SshPublicKey* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateSshPublicKey(::grpc::ServerContext* context, ::google::cloud::oslogin::v1::CreateSshPublicKeyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::oslogin::common::SshPublicKey>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeletePosixAccount : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeletePosixAccount() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_DeletePosixAccount() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeletePosixAccount(::grpc::ServerContext* /*context*/, const ::google::cloud::oslogin::v1::DeletePosixAccountRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeletePosixAccount(::grpc::ServerContext* context, ::google::cloud::oslogin::v1::DeletePosixAccountRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteSshPublicKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteSshPublicKey() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_DeleteSshPublicKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteSshPublicKey(::grpc::ServerContext* /*context*/, const ::google::cloud::oslogin::v1::DeleteSshPublicKeyRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteSshPublicKey(::grpc::ServerContext* context, ::google::cloud::oslogin::v1::DeleteSshPublicKeyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetLoginProfile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetLoginProfile() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_GetLoginProfile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetLoginProfile(::grpc::ServerContext* /*context*/, const ::google::cloud::oslogin::v1::GetLoginProfileRequest* /*request*/, ::google::cloud::oslogin::v1::LoginProfile* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetLoginProfile(::grpc::ServerContext* context, ::google::cloud::oslogin::v1::GetLoginProfileRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::oslogin::v1::LoginProfile>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetSshPublicKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetSshPublicKey() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_GetSshPublicKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSshPublicKey(::grpc::ServerContext* /*context*/, const ::google::cloud::oslogin::v1::GetSshPublicKeyRequest* /*request*/, ::google::cloud::oslogin::common::SshPublicKey* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetSshPublicKey(::grpc::ServerContext* context, ::google::cloud::oslogin::v1::GetSshPublicKeyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::oslogin::common::SshPublicKey>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ImportSshPublicKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ImportSshPublicKey() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_ImportSshPublicKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ImportSshPublicKey(::grpc::ServerContext* /*context*/, const ::google::cloud::oslogin::v1::ImportSshPublicKeyRequest* /*request*/, ::google::cloud::oslogin::v1::ImportSshPublicKeyResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestImportSshPublicKey(::grpc::ServerContext* context, ::google::cloud::oslogin::v1::ImportSshPublicKeyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::oslogin::v1::ImportSshPublicKeyResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateSshPublicKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateSshPublicKey() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_UpdateSshPublicKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateSshPublicKey(::grpc::ServerContext* /*context*/, const ::google::cloud::oslogin::v1::UpdateSshPublicKeyRequest* /*request*/, ::google::cloud::oslogin::common::SshPublicKey* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateSshPublicKey(::grpc::ServerContext* context, ::google::cloud::oslogin::v1::UpdateSshPublicKeyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::oslogin::common::SshPublicKey>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_CreateSshPublicKey<WithAsyncMethod_DeletePosixAccount<WithAsyncMethod_DeleteSshPublicKey<WithAsyncMethod_GetLoginProfile<WithAsyncMethod_GetSshPublicKey<WithAsyncMethod_ImportSshPublicKey<WithAsyncMethod_UpdateSshPublicKey<Service > > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_CreateSshPublicKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateSshPublicKey() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::oslogin::v1::CreateSshPublicKeyRequest, ::google::cloud::oslogin::common::SshPublicKey>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::oslogin::v1::CreateSshPublicKeyRequest* request, ::google::cloud::oslogin::common::SshPublicKey* response) { return this->CreateSshPublicKey(context, request, response); }));}
    void SetMessageAllocatorFor_CreateSshPublicKey(
        ::grpc::MessageAllocator< ::google::cloud::oslogin::v1::CreateSshPublicKeyRequest, ::google::cloud::oslogin::common::SshPublicKey>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::oslogin::v1::CreateSshPublicKeyRequest, ::google::cloud::oslogin::common::SshPublicKey>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateSshPublicKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateSshPublicKey(::grpc::ServerContext* /*context*/, const ::google::cloud::oslogin::v1::CreateSshPublicKeyRequest* /*request*/, ::google::cloud::oslogin::common::SshPublicKey* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateSshPublicKey(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::oslogin::v1::CreateSshPublicKeyRequest* /*request*/, ::google::cloud::oslogin::common::SshPublicKey* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeletePosixAccount : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeletePosixAccount() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::oslogin::v1::DeletePosixAccountRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::oslogin::v1::DeletePosixAccountRequest* request, ::google::protobuf::Empty* response) { return this->DeletePosixAccount(context, request, response); }));}
    void SetMessageAllocatorFor_DeletePosixAccount(
        ::grpc::MessageAllocator< ::google::cloud::oslogin::v1::DeletePosixAccountRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::oslogin::v1::DeletePosixAccountRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeletePosixAccount() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeletePosixAccount(::grpc::ServerContext* /*context*/, const ::google::cloud::oslogin::v1::DeletePosixAccountRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeletePosixAccount(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::oslogin::v1::DeletePosixAccountRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteSshPublicKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteSshPublicKey() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::oslogin::v1::DeleteSshPublicKeyRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::oslogin::v1::DeleteSshPublicKeyRequest* request, ::google::protobuf::Empty* response) { return this->DeleteSshPublicKey(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteSshPublicKey(
        ::grpc::MessageAllocator< ::google::cloud::oslogin::v1::DeleteSshPublicKeyRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::oslogin::v1::DeleteSshPublicKeyRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteSshPublicKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteSshPublicKey(::grpc::ServerContext* /*context*/, const ::google::cloud::oslogin::v1::DeleteSshPublicKeyRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteSshPublicKey(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::oslogin::v1::DeleteSshPublicKeyRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetLoginProfile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetLoginProfile() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::oslogin::v1::GetLoginProfileRequest, ::google::cloud::oslogin::v1::LoginProfile>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::oslogin::v1::GetLoginProfileRequest* request, ::google::cloud::oslogin::v1::LoginProfile* response) { return this->GetLoginProfile(context, request, response); }));}
    void SetMessageAllocatorFor_GetLoginProfile(
        ::grpc::MessageAllocator< ::google::cloud::oslogin::v1::GetLoginProfileRequest, ::google::cloud::oslogin::v1::LoginProfile>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::oslogin::v1::GetLoginProfileRequest, ::google::cloud::oslogin::v1::LoginProfile>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetLoginProfile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetLoginProfile(::grpc::ServerContext* /*context*/, const ::google::cloud::oslogin::v1::GetLoginProfileRequest* /*request*/, ::google::cloud::oslogin::v1::LoginProfile* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetLoginProfile(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::oslogin::v1::GetLoginProfileRequest* /*request*/, ::google::cloud::oslogin::v1::LoginProfile* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetSshPublicKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetSshPublicKey() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::oslogin::v1::GetSshPublicKeyRequest, ::google::cloud::oslogin::common::SshPublicKey>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::oslogin::v1::GetSshPublicKeyRequest* request, ::google::cloud::oslogin::common::SshPublicKey* response) { return this->GetSshPublicKey(context, request, response); }));}
    void SetMessageAllocatorFor_GetSshPublicKey(
        ::grpc::MessageAllocator< ::google::cloud::oslogin::v1::GetSshPublicKeyRequest, ::google::cloud::oslogin::common::SshPublicKey>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::oslogin::v1::GetSshPublicKeyRequest, ::google::cloud::oslogin::common::SshPublicKey>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetSshPublicKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSshPublicKey(::grpc::ServerContext* /*context*/, const ::google::cloud::oslogin::v1::GetSshPublicKeyRequest* /*request*/, ::google::cloud::oslogin::common::SshPublicKey* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetSshPublicKey(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::oslogin::v1::GetSshPublicKeyRequest* /*request*/, ::google::cloud::oslogin::common::SshPublicKey* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ImportSshPublicKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ImportSshPublicKey() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::oslogin::v1::ImportSshPublicKeyRequest, ::google::cloud::oslogin::v1::ImportSshPublicKeyResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::oslogin::v1::ImportSshPublicKeyRequest* request, ::google::cloud::oslogin::v1::ImportSshPublicKeyResponse* response) { return this->ImportSshPublicKey(context, request, response); }));}
    void SetMessageAllocatorFor_ImportSshPublicKey(
        ::grpc::MessageAllocator< ::google::cloud::oslogin::v1::ImportSshPublicKeyRequest, ::google::cloud::oslogin::v1::ImportSshPublicKeyResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::oslogin::v1::ImportSshPublicKeyRequest, ::google::cloud::oslogin::v1::ImportSshPublicKeyResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ImportSshPublicKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ImportSshPublicKey(::grpc::ServerContext* /*context*/, const ::google::cloud::oslogin::v1::ImportSshPublicKeyRequest* /*request*/, ::google::cloud::oslogin::v1::ImportSshPublicKeyResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ImportSshPublicKey(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::oslogin::v1::ImportSshPublicKeyRequest* /*request*/, ::google::cloud::oslogin::v1::ImportSshPublicKeyResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateSshPublicKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateSshPublicKey() {
      ::grpc::Service::MarkMethodCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::oslogin::v1::UpdateSshPublicKeyRequest, ::google::cloud::oslogin::common::SshPublicKey>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::oslogin::v1::UpdateSshPublicKeyRequest* request, ::google::cloud::oslogin::common::SshPublicKey* response) { return this->UpdateSshPublicKey(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateSshPublicKey(
        ::grpc::MessageAllocator< ::google::cloud::oslogin::v1::UpdateSshPublicKeyRequest, ::google::cloud::oslogin::common::SshPublicKey>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(6);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::oslogin::v1::UpdateSshPublicKeyRequest, ::google::cloud::oslogin::common::SshPublicKey>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateSshPublicKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateSshPublicKey(::grpc::ServerContext* /*context*/, const ::google::cloud::oslogin::v1::UpdateSshPublicKeyRequest* /*request*/, ::google::cloud::oslogin::common::SshPublicKey* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateSshPublicKey(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::oslogin::v1::UpdateSshPublicKeyRequest* /*request*/, ::google::cloud::oslogin::common::SshPublicKey* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_CreateSshPublicKey<WithCallbackMethod_DeletePosixAccount<WithCallbackMethod_DeleteSshPublicKey<WithCallbackMethod_GetLoginProfile<WithCallbackMethod_GetSshPublicKey<WithCallbackMethod_ImportSshPublicKey<WithCallbackMethod_UpdateSshPublicKey<Service > > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_CreateSshPublicKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateSshPublicKey() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_CreateSshPublicKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateSshPublicKey(::grpc::ServerContext* /*context*/, const ::google::cloud::oslogin::v1::CreateSshPublicKeyRequest* /*request*/, ::google::cloud::oslogin::common::SshPublicKey* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeletePosixAccount : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeletePosixAccount() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_DeletePosixAccount() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeletePosixAccount(::grpc::ServerContext* /*context*/, const ::google::cloud::oslogin::v1::DeletePosixAccountRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteSshPublicKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteSshPublicKey() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_DeleteSshPublicKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteSshPublicKey(::grpc::ServerContext* /*context*/, const ::google::cloud::oslogin::v1::DeleteSshPublicKeyRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetLoginProfile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetLoginProfile() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_GetLoginProfile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetLoginProfile(::grpc::ServerContext* /*context*/, const ::google::cloud::oslogin::v1::GetLoginProfileRequest* /*request*/, ::google::cloud::oslogin::v1::LoginProfile* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetSshPublicKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetSshPublicKey() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_GetSshPublicKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSshPublicKey(::grpc::ServerContext* /*context*/, const ::google::cloud::oslogin::v1::GetSshPublicKeyRequest* /*request*/, ::google::cloud::oslogin::common::SshPublicKey* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ImportSshPublicKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ImportSshPublicKey() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_ImportSshPublicKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ImportSshPublicKey(::grpc::ServerContext* /*context*/, const ::google::cloud::oslogin::v1::ImportSshPublicKeyRequest* /*request*/, ::google::cloud::oslogin::v1::ImportSshPublicKeyResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateSshPublicKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateSshPublicKey() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_UpdateSshPublicKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateSshPublicKey(::grpc::ServerContext* /*context*/, const ::google::cloud::oslogin::v1::UpdateSshPublicKeyRequest* /*request*/, ::google::cloud::oslogin::common::SshPublicKey* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateSshPublicKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateSshPublicKey() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_CreateSshPublicKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateSshPublicKey(::grpc::ServerContext* /*context*/, const ::google::cloud::oslogin::v1::CreateSshPublicKeyRequest* /*request*/, ::google::cloud::oslogin::common::SshPublicKey* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateSshPublicKey(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeletePosixAccount : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeletePosixAccount() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_DeletePosixAccount() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeletePosixAccount(::grpc::ServerContext* /*context*/, const ::google::cloud::oslogin::v1::DeletePosixAccountRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeletePosixAccount(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteSshPublicKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteSshPublicKey() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_DeleteSshPublicKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteSshPublicKey(::grpc::ServerContext* /*context*/, const ::google::cloud::oslogin::v1::DeleteSshPublicKeyRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteSshPublicKey(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetLoginProfile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetLoginProfile() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_GetLoginProfile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetLoginProfile(::grpc::ServerContext* /*context*/, const ::google::cloud::oslogin::v1::GetLoginProfileRequest* /*request*/, ::google::cloud::oslogin::v1::LoginProfile* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetLoginProfile(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetSshPublicKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetSshPublicKey() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_GetSshPublicKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSshPublicKey(::grpc::ServerContext* /*context*/, const ::google::cloud::oslogin::v1::GetSshPublicKeyRequest* /*request*/, ::google::cloud::oslogin::common::SshPublicKey* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetSshPublicKey(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ImportSshPublicKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ImportSshPublicKey() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_ImportSshPublicKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ImportSshPublicKey(::grpc::ServerContext* /*context*/, const ::google::cloud::oslogin::v1::ImportSshPublicKeyRequest* /*request*/, ::google::cloud::oslogin::v1::ImportSshPublicKeyResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestImportSshPublicKey(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateSshPublicKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateSshPublicKey() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_UpdateSshPublicKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateSshPublicKey(::grpc::ServerContext* /*context*/, const ::google::cloud::oslogin::v1::UpdateSshPublicKeyRequest* /*request*/, ::google::cloud::oslogin::common::SshPublicKey* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateSshPublicKey(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateSshPublicKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateSshPublicKey() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateSshPublicKey(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateSshPublicKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateSshPublicKey(::grpc::ServerContext* /*context*/, const ::google::cloud::oslogin::v1::CreateSshPublicKeyRequest* /*request*/, ::google::cloud::oslogin::common::SshPublicKey* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateSshPublicKey(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeletePosixAccount : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeletePosixAccount() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeletePosixAccount(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeletePosixAccount() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeletePosixAccount(::grpc::ServerContext* /*context*/, const ::google::cloud::oslogin::v1::DeletePosixAccountRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeletePosixAccount(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteSshPublicKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteSshPublicKey() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteSshPublicKey(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteSshPublicKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteSshPublicKey(::grpc::ServerContext* /*context*/, const ::google::cloud::oslogin::v1::DeleteSshPublicKeyRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteSshPublicKey(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetLoginProfile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetLoginProfile() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetLoginProfile(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetLoginProfile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetLoginProfile(::grpc::ServerContext* /*context*/, const ::google::cloud::oslogin::v1::GetLoginProfileRequest* /*request*/, ::google::cloud::oslogin::v1::LoginProfile* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetLoginProfile(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetSshPublicKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetSshPublicKey() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetSshPublicKey(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetSshPublicKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetSshPublicKey(::grpc::ServerContext* /*context*/, const ::google::cloud::oslogin::v1::GetSshPublicKeyRequest* /*request*/, ::google::cloud::oslogin::common::SshPublicKey* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetSshPublicKey(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ImportSshPublicKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ImportSshPublicKey() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ImportSshPublicKey(context, request, response); }));
    }
    ~WithRawCallbackMethod_ImportSshPublicKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ImportSshPublicKey(::grpc::ServerContext* /*context*/, const ::google::cloud::oslogin::v1::ImportSshPublicKeyRequest* /*request*/, ::google::cloud::oslogin::v1::ImportSshPublicKeyResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ImportSshPublicKey(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateSshPublicKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateSshPublicKey() {
      ::grpc::Service::MarkMethodRawCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateSshPublicKey(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateSshPublicKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateSshPublicKey(::grpc::ServerContext* /*context*/, const ::google::cloud::oslogin::v1::UpdateSshPublicKeyRequest* /*request*/, ::google::cloud::oslogin::common::SshPublicKey* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateSshPublicKey(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateSshPublicKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateSshPublicKey() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::oslogin::v1::CreateSshPublicKeyRequest, ::google::cloud::oslogin::common::SshPublicKey>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::oslogin::v1::CreateSshPublicKeyRequest, ::google::cloud::oslogin::common::SshPublicKey>* streamer) {
                       return this->StreamedCreateSshPublicKey(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateSshPublicKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateSshPublicKey(::grpc::ServerContext* /*context*/, const ::google::cloud::oslogin::v1::CreateSshPublicKeyRequest* /*request*/, ::google::cloud::oslogin::common::SshPublicKey* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateSshPublicKey(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::oslogin::v1::CreateSshPublicKeyRequest,::google::cloud::oslogin::common::SshPublicKey>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeletePosixAccount : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeletePosixAccount() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::oslogin::v1::DeletePosixAccountRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::oslogin::v1::DeletePosixAccountRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedDeletePosixAccount(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeletePosixAccount() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeletePosixAccount(::grpc::ServerContext* /*context*/, const ::google::cloud::oslogin::v1::DeletePosixAccountRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeletePosixAccount(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::oslogin::v1::DeletePosixAccountRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteSshPublicKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteSshPublicKey() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::oslogin::v1::DeleteSshPublicKeyRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::oslogin::v1::DeleteSshPublicKeyRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedDeleteSshPublicKey(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteSshPublicKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteSshPublicKey(::grpc::ServerContext* /*context*/, const ::google::cloud::oslogin::v1::DeleteSshPublicKeyRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteSshPublicKey(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::oslogin::v1::DeleteSshPublicKeyRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetLoginProfile : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetLoginProfile() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::oslogin::v1::GetLoginProfileRequest, ::google::cloud::oslogin::v1::LoginProfile>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::oslogin::v1::GetLoginProfileRequest, ::google::cloud::oslogin::v1::LoginProfile>* streamer) {
                       return this->StreamedGetLoginProfile(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetLoginProfile() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetLoginProfile(::grpc::ServerContext* /*context*/, const ::google::cloud::oslogin::v1::GetLoginProfileRequest* /*request*/, ::google::cloud::oslogin::v1::LoginProfile* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetLoginProfile(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::oslogin::v1::GetLoginProfileRequest,::google::cloud::oslogin::v1::LoginProfile>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetSshPublicKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetSshPublicKey() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::oslogin::v1::GetSshPublicKeyRequest, ::google::cloud::oslogin::common::SshPublicKey>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::oslogin::v1::GetSshPublicKeyRequest, ::google::cloud::oslogin::common::SshPublicKey>* streamer) {
                       return this->StreamedGetSshPublicKey(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetSshPublicKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetSshPublicKey(::grpc::ServerContext* /*context*/, const ::google::cloud::oslogin::v1::GetSshPublicKeyRequest* /*request*/, ::google::cloud::oslogin::common::SshPublicKey* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetSshPublicKey(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::oslogin::v1::GetSshPublicKeyRequest,::google::cloud::oslogin::common::SshPublicKey>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ImportSshPublicKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ImportSshPublicKey() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::oslogin::v1::ImportSshPublicKeyRequest, ::google::cloud::oslogin::v1::ImportSshPublicKeyResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::oslogin::v1::ImportSshPublicKeyRequest, ::google::cloud::oslogin::v1::ImportSshPublicKeyResponse>* streamer) {
                       return this->StreamedImportSshPublicKey(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ImportSshPublicKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ImportSshPublicKey(::grpc::ServerContext* /*context*/, const ::google::cloud::oslogin::v1::ImportSshPublicKeyRequest* /*request*/, ::google::cloud::oslogin::v1::ImportSshPublicKeyResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedImportSshPublicKey(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::oslogin::v1::ImportSshPublicKeyRequest,::google::cloud::oslogin::v1::ImportSshPublicKeyResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateSshPublicKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateSshPublicKey() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::oslogin::v1::UpdateSshPublicKeyRequest, ::google::cloud::oslogin::common::SshPublicKey>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::oslogin::v1::UpdateSshPublicKeyRequest, ::google::cloud::oslogin::common::SshPublicKey>* streamer) {
                       return this->StreamedUpdateSshPublicKey(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateSshPublicKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateSshPublicKey(::grpc::ServerContext* /*context*/, const ::google::cloud::oslogin::v1::UpdateSshPublicKeyRequest* /*request*/, ::google::cloud::oslogin::common::SshPublicKey* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateSshPublicKey(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::oslogin::v1::UpdateSshPublicKeyRequest,::google::cloud::oslogin::common::SshPublicKey>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_CreateSshPublicKey<WithStreamedUnaryMethod_DeletePosixAccount<WithStreamedUnaryMethod_DeleteSshPublicKey<WithStreamedUnaryMethod_GetLoginProfile<WithStreamedUnaryMethod_GetSshPublicKey<WithStreamedUnaryMethod_ImportSshPublicKey<WithStreamedUnaryMethod_UpdateSshPublicKey<Service > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_CreateSshPublicKey<WithStreamedUnaryMethod_DeletePosixAccount<WithStreamedUnaryMethod_DeleteSshPublicKey<WithStreamedUnaryMethod_GetLoginProfile<WithStreamedUnaryMethod_GetSshPublicKey<WithStreamedUnaryMethod_ImportSshPublicKey<WithStreamedUnaryMethod_UpdateSshPublicKey<Service > > > > > > > StreamedService;
};

}  // namespace v1
}  // namespace oslogin
}  // namespace cloud
}  // namespace google


#include <grpcpp/ports_undef.inc>
#endif  // GRPC_google_2fcloud_2foslogin_2fv1_2foslogin_2eproto__INCLUDED
