// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source:
// google/cloud/rapidmigrationassessment/v1/rapidmigrationassessment.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_RAPIDMIGRATIONASSESSMENT_V1_RAPID_MIGRATION_ASSESSMENT_CONNECTION_IDEMPOTENCY_POLICY_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_RAPIDMIGRATIONASSESSMENT_V1_RAPID_MIGRATION_ASSESSMENT_CONNECTION_IDEMPOTENCY_POLICY_H

#include "google/cloud/idempotency.h"
#include "google/cloud/version.h"
#include <google/cloud/location/locations.grpc.pb.h>
#include <google/cloud/rapidmigrationassessment/v1/rapidmigrationassessment.grpc.pb.h>
#include <google/longrunning/operations.grpc.pb.h>
#include <memory>

namespace google {
namespace cloud {
namespace rapidmigrationassessment_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

class RapidMigrationAssessmentConnectionIdempotencyPolicy {
 public:
  virtual ~RapidMigrationAssessmentConnectionIdempotencyPolicy();

  /// Create a new copy of this object.
  virtual std::unique_ptr<RapidMigrationAssessmentConnectionIdempotencyPolicy>
  clone() const;

  virtual google::cloud::Idempotency CreateCollector(
      google::cloud::rapidmigrationassessment::v1::CreateCollectorRequest const&
          request);

  virtual google::cloud::Idempotency CreateAnnotation(
      google::cloud::rapidmigrationassessment::v1::
          CreateAnnotationRequest const& request);

  virtual google::cloud::Idempotency GetAnnotation(
      google::cloud::rapidmigrationassessment::v1::GetAnnotationRequest const&
          request);

  virtual google::cloud::Idempotency ListCollectors(
      google::cloud::rapidmigrationassessment::v1::ListCollectorsRequest
          request);

  virtual google::cloud::Idempotency GetCollector(
      google::cloud::rapidmigrationassessment::v1::GetCollectorRequest const&
          request);

  virtual google::cloud::Idempotency UpdateCollector(
      google::cloud::rapidmigrationassessment::v1::UpdateCollectorRequest const&
          request);

  virtual google::cloud::Idempotency DeleteCollector(
      google::cloud::rapidmigrationassessment::v1::DeleteCollectorRequest const&
          request);

  virtual google::cloud::Idempotency ResumeCollector(
      google::cloud::rapidmigrationassessment::v1::ResumeCollectorRequest const&
          request);

  virtual google::cloud::Idempotency RegisterCollector(
      google::cloud::rapidmigrationassessment::v1::
          RegisterCollectorRequest const& request);

  virtual google::cloud::Idempotency PauseCollector(
      google::cloud::rapidmigrationassessment::v1::PauseCollectorRequest const&
          request);

  virtual google::cloud::Idempotency ListLocations(
      google::cloud::location::ListLocationsRequest request);

  virtual google::cloud::Idempotency GetLocation(
      google::cloud::location::GetLocationRequest const& request);

  virtual google::cloud::Idempotency ListOperations(
      google::longrunning::ListOperationsRequest request);

  virtual google::cloud::Idempotency GetOperation(
      google::longrunning::GetOperationRequest const& request);

  virtual google::cloud::Idempotency DeleteOperation(
      google::longrunning::DeleteOperationRequest const& request);

  virtual google::cloud::Idempotency CancelOperation(
      google::longrunning::CancelOperationRequest const& request);
};

std::unique_ptr<RapidMigrationAssessmentConnectionIdempotencyPolicy>
MakeDefaultRapidMigrationAssessmentConnectionIdempotencyPolicy();

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace rapidmigrationassessment_v1
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_RAPIDMIGRATIONASSESSMENT_V1_RAPID_MIGRATION_ASSESSMENT_CONNECTION_IDEMPOTENCY_POLICY_H
