// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/redis/cluster/v1/cloud_redis_cluster.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_REDIS_CLUSTER_V1_CLOUD_REDIS_CLUSTER_CONNECTION_IDEMPOTENCY_POLICY_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_REDIS_CLUSTER_V1_CLOUD_REDIS_CLUSTER_CONNECTION_IDEMPOTENCY_POLICY_H

#include "google/cloud/idempotency.h"
#include "google/cloud/version.h"
#include <google/cloud/location/locations.grpc.pb.h>
#include <google/cloud/redis/cluster/v1/cloud_redis_cluster.grpc.pb.h>
#include <google/longrunning/operations.grpc.pb.h>
#include <memory>

namespace google {
namespace cloud {
namespace redis_cluster_v1 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

class CloudRedisClusterConnectionIdempotencyPolicy {
 public:
  virtual ~CloudRedisClusterConnectionIdempotencyPolicy();

  /// Create a new copy of this object.
  virtual std::unique_ptr<CloudRedisClusterConnectionIdempotencyPolicy> clone()
      const;

  virtual google::cloud::Idempotency ListClusters(
      google::cloud::redis::cluster::v1::ListClustersRequest request);

  virtual google::cloud::Idempotency GetCluster(
      google::cloud::redis::cluster::v1::GetClusterRequest const& request);

  virtual google::cloud::Idempotency UpdateCluster(
      google::cloud::redis::cluster::v1::UpdateClusterRequest const& request);

  virtual google::cloud::Idempotency DeleteCluster(
      google::cloud::redis::cluster::v1::DeleteClusterRequest const& request);

  virtual google::cloud::Idempotency CreateCluster(
      google::cloud::redis::cluster::v1::CreateClusterRequest const& request);

  virtual google::cloud::Idempotency GetClusterCertificateAuthority(
      google::cloud::redis::cluster::v1::
          GetClusterCertificateAuthorityRequest const& request);

  virtual google::cloud::Idempotency RescheduleClusterMaintenance(
      google::cloud::redis::cluster::v1::
          RescheduleClusterMaintenanceRequest const& request);

  virtual google::cloud::Idempotency ListBackupCollections(
      google::cloud::redis::cluster::v1::ListBackupCollectionsRequest request);

  virtual google::cloud::Idempotency GetBackupCollection(
      google::cloud::redis::cluster::v1::GetBackupCollectionRequest const&
          request);

  virtual google::cloud::Idempotency ListBackups(
      google::cloud::redis::cluster::v1::ListBackupsRequest request);

  virtual google::cloud::Idempotency GetBackup(
      google::cloud::redis::cluster::v1::GetBackupRequest const& request);

  virtual google::cloud::Idempotency DeleteBackup(
      google::cloud::redis::cluster::v1::DeleteBackupRequest const& request);

  virtual google::cloud::Idempotency ExportBackup(
      google::cloud::redis::cluster::v1::ExportBackupRequest const& request);

  virtual google::cloud::Idempotency BackupCluster(
      google::cloud::redis::cluster::v1::BackupClusterRequest const& request);

  virtual google::cloud::Idempotency ListLocations(
      google::cloud::location::ListLocationsRequest request);

  virtual google::cloud::Idempotency GetLocation(
      google::cloud::location::GetLocationRequest const& request);

  virtual google::cloud::Idempotency ListOperations(
      google::longrunning::ListOperationsRequest request);

  virtual google::cloud::Idempotency GetOperation(
      google::longrunning::GetOperationRequest const& request);

  virtual google::cloud::Idempotency DeleteOperation(
      google::longrunning::DeleteOperationRequest const& request);

  virtual google::cloud::Idempotency CancelOperation(
      google::longrunning::CancelOperationRequest const& request);
};

std::unique_ptr<CloudRedisClusterConnectionIdempotencyPolicy>
MakeDefaultCloudRedisClusterConnectionIdempotencyPolicy();

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace redis_cluster_v1
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_REDIS_CLUSTER_V1_CLOUD_REDIS_CLUSTER_CONNECTION_IDEMPOTENCY_POLICY_H
