// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/retail/v2/serving_config_service.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_RETAIL_V2_SERVING_CONFIG_CONNECTION_IDEMPOTENCY_POLICY_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_RETAIL_V2_SERVING_CONFIG_CONNECTION_IDEMPOTENCY_POLICY_H

#include "google/cloud/idempotency.h"
#include "google/cloud/version.h"
#include <google/cloud/retail/v2/serving_config_service.grpc.pb.h>
#include <google/longrunning/operations.grpc.pb.h>
#include <memory>

namespace google {
namespace cloud {
namespace retail_v2 {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

class ServingConfigServiceConnectionIdempotencyPolicy {
 public:
  virtual ~ServingConfigServiceConnectionIdempotencyPolicy();

  /// Create a new copy of this object.
  virtual std::unique_ptr<ServingConfigServiceConnectionIdempotencyPolicy>
  clone() const;

  virtual google::cloud::Idempotency CreateServingConfig(
      google::cloud::retail::v2::CreateServingConfigRequest const& request);

  virtual google::cloud::Idempotency DeleteServingConfig(
      google::cloud::retail::v2::DeleteServingConfigRequest const& request);

  virtual google::cloud::Idempotency UpdateServingConfig(
      google::cloud::retail::v2::UpdateServingConfigRequest const& request);

  virtual google::cloud::Idempotency GetServingConfig(
      google::cloud::retail::v2::GetServingConfigRequest const& request);

  virtual google::cloud::Idempotency ListServingConfigs(
      google::cloud::retail::v2::ListServingConfigsRequest request);

  virtual google::cloud::Idempotency AddControl(
      google::cloud::retail::v2::AddControlRequest const& request);

  virtual google::cloud::Idempotency RemoveControl(
      google::cloud::retail::v2::RemoveControlRequest const& request);

  virtual google::cloud::Idempotency ListOperations(
      google::longrunning::ListOperationsRequest request);

  virtual google::cloud::Idempotency GetOperation(
      google::longrunning::GetOperationRequest const& request);
};

std::unique_ptr<ServingConfigServiceConnectionIdempotencyPolicy>
MakeDefaultServingConfigServiceConnectionIdempotencyPolicy();

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace retail_v2
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_RETAIL_V2_SERVING_CONFIG_CONNECTION_IDEMPOTENCY_POLICY_H
