// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/security/publicca/v1/service.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fsecurity_2fpublicca_2fv1_2fservice_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fsecurity_2fpublicca_2fv1_2fservice_2eproto__INCLUDED

#include "google/cloud/security/publicca/v1/service.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>
#include <grpcpp/ports_def.inc>

namespace google {
namespace cloud {
namespace security {
namespace publicca {
namespace v1 {

// Manages the resources required for ACME [external account
// binding](https://tools.ietf.org/html/rfc8555#section-7.3.4) for
// the public certificate authority service.
class PublicCertificateAuthorityService final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.security.publicca.v1.PublicCertificateAuthorityService";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Creates a new
    // [ExternalAccountKey][google.cloud.security.publicca.v1.ExternalAccountKey]
    // bound to the project.
    virtual ::grpc::Status CreateExternalAccountKey(::grpc::ClientContext* context, const ::google::cloud::security::publicca::v1::CreateExternalAccountKeyRequest& request, ::google::cloud::security::publicca::v1::ExternalAccountKey* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::security::publicca::v1::ExternalAccountKey>> AsyncCreateExternalAccountKey(::grpc::ClientContext* context, const ::google::cloud::security::publicca::v1::CreateExternalAccountKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::security::publicca::v1::ExternalAccountKey>>(AsyncCreateExternalAccountKeyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::security::publicca::v1::ExternalAccountKey>> PrepareAsyncCreateExternalAccountKey(::grpc::ClientContext* context, const ::google::cloud::security::publicca::v1::CreateExternalAccountKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::security::publicca::v1::ExternalAccountKey>>(PrepareAsyncCreateExternalAccountKeyRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Creates a new
      // [ExternalAccountKey][google.cloud.security.publicca.v1.ExternalAccountKey]
      // bound to the project.
      virtual void CreateExternalAccountKey(::grpc::ClientContext* context, const ::google::cloud::security::publicca::v1::CreateExternalAccountKeyRequest* request, ::google::cloud::security::publicca::v1::ExternalAccountKey* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateExternalAccountKey(::grpc::ClientContext* context, const ::google::cloud::security::publicca::v1::CreateExternalAccountKeyRequest* request, ::google::cloud::security::publicca::v1::ExternalAccountKey* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::security::publicca::v1::ExternalAccountKey>* AsyncCreateExternalAccountKeyRaw(::grpc::ClientContext* context, const ::google::cloud::security::publicca::v1::CreateExternalAccountKeyRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::security::publicca::v1::ExternalAccountKey>* PrepareAsyncCreateExternalAccountKeyRaw(::grpc::ClientContext* context, const ::google::cloud::security::publicca::v1::CreateExternalAccountKeyRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status CreateExternalAccountKey(::grpc::ClientContext* context, const ::google::cloud::security::publicca::v1::CreateExternalAccountKeyRequest& request, ::google::cloud::security::publicca::v1::ExternalAccountKey* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::security::publicca::v1::ExternalAccountKey>> AsyncCreateExternalAccountKey(::grpc::ClientContext* context, const ::google::cloud::security::publicca::v1::CreateExternalAccountKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::security::publicca::v1::ExternalAccountKey>>(AsyncCreateExternalAccountKeyRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::security::publicca::v1::ExternalAccountKey>> PrepareAsyncCreateExternalAccountKey(::grpc::ClientContext* context, const ::google::cloud::security::publicca::v1::CreateExternalAccountKeyRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::security::publicca::v1::ExternalAccountKey>>(PrepareAsyncCreateExternalAccountKeyRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void CreateExternalAccountKey(::grpc::ClientContext* context, const ::google::cloud::security::publicca::v1::CreateExternalAccountKeyRequest* request, ::google::cloud::security::publicca::v1::ExternalAccountKey* response, std::function<void(::grpc::Status)>) override;
      void CreateExternalAccountKey(::grpc::ClientContext* context, const ::google::cloud::security::publicca::v1::CreateExternalAccountKeyRequest* request, ::google::cloud::security::publicca::v1::ExternalAccountKey* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::security::publicca::v1::ExternalAccountKey>* AsyncCreateExternalAccountKeyRaw(::grpc::ClientContext* context, const ::google::cloud::security::publicca::v1::CreateExternalAccountKeyRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::security::publicca::v1::ExternalAccountKey>* PrepareAsyncCreateExternalAccountKeyRaw(::grpc::ClientContext* context, const ::google::cloud::security::publicca::v1::CreateExternalAccountKeyRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_CreateExternalAccountKey_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Creates a new
    // [ExternalAccountKey][google.cloud.security.publicca.v1.ExternalAccountKey]
    // bound to the project.
    virtual ::grpc::Status CreateExternalAccountKey(::grpc::ServerContext* context, const ::google::cloud::security::publicca::v1::CreateExternalAccountKeyRequest* request, ::google::cloud::security::publicca::v1::ExternalAccountKey* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateExternalAccountKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateExternalAccountKey() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_CreateExternalAccountKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateExternalAccountKey(::grpc::ServerContext* /*context*/, const ::google::cloud::security::publicca::v1::CreateExternalAccountKeyRequest* /*request*/, ::google::cloud::security::publicca::v1::ExternalAccountKey* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateExternalAccountKey(::grpc::ServerContext* context, ::google::cloud::security::publicca::v1::CreateExternalAccountKeyRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::security::publicca::v1::ExternalAccountKey>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_CreateExternalAccountKey<Service > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_CreateExternalAccountKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateExternalAccountKey() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::security::publicca::v1::CreateExternalAccountKeyRequest, ::google::cloud::security::publicca::v1::ExternalAccountKey>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::security::publicca::v1::CreateExternalAccountKeyRequest* request, ::google::cloud::security::publicca::v1::ExternalAccountKey* response) { return this->CreateExternalAccountKey(context, request, response); }));}
    void SetMessageAllocatorFor_CreateExternalAccountKey(
        ::grpc::MessageAllocator< ::google::cloud::security::publicca::v1::CreateExternalAccountKeyRequest, ::google::cloud::security::publicca::v1::ExternalAccountKey>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::security::publicca::v1::CreateExternalAccountKeyRequest, ::google::cloud::security::publicca::v1::ExternalAccountKey>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateExternalAccountKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateExternalAccountKey(::grpc::ServerContext* /*context*/, const ::google::cloud::security::publicca::v1::CreateExternalAccountKeyRequest* /*request*/, ::google::cloud::security::publicca::v1::ExternalAccountKey* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateExternalAccountKey(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::security::publicca::v1::CreateExternalAccountKeyRequest* /*request*/, ::google::cloud::security::publicca::v1::ExternalAccountKey* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_CreateExternalAccountKey<Service > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_CreateExternalAccountKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateExternalAccountKey() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_CreateExternalAccountKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateExternalAccountKey(::grpc::ServerContext* /*context*/, const ::google::cloud::security::publicca::v1::CreateExternalAccountKeyRequest* /*request*/, ::google::cloud::security::publicca::v1::ExternalAccountKey* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateExternalAccountKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateExternalAccountKey() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_CreateExternalAccountKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateExternalAccountKey(::grpc::ServerContext* /*context*/, const ::google::cloud::security::publicca::v1::CreateExternalAccountKeyRequest* /*request*/, ::google::cloud::security::publicca::v1::ExternalAccountKey* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateExternalAccountKey(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateExternalAccountKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateExternalAccountKey() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateExternalAccountKey(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateExternalAccountKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateExternalAccountKey(::grpc::ServerContext* /*context*/, const ::google::cloud::security::publicca::v1::CreateExternalAccountKeyRequest* /*request*/, ::google::cloud::security::publicca::v1::ExternalAccountKey* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateExternalAccountKey(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateExternalAccountKey : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateExternalAccountKey() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::security::publicca::v1::CreateExternalAccountKeyRequest, ::google::cloud::security::publicca::v1::ExternalAccountKey>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::security::publicca::v1::CreateExternalAccountKeyRequest, ::google::cloud::security::publicca::v1::ExternalAccountKey>* streamer) {
                       return this->StreamedCreateExternalAccountKey(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateExternalAccountKey() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateExternalAccountKey(::grpc::ServerContext* /*context*/, const ::google::cloud::security::publicca::v1::CreateExternalAccountKeyRequest* /*request*/, ::google::cloud::security::publicca::v1::ExternalAccountKey* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateExternalAccountKey(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::security::publicca::v1::CreateExternalAccountKeyRequest,::google::cloud::security::publicca::v1::ExternalAccountKey>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_CreateExternalAccountKey<Service > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_CreateExternalAccountKey<Service > StreamedService;
};

}  // namespace v1
}  // namespace publicca
}  // namespace security
}  // namespace cloud
}  // namespace google


#include <grpcpp/ports_undef.inc>
#endif  // GRPC_google_2fcloud_2fsecurity_2fpublicca_2fv1_2fservice_2eproto__INCLUDED
