// Copyright 2023 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//      https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

// Generated by the Codegen C++ plugin.
// If you make any local changes, they will be lost.
// source: google/cloud/support/v2/comment_service.proto

#ifndef GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_SUPPORT_V2_INTERNAL_COMMENT_STUB_H
#define GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_SUPPORT_V2_INTERNAL_COMMENT_STUB_H

#include "google/cloud/options.h"
#include "google/cloud/status_or.h"
#include "google/cloud/version.h"
#include <google/cloud/support/v2/comment_service.grpc.pb.h>
#include <memory>
#include <utility>

namespace google {
namespace cloud {
namespace support_v2_internal {
GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_BEGIN

class CommentServiceStub {
 public:
  virtual ~CommentServiceStub() = 0;

  virtual StatusOr<google::cloud::support::v2::ListCommentsResponse>
  ListComments(
      grpc::ClientContext& context, Options const& options,
      google::cloud::support::v2::ListCommentsRequest const& request) = 0;

  virtual StatusOr<google::cloud::support::v2::Comment> CreateComment(
      grpc::ClientContext& context, Options const& options,
      google::cloud::support::v2::CreateCommentRequest const& request) = 0;
};

class DefaultCommentServiceStub : public CommentServiceStub {
 public:
  explicit DefaultCommentServiceStub(
      std::unique_ptr<google::cloud::support::v2::CommentService::StubInterface>
          grpc_stub)
      : grpc_stub_(std::move(grpc_stub)) {}

  StatusOr<google::cloud::support::v2::ListCommentsResponse> ListComments(
      grpc::ClientContext& context, Options const& options,
      google::cloud::support::v2::ListCommentsRequest const& request) override;

  StatusOr<google::cloud::support::v2::Comment> CreateComment(
      grpc::ClientContext& context, Options const& options,
      google::cloud::support::v2::CreateCommentRequest const& request) override;

 private:
  std::unique_ptr<google::cloud::support::v2::CommentService::StubInterface>
      grpc_stub_;
};

GOOGLE_CLOUD_CPP_INLINE_NAMESPACE_END
}  // namespace support_v2_internal
}  // namespace cloud
}  // namespace google

#endif  // GOOGLE_CLOUD_CPP_GOOGLE_CLOUD_SUPPORT_V2_INTERNAL_COMMENT_STUB_H
