// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/workflows/v1/workflows.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fworkflows_2fv1_2fworkflows_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fworkflows_2fv1_2fworkflows_2eproto__INCLUDED

#include "google/cloud/workflows/v1/workflows.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>
#include <grpcpp/ports_def.inc>

namespace google {
namespace cloud {
namespace workflows {
namespace v1 {

// Workflows is used to deploy and execute workflow programs.
// Workflows makes sure the program executes reliably, despite hardware and
// networking interruptions.
class Workflows final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.workflows.v1.Workflows";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Lists workflows in a given project and location.
    // The default order is not specified.
    virtual ::grpc::Status ListWorkflows(::grpc::ClientContext* context, const ::google::cloud::workflows::v1::ListWorkflowsRequest& request, ::google::cloud::workflows::v1::ListWorkflowsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::workflows::v1::ListWorkflowsResponse>> AsyncListWorkflows(::grpc::ClientContext* context, const ::google::cloud::workflows::v1::ListWorkflowsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::workflows::v1::ListWorkflowsResponse>>(AsyncListWorkflowsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::workflows::v1::ListWorkflowsResponse>> PrepareAsyncListWorkflows(::grpc::ClientContext* context, const ::google::cloud::workflows::v1::ListWorkflowsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::workflows::v1::ListWorkflowsResponse>>(PrepareAsyncListWorkflowsRaw(context, request, cq));
    }
    // Gets details of a single workflow.
    virtual ::grpc::Status GetWorkflow(::grpc::ClientContext* context, const ::google::cloud::workflows::v1::GetWorkflowRequest& request, ::google::cloud::workflows::v1::Workflow* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::workflows::v1::Workflow>> AsyncGetWorkflow(::grpc::ClientContext* context, const ::google::cloud::workflows::v1::GetWorkflowRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::workflows::v1::Workflow>>(AsyncGetWorkflowRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::workflows::v1::Workflow>> PrepareAsyncGetWorkflow(::grpc::ClientContext* context, const ::google::cloud::workflows::v1::GetWorkflowRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::workflows::v1::Workflow>>(PrepareAsyncGetWorkflowRaw(context, request, cq));
    }
    // Creates a new workflow. If a workflow with the specified name already
    // exists in the specified project and location, the long running operation
    // returns a [ALREADY_EXISTS][google.rpc.Code.ALREADY_EXISTS] error.
    virtual ::grpc::Status CreateWorkflow(::grpc::ClientContext* context, const ::google::cloud::workflows::v1::CreateWorkflowRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateWorkflow(::grpc::ClientContext* context, const ::google::cloud::workflows::v1::CreateWorkflowRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateWorkflowRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateWorkflow(::grpc::ClientContext* context, const ::google::cloud::workflows::v1::CreateWorkflowRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateWorkflowRaw(context, request, cq));
    }
    // Deletes a workflow with the specified name.
    // This method also cancels and deletes all running executions of the
    // workflow.
    virtual ::grpc::Status DeleteWorkflow(::grpc::ClientContext* context, const ::google::cloud::workflows::v1::DeleteWorkflowRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteWorkflow(::grpc::ClientContext* context, const ::google::cloud::workflows::v1::DeleteWorkflowRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteWorkflowRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteWorkflow(::grpc::ClientContext* context, const ::google::cloud::workflows::v1::DeleteWorkflowRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteWorkflowRaw(context, request, cq));
    }
    // Updates an existing workflow.
    // Running this method has no impact on already running executions of the
    // workflow. A new revision of the workflow might be created as a result of a
    // successful update operation. In that case, the new revision is used
    // in new workflow executions.
    virtual ::grpc::Status UpdateWorkflow(::grpc::ClientContext* context, const ::google::cloud::workflows::v1::UpdateWorkflowRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateWorkflow(::grpc::ClientContext* context, const ::google::cloud::workflows::v1::UpdateWorkflowRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateWorkflowRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateWorkflow(::grpc::ClientContext* context, const ::google::cloud::workflows::v1::UpdateWorkflowRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateWorkflowRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Lists workflows in a given project and location.
      // The default order is not specified.
      virtual void ListWorkflows(::grpc::ClientContext* context, const ::google::cloud::workflows::v1::ListWorkflowsRequest* request, ::google::cloud::workflows::v1::ListWorkflowsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListWorkflows(::grpc::ClientContext* context, const ::google::cloud::workflows::v1::ListWorkflowsRequest* request, ::google::cloud::workflows::v1::ListWorkflowsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Gets details of a single workflow.
      virtual void GetWorkflow(::grpc::ClientContext* context, const ::google::cloud::workflows::v1::GetWorkflowRequest* request, ::google::cloud::workflows::v1::Workflow* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetWorkflow(::grpc::ClientContext* context, const ::google::cloud::workflows::v1::GetWorkflowRequest* request, ::google::cloud::workflows::v1::Workflow* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a new workflow. If a workflow with the specified name already
      // exists in the specified project and location, the long running operation
      // returns a [ALREADY_EXISTS][google.rpc.Code.ALREADY_EXISTS] error.
      virtual void CreateWorkflow(::grpc::ClientContext* context, const ::google::cloud::workflows::v1::CreateWorkflowRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateWorkflow(::grpc::ClientContext* context, const ::google::cloud::workflows::v1::CreateWorkflowRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes a workflow with the specified name.
      // This method also cancels and deletes all running executions of the
      // workflow.
      virtual void DeleteWorkflow(::grpc::ClientContext* context, const ::google::cloud::workflows::v1::DeleteWorkflowRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteWorkflow(::grpc::ClientContext* context, const ::google::cloud::workflows::v1::DeleteWorkflowRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates an existing workflow.
      // Running this method has no impact on already running executions of the
      // workflow. A new revision of the workflow might be created as a result of a
      // successful update operation. In that case, the new revision is used
      // in new workflow executions.
      virtual void UpdateWorkflow(::grpc::ClientContext* context, const ::google::cloud::workflows::v1::UpdateWorkflowRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateWorkflow(::grpc::ClientContext* context, const ::google::cloud::workflows::v1::UpdateWorkflowRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::workflows::v1::ListWorkflowsResponse>* AsyncListWorkflowsRaw(::grpc::ClientContext* context, const ::google::cloud::workflows::v1::ListWorkflowsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::workflows::v1::ListWorkflowsResponse>* PrepareAsyncListWorkflowsRaw(::grpc::ClientContext* context, const ::google::cloud::workflows::v1::ListWorkflowsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::workflows::v1::Workflow>* AsyncGetWorkflowRaw(::grpc::ClientContext* context, const ::google::cloud::workflows::v1::GetWorkflowRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::workflows::v1::Workflow>* PrepareAsyncGetWorkflowRaw(::grpc::ClientContext* context, const ::google::cloud::workflows::v1::GetWorkflowRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateWorkflowRaw(::grpc::ClientContext* context, const ::google::cloud::workflows::v1::CreateWorkflowRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateWorkflowRaw(::grpc::ClientContext* context, const ::google::cloud::workflows::v1::CreateWorkflowRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteWorkflowRaw(::grpc::ClientContext* context, const ::google::cloud::workflows::v1::DeleteWorkflowRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteWorkflowRaw(::grpc::ClientContext* context, const ::google::cloud::workflows::v1::DeleteWorkflowRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateWorkflowRaw(::grpc::ClientContext* context, const ::google::cloud::workflows::v1::UpdateWorkflowRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateWorkflowRaw(::grpc::ClientContext* context, const ::google::cloud::workflows::v1::UpdateWorkflowRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status ListWorkflows(::grpc::ClientContext* context, const ::google::cloud::workflows::v1::ListWorkflowsRequest& request, ::google::cloud::workflows::v1::ListWorkflowsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::workflows::v1::ListWorkflowsResponse>> AsyncListWorkflows(::grpc::ClientContext* context, const ::google::cloud::workflows::v1::ListWorkflowsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::workflows::v1::ListWorkflowsResponse>>(AsyncListWorkflowsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::workflows::v1::ListWorkflowsResponse>> PrepareAsyncListWorkflows(::grpc::ClientContext* context, const ::google::cloud::workflows::v1::ListWorkflowsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::workflows::v1::ListWorkflowsResponse>>(PrepareAsyncListWorkflowsRaw(context, request, cq));
    }
    ::grpc::Status GetWorkflow(::grpc::ClientContext* context, const ::google::cloud::workflows::v1::GetWorkflowRequest& request, ::google::cloud::workflows::v1::Workflow* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::workflows::v1::Workflow>> AsyncGetWorkflow(::grpc::ClientContext* context, const ::google::cloud::workflows::v1::GetWorkflowRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::workflows::v1::Workflow>>(AsyncGetWorkflowRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::workflows::v1::Workflow>> PrepareAsyncGetWorkflow(::grpc::ClientContext* context, const ::google::cloud::workflows::v1::GetWorkflowRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::workflows::v1::Workflow>>(PrepareAsyncGetWorkflowRaw(context, request, cq));
    }
    ::grpc::Status CreateWorkflow(::grpc::ClientContext* context, const ::google::cloud::workflows::v1::CreateWorkflowRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateWorkflow(::grpc::ClientContext* context, const ::google::cloud::workflows::v1::CreateWorkflowRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateWorkflowRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateWorkflow(::grpc::ClientContext* context, const ::google::cloud::workflows::v1::CreateWorkflowRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateWorkflowRaw(context, request, cq));
    }
    ::grpc::Status DeleteWorkflow(::grpc::ClientContext* context, const ::google::cloud::workflows::v1::DeleteWorkflowRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteWorkflow(::grpc::ClientContext* context, const ::google::cloud::workflows::v1::DeleteWorkflowRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteWorkflowRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteWorkflow(::grpc::ClientContext* context, const ::google::cloud::workflows::v1::DeleteWorkflowRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteWorkflowRaw(context, request, cq));
    }
    ::grpc::Status UpdateWorkflow(::grpc::ClientContext* context, const ::google::cloud::workflows::v1::UpdateWorkflowRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateWorkflow(::grpc::ClientContext* context, const ::google::cloud::workflows::v1::UpdateWorkflowRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateWorkflowRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateWorkflow(::grpc::ClientContext* context, const ::google::cloud::workflows::v1::UpdateWorkflowRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateWorkflowRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void ListWorkflows(::grpc::ClientContext* context, const ::google::cloud::workflows::v1::ListWorkflowsRequest* request, ::google::cloud::workflows::v1::ListWorkflowsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListWorkflows(::grpc::ClientContext* context, const ::google::cloud::workflows::v1::ListWorkflowsRequest* request, ::google::cloud::workflows::v1::ListWorkflowsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetWorkflow(::grpc::ClientContext* context, const ::google::cloud::workflows::v1::GetWorkflowRequest* request, ::google::cloud::workflows::v1::Workflow* response, std::function<void(::grpc::Status)>) override;
      void GetWorkflow(::grpc::ClientContext* context, const ::google::cloud::workflows::v1::GetWorkflowRequest* request, ::google::cloud::workflows::v1::Workflow* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateWorkflow(::grpc::ClientContext* context, const ::google::cloud::workflows::v1::CreateWorkflowRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateWorkflow(::grpc::ClientContext* context, const ::google::cloud::workflows::v1::CreateWorkflowRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteWorkflow(::grpc::ClientContext* context, const ::google::cloud::workflows::v1::DeleteWorkflowRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteWorkflow(::grpc::ClientContext* context, const ::google::cloud::workflows::v1::DeleteWorkflowRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateWorkflow(::grpc::ClientContext* context, const ::google::cloud::workflows::v1::UpdateWorkflowRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateWorkflow(::grpc::ClientContext* context, const ::google::cloud::workflows::v1::UpdateWorkflowRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::cloud::workflows::v1::ListWorkflowsResponse>* AsyncListWorkflowsRaw(::grpc::ClientContext* context, const ::google::cloud::workflows::v1::ListWorkflowsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::workflows::v1::ListWorkflowsResponse>* PrepareAsyncListWorkflowsRaw(::grpc::ClientContext* context, const ::google::cloud::workflows::v1::ListWorkflowsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::workflows::v1::Workflow>* AsyncGetWorkflowRaw(::grpc::ClientContext* context, const ::google::cloud::workflows::v1::GetWorkflowRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::workflows::v1::Workflow>* PrepareAsyncGetWorkflowRaw(::grpc::ClientContext* context, const ::google::cloud::workflows::v1::GetWorkflowRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateWorkflowRaw(::grpc::ClientContext* context, const ::google::cloud::workflows::v1::CreateWorkflowRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateWorkflowRaw(::grpc::ClientContext* context, const ::google::cloud::workflows::v1::CreateWorkflowRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteWorkflowRaw(::grpc::ClientContext* context, const ::google::cloud::workflows::v1::DeleteWorkflowRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteWorkflowRaw(::grpc::ClientContext* context, const ::google::cloud::workflows::v1::DeleteWorkflowRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateWorkflowRaw(::grpc::ClientContext* context, const ::google::cloud::workflows::v1::UpdateWorkflowRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateWorkflowRaw(::grpc::ClientContext* context, const ::google::cloud::workflows::v1::UpdateWorkflowRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_ListWorkflows_;
    const ::grpc::internal::RpcMethod rpcmethod_GetWorkflow_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateWorkflow_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteWorkflow_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateWorkflow_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Lists workflows in a given project and location.
    // The default order is not specified.
    virtual ::grpc::Status ListWorkflows(::grpc::ServerContext* context, const ::google::cloud::workflows::v1::ListWorkflowsRequest* request, ::google::cloud::workflows::v1::ListWorkflowsResponse* response);
    // Gets details of a single workflow.
    virtual ::grpc::Status GetWorkflow(::grpc::ServerContext* context, const ::google::cloud::workflows::v1::GetWorkflowRequest* request, ::google::cloud::workflows::v1::Workflow* response);
    // Creates a new workflow. If a workflow with the specified name already
    // exists in the specified project and location, the long running operation
    // returns a [ALREADY_EXISTS][google.rpc.Code.ALREADY_EXISTS] error.
    virtual ::grpc::Status CreateWorkflow(::grpc::ServerContext* context, const ::google::cloud::workflows::v1::CreateWorkflowRequest* request, ::google::longrunning::Operation* response);
    // Deletes a workflow with the specified name.
    // This method also cancels and deletes all running executions of the
    // workflow.
    virtual ::grpc::Status DeleteWorkflow(::grpc::ServerContext* context, const ::google::cloud::workflows::v1::DeleteWorkflowRequest* request, ::google::longrunning::Operation* response);
    // Updates an existing workflow.
    // Running this method has no impact on already running executions of the
    // workflow. A new revision of the workflow might be created as a result of a
    // successful update operation. In that case, the new revision is used
    // in new workflow executions.
    virtual ::grpc::Status UpdateWorkflow(::grpc::ServerContext* context, const ::google::cloud::workflows::v1::UpdateWorkflowRequest* request, ::google::longrunning::Operation* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_ListWorkflows : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListWorkflows() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_ListWorkflows() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListWorkflows(::grpc::ServerContext* /*context*/, const ::google::cloud::workflows::v1::ListWorkflowsRequest* /*request*/, ::google::cloud::workflows::v1::ListWorkflowsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListWorkflows(::grpc::ServerContext* context, ::google::cloud::workflows::v1::ListWorkflowsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::workflows::v1::ListWorkflowsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetWorkflow : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetWorkflow() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_GetWorkflow() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetWorkflow(::grpc::ServerContext* /*context*/, const ::google::cloud::workflows::v1::GetWorkflowRequest* /*request*/, ::google::cloud::workflows::v1::Workflow* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetWorkflow(::grpc::ServerContext* context, ::google::cloud::workflows::v1::GetWorkflowRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::workflows::v1::Workflow>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateWorkflow : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateWorkflow() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_CreateWorkflow() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateWorkflow(::grpc::ServerContext* /*context*/, const ::google::cloud::workflows::v1::CreateWorkflowRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateWorkflow(::grpc::ServerContext* context, ::google::cloud::workflows::v1::CreateWorkflowRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteWorkflow : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteWorkflow() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_DeleteWorkflow() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteWorkflow(::grpc::ServerContext* /*context*/, const ::google::cloud::workflows::v1::DeleteWorkflowRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteWorkflow(::grpc::ServerContext* context, ::google::cloud::workflows::v1::DeleteWorkflowRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateWorkflow : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateWorkflow() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_UpdateWorkflow() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateWorkflow(::grpc::ServerContext* /*context*/, const ::google::cloud::workflows::v1::UpdateWorkflowRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateWorkflow(::grpc::ServerContext* context, ::google::cloud::workflows::v1::UpdateWorkflowRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_ListWorkflows<WithAsyncMethod_GetWorkflow<WithAsyncMethod_CreateWorkflow<WithAsyncMethod_DeleteWorkflow<WithAsyncMethod_UpdateWorkflow<Service > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_ListWorkflows : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListWorkflows() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::workflows::v1::ListWorkflowsRequest, ::google::cloud::workflows::v1::ListWorkflowsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::workflows::v1::ListWorkflowsRequest* request, ::google::cloud::workflows::v1::ListWorkflowsResponse* response) { return this->ListWorkflows(context, request, response); }));}
    void SetMessageAllocatorFor_ListWorkflows(
        ::grpc::MessageAllocator< ::google::cloud::workflows::v1::ListWorkflowsRequest, ::google::cloud::workflows::v1::ListWorkflowsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::workflows::v1::ListWorkflowsRequest, ::google::cloud::workflows::v1::ListWorkflowsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListWorkflows() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListWorkflows(::grpc::ServerContext* /*context*/, const ::google::cloud::workflows::v1::ListWorkflowsRequest* /*request*/, ::google::cloud::workflows::v1::ListWorkflowsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListWorkflows(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::workflows::v1::ListWorkflowsRequest* /*request*/, ::google::cloud::workflows::v1::ListWorkflowsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetWorkflow : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetWorkflow() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::workflows::v1::GetWorkflowRequest, ::google::cloud::workflows::v1::Workflow>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::workflows::v1::GetWorkflowRequest* request, ::google::cloud::workflows::v1::Workflow* response) { return this->GetWorkflow(context, request, response); }));}
    void SetMessageAllocatorFor_GetWorkflow(
        ::grpc::MessageAllocator< ::google::cloud::workflows::v1::GetWorkflowRequest, ::google::cloud::workflows::v1::Workflow>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::workflows::v1::GetWorkflowRequest, ::google::cloud::workflows::v1::Workflow>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetWorkflow() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetWorkflow(::grpc::ServerContext* /*context*/, const ::google::cloud::workflows::v1::GetWorkflowRequest* /*request*/, ::google::cloud::workflows::v1::Workflow* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetWorkflow(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::workflows::v1::GetWorkflowRequest* /*request*/, ::google::cloud::workflows::v1::Workflow* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateWorkflow : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateWorkflow() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::workflows::v1::CreateWorkflowRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::workflows::v1::CreateWorkflowRequest* request, ::google::longrunning::Operation* response) { return this->CreateWorkflow(context, request, response); }));}
    void SetMessageAllocatorFor_CreateWorkflow(
        ::grpc::MessageAllocator< ::google::cloud::workflows::v1::CreateWorkflowRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::workflows::v1::CreateWorkflowRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateWorkflow() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateWorkflow(::grpc::ServerContext* /*context*/, const ::google::cloud::workflows::v1::CreateWorkflowRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateWorkflow(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::workflows::v1::CreateWorkflowRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteWorkflow : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteWorkflow() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::workflows::v1::DeleteWorkflowRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::workflows::v1::DeleteWorkflowRequest* request, ::google::longrunning::Operation* response) { return this->DeleteWorkflow(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteWorkflow(
        ::grpc::MessageAllocator< ::google::cloud::workflows::v1::DeleteWorkflowRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::workflows::v1::DeleteWorkflowRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteWorkflow() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteWorkflow(::grpc::ServerContext* /*context*/, const ::google::cloud::workflows::v1::DeleteWorkflowRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteWorkflow(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::workflows::v1::DeleteWorkflowRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateWorkflow : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateWorkflow() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::workflows::v1::UpdateWorkflowRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::workflows::v1::UpdateWorkflowRequest* request, ::google::longrunning::Operation* response) { return this->UpdateWorkflow(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateWorkflow(
        ::grpc::MessageAllocator< ::google::cloud::workflows::v1::UpdateWorkflowRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::workflows::v1::UpdateWorkflowRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateWorkflow() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateWorkflow(::grpc::ServerContext* /*context*/, const ::google::cloud::workflows::v1::UpdateWorkflowRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateWorkflow(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::workflows::v1::UpdateWorkflowRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_ListWorkflows<WithCallbackMethod_GetWorkflow<WithCallbackMethod_CreateWorkflow<WithCallbackMethod_DeleteWorkflow<WithCallbackMethod_UpdateWorkflow<Service > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_ListWorkflows : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListWorkflows() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_ListWorkflows() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListWorkflows(::grpc::ServerContext* /*context*/, const ::google::cloud::workflows::v1::ListWorkflowsRequest* /*request*/, ::google::cloud::workflows::v1::ListWorkflowsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetWorkflow : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetWorkflow() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_GetWorkflow() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetWorkflow(::grpc::ServerContext* /*context*/, const ::google::cloud::workflows::v1::GetWorkflowRequest* /*request*/, ::google::cloud::workflows::v1::Workflow* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateWorkflow : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateWorkflow() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_CreateWorkflow() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateWorkflow(::grpc::ServerContext* /*context*/, const ::google::cloud::workflows::v1::CreateWorkflowRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteWorkflow : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteWorkflow() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_DeleteWorkflow() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteWorkflow(::grpc::ServerContext* /*context*/, const ::google::cloud::workflows::v1::DeleteWorkflowRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateWorkflow : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateWorkflow() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_UpdateWorkflow() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateWorkflow(::grpc::ServerContext* /*context*/, const ::google::cloud::workflows::v1::UpdateWorkflowRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListWorkflows : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListWorkflows() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_ListWorkflows() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListWorkflows(::grpc::ServerContext* /*context*/, const ::google::cloud::workflows::v1::ListWorkflowsRequest* /*request*/, ::google::cloud::workflows::v1::ListWorkflowsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListWorkflows(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetWorkflow : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetWorkflow() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_GetWorkflow() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetWorkflow(::grpc::ServerContext* /*context*/, const ::google::cloud::workflows::v1::GetWorkflowRequest* /*request*/, ::google::cloud::workflows::v1::Workflow* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetWorkflow(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateWorkflow : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateWorkflow() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_CreateWorkflow() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateWorkflow(::grpc::ServerContext* /*context*/, const ::google::cloud::workflows::v1::CreateWorkflowRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateWorkflow(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteWorkflow : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteWorkflow() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_DeleteWorkflow() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteWorkflow(::grpc::ServerContext* /*context*/, const ::google::cloud::workflows::v1::DeleteWorkflowRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteWorkflow(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateWorkflow : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateWorkflow() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_UpdateWorkflow() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateWorkflow(::grpc::ServerContext* /*context*/, const ::google::cloud::workflows::v1::UpdateWorkflowRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateWorkflow(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListWorkflows : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListWorkflows() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListWorkflows(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListWorkflows() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListWorkflows(::grpc::ServerContext* /*context*/, const ::google::cloud::workflows::v1::ListWorkflowsRequest* /*request*/, ::google::cloud::workflows::v1::ListWorkflowsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListWorkflows(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetWorkflow : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetWorkflow() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetWorkflow(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetWorkflow() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetWorkflow(::grpc::ServerContext* /*context*/, const ::google::cloud::workflows::v1::GetWorkflowRequest* /*request*/, ::google::cloud::workflows::v1::Workflow* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetWorkflow(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateWorkflow : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateWorkflow() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateWorkflow(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateWorkflow() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateWorkflow(::grpc::ServerContext* /*context*/, const ::google::cloud::workflows::v1::CreateWorkflowRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateWorkflow(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteWorkflow : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteWorkflow() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteWorkflow(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteWorkflow() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteWorkflow(::grpc::ServerContext* /*context*/, const ::google::cloud::workflows::v1::DeleteWorkflowRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteWorkflow(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateWorkflow : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateWorkflow() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateWorkflow(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateWorkflow() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateWorkflow(::grpc::ServerContext* /*context*/, const ::google::cloud::workflows::v1::UpdateWorkflowRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateWorkflow(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListWorkflows : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListWorkflows() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::workflows::v1::ListWorkflowsRequest, ::google::cloud::workflows::v1::ListWorkflowsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::workflows::v1::ListWorkflowsRequest, ::google::cloud::workflows::v1::ListWorkflowsResponse>* streamer) {
                       return this->StreamedListWorkflows(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListWorkflows() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListWorkflows(::grpc::ServerContext* /*context*/, const ::google::cloud::workflows::v1::ListWorkflowsRequest* /*request*/, ::google::cloud::workflows::v1::ListWorkflowsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListWorkflows(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::workflows::v1::ListWorkflowsRequest,::google::cloud::workflows::v1::ListWorkflowsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetWorkflow : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetWorkflow() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::workflows::v1::GetWorkflowRequest, ::google::cloud::workflows::v1::Workflow>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::workflows::v1::GetWorkflowRequest, ::google::cloud::workflows::v1::Workflow>* streamer) {
                       return this->StreamedGetWorkflow(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetWorkflow() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetWorkflow(::grpc::ServerContext* /*context*/, const ::google::cloud::workflows::v1::GetWorkflowRequest* /*request*/, ::google::cloud::workflows::v1::Workflow* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetWorkflow(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::workflows::v1::GetWorkflowRequest,::google::cloud::workflows::v1::Workflow>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateWorkflow : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateWorkflow() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::workflows::v1::CreateWorkflowRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::workflows::v1::CreateWorkflowRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateWorkflow(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateWorkflow() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateWorkflow(::grpc::ServerContext* /*context*/, const ::google::cloud::workflows::v1::CreateWorkflowRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateWorkflow(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::workflows::v1::CreateWorkflowRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteWorkflow : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteWorkflow() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::workflows::v1::DeleteWorkflowRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::workflows::v1::DeleteWorkflowRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteWorkflow(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteWorkflow() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteWorkflow(::grpc::ServerContext* /*context*/, const ::google::cloud::workflows::v1::DeleteWorkflowRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteWorkflow(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::workflows::v1::DeleteWorkflowRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateWorkflow : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateWorkflow() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::workflows::v1::UpdateWorkflowRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::workflows::v1::UpdateWorkflowRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateWorkflow(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateWorkflow() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateWorkflow(::grpc::ServerContext* /*context*/, const ::google::cloud::workflows::v1::UpdateWorkflowRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateWorkflow(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::workflows::v1::UpdateWorkflowRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_ListWorkflows<WithStreamedUnaryMethod_GetWorkflow<WithStreamedUnaryMethod_CreateWorkflow<WithStreamedUnaryMethod_DeleteWorkflow<WithStreamedUnaryMethod_UpdateWorkflow<Service > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_ListWorkflows<WithStreamedUnaryMethod_GetWorkflow<WithStreamedUnaryMethod_CreateWorkflow<WithStreamedUnaryMethod_DeleteWorkflow<WithStreamedUnaryMethod_UpdateWorkflow<Service > > > > > StreamedService;
};

}  // namespace v1
}  // namespace workflows
}  // namespace cloud
}  // namespace google


#include <grpcpp/ports_undef.inc>
#endif  // GRPC_google_2fcloud_2fworkflows_2fv1_2fworkflows_2eproto__INCLUDED
