// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: google/cloud/video/livestream/v1/service.proto
// Original file comments:
// Copyright 2024 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
#ifndef GRPC_google_2fcloud_2fvideo_2flivestream_2fv1_2fservice_2eproto__INCLUDED
#define GRPC_google_2fcloud_2fvideo_2flivestream_2fv1_2fservice_2eproto__INCLUDED

#include "google/cloud/video/livestream/v1/service.pb.h"

#include <functional>
#include <grpcpp/generic/async_generic_service.h>
#include <grpcpp/support/async_stream.h>
#include <grpcpp/support/async_unary_call.h>
#include <grpcpp/support/client_callback.h>
#include <grpcpp/client_context.h>
#include <grpcpp/completion_queue.h>
#include <grpcpp/support/message_allocator.h>
#include <grpcpp/support/method_handler.h>
#include <grpcpp/impl/proto_utils.h>
#include <grpcpp/impl/rpc_method.h>
#include <grpcpp/support/server_callback.h>
#include <grpcpp/impl/server_callback_handlers.h>
#include <grpcpp/server_context.h>
#include <grpcpp/impl/service_type.h>
#include <grpcpp/support/status.h>
#include <grpcpp/support/stub_options.h>
#include <grpcpp/support/sync_stream.h>
#include <grpcpp/ports_def.inc>

namespace google {
namespace cloud {
namespace video {
namespace livestream {
namespace v1 {

// Using Live Stream API, you can generate live streams in the various
// renditions and streaming formats. The streaming format include HTTP Live
// Streaming (HLS) and Dynamic Adaptive Streaming over HTTP (DASH). You can send
// a source stream in the various ways, including Real-Time Messaging
// Protocol (RTMP) and Secure Reliable Transport (SRT).
class LivestreamService final {
 public:
  static constexpr char const* service_full_name() {
    return "google.cloud.video.livestream.v1.LivestreamService";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    // Creates a channel with the provided unique ID in the specified
    // region.
    virtual ::grpc::Status CreateChannel(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::CreateChannelRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateChannel(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::CreateChannelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateChannelRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateChannel(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::CreateChannelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateChannelRaw(context, request, cq));
    }
    // Returns a list of all channels in the specified region.
    virtual ::grpc::Status ListChannels(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::ListChannelsRequest& request, ::google::cloud::video::livestream::v1::ListChannelsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::livestream::v1::ListChannelsResponse>> AsyncListChannels(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::ListChannelsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::livestream::v1::ListChannelsResponse>>(AsyncListChannelsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::livestream::v1::ListChannelsResponse>> PrepareAsyncListChannels(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::ListChannelsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::livestream::v1::ListChannelsResponse>>(PrepareAsyncListChannelsRaw(context, request, cq));
    }
    // Returns the specified channel.
    virtual ::grpc::Status GetChannel(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetChannelRequest& request, ::google::cloud::video::livestream::v1::Channel* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::livestream::v1::Channel>> AsyncGetChannel(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetChannelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::livestream::v1::Channel>>(AsyncGetChannelRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::livestream::v1::Channel>> PrepareAsyncGetChannel(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetChannelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::livestream::v1::Channel>>(PrepareAsyncGetChannelRaw(context, request, cq));
    }
    // Deletes the specified channel.
    virtual ::grpc::Status DeleteChannel(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::DeleteChannelRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteChannel(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::DeleteChannelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteChannelRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteChannel(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::DeleteChannelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteChannelRaw(context, request, cq));
    }
    // Updates the specified channel.
    virtual ::grpc::Status UpdateChannel(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::UpdateChannelRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateChannel(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::UpdateChannelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateChannelRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateChannel(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::UpdateChannelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateChannelRaw(context, request, cq));
    }
    // Starts the specified channel. Part of the video pipeline will be created
    // only when the StartChannel request is received by the server.
    virtual ::grpc::Status StartChannel(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::StartChannelRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncStartChannel(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::StartChannelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncStartChannelRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncStartChannel(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::StartChannelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncStartChannelRaw(context, request, cq));
    }
    // Stops the specified channel. Part of the video pipeline will be released
    // when the StopChannel request is received by the server.
    virtual ::grpc::Status StopChannel(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::StopChannelRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncStopChannel(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::StopChannelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncStopChannelRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncStopChannel(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::StopChannelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncStopChannelRaw(context, request, cq));
    }
    // Creates an input with the provided unique ID in the specified region.
    virtual ::grpc::Status CreateInput(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::CreateInputRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateInput(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::CreateInputRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateInputRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateInput(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::CreateInputRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateInputRaw(context, request, cq));
    }
    // Returns a list of all inputs in the specified region.
    virtual ::grpc::Status ListInputs(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::ListInputsRequest& request, ::google::cloud::video::livestream::v1::ListInputsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::livestream::v1::ListInputsResponse>> AsyncListInputs(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::ListInputsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::livestream::v1::ListInputsResponse>>(AsyncListInputsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::livestream::v1::ListInputsResponse>> PrepareAsyncListInputs(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::ListInputsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::livestream::v1::ListInputsResponse>>(PrepareAsyncListInputsRaw(context, request, cq));
    }
    // Returns the specified input.
    virtual ::grpc::Status GetInput(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetInputRequest& request, ::google::cloud::video::livestream::v1::Input* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::livestream::v1::Input>> AsyncGetInput(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetInputRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::livestream::v1::Input>>(AsyncGetInputRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::livestream::v1::Input>> PrepareAsyncGetInput(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetInputRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::livestream::v1::Input>>(PrepareAsyncGetInputRaw(context, request, cq));
    }
    // Deletes the specified input.
    virtual ::grpc::Status DeleteInput(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::DeleteInputRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteInput(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::DeleteInputRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteInputRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteInput(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::DeleteInputRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteInputRaw(context, request, cq));
    }
    // Updates the specified input.
    virtual ::grpc::Status UpdateInput(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::UpdateInputRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdateInput(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::UpdateInputRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdateInputRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdateInput(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::UpdateInputRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdateInputRaw(context, request, cq));
    }
    // Creates an event with the provided unique ID in the specified channel.
    virtual ::grpc::Status CreateEvent(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::CreateEventRequest& request, ::google::cloud::video::livestream::v1::Event* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::livestream::v1::Event>> AsyncCreateEvent(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::CreateEventRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::livestream::v1::Event>>(AsyncCreateEventRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::livestream::v1::Event>> PrepareAsyncCreateEvent(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::CreateEventRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::livestream::v1::Event>>(PrepareAsyncCreateEventRaw(context, request, cq));
    }
    // Returns a list of all events in the specified channel.
    virtual ::grpc::Status ListEvents(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::ListEventsRequest& request, ::google::cloud::video::livestream::v1::ListEventsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::livestream::v1::ListEventsResponse>> AsyncListEvents(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::ListEventsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::livestream::v1::ListEventsResponse>>(AsyncListEventsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::livestream::v1::ListEventsResponse>> PrepareAsyncListEvents(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::ListEventsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::livestream::v1::ListEventsResponse>>(PrepareAsyncListEventsRaw(context, request, cq));
    }
    // Returns the specified event.
    virtual ::grpc::Status GetEvent(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetEventRequest& request, ::google::cloud::video::livestream::v1::Event* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::livestream::v1::Event>> AsyncGetEvent(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetEventRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::livestream::v1::Event>>(AsyncGetEventRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::livestream::v1::Event>> PrepareAsyncGetEvent(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetEventRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::livestream::v1::Event>>(PrepareAsyncGetEventRaw(context, request, cq));
    }
    // Deletes the specified event.
    virtual ::grpc::Status DeleteEvent(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::DeleteEventRequest& request, ::google::protobuf::Empty* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> AsyncDeleteEvent(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::DeleteEventRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(AsyncDeleteEventRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>> PrepareAsyncDeleteEvent(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::DeleteEventRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>>(PrepareAsyncDeleteEventRaw(context, request, cq));
    }
    // Returns a list of all clips in the specified channel.
    virtual ::grpc::Status ListClips(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::ListClipsRequest& request, ::google::cloud::video::livestream::v1::ListClipsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::livestream::v1::ListClipsResponse>> AsyncListClips(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::ListClipsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::livestream::v1::ListClipsResponse>>(AsyncListClipsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::livestream::v1::ListClipsResponse>> PrepareAsyncListClips(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::ListClipsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::livestream::v1::ListClipsResponse>>(PrepareAsyncListClipsRaw(context, request, cq));
    }
    // Returns the specified clip.
    virtual ::grpc::Status GetClip(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetClipRequest& request, ::google::cloud::video::livestream::v1::Clip* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::livestream::v1::Clip>> AsyncGetClip(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetClipRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::livestream::v1::Clip>>(AsyncGetClipRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::livestream::v1::Clip>> PrepareAsyncGetClip(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetClipRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::livestream::v1::Clip>>(PrepareAsyncGetClipRaw(context, request, cq));
    }
    // Creates a clip with the provided clip ID in the specified channel.
    virtual ::grpc::Status CreateClip(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::CreateClipRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateClip(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::CreateClipRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateClipRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateClip(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::CreateClipRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateClipRaw(context, request, cq));
    }
    // Deletes the specified clip job resource. This method only deletes the clip
    // job and does not delete the VOD clip stored in the GCS.
    virtual ::grpc::Status DeleteClip(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::DeleteClipRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteClip(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::DeleteClipRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteClipRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteClip(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::DeleteClipRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteClipRaw(context, request, cq));
    }
    // Creates a Asset with the provided unique ID in the specified
    // region.
    virtual ::grpc::Status CreateAsset(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::CreateAssetRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncCreateAsset(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::CreateAssetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncCreateAssetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncCreateAsset(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::CreateAssetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncCreateAssetRaw(context, request, cq));
    }
    // Deletes the specified asset if it is not used.
    virtual ::grpc::Status DeleteAsset(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::DeleteAssetRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncDeleteAsset(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::DeleteAssetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncDeleteAssetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncDeleteAsset(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::DeleteAssetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncDeleteAssetRaw(context, request, cq));
    }
    // Returns the specified asset.
    virtual ::grpc::Status GetAsset(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetAssetRequest& request, ::google::cloud::video::livestream::v1::Asset* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::livestream::v1::Asset>> AsyncGetAsset(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetAssetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::livestream::v1::Asset>>(AsyncGetAssetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::livestream::v1::Asset>> PrepareAsyncGetAsset(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetAssetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::livestream::v1::Asset>>(PrepareAsyncGetAssetRaw(context, request, cq));
    }
    // Returns a list of all assets in the specified region.
    virtual ::grpc::Status ListAssets(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::ListAssetsRequest& request, ::google::cloud::video::livestream::v1::ListAssetsResponse* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::livestream::v1::ListAssetsResponse>> AsyncListAssets(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::ListAssetsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::livestream::v1::ListAssetsResponse>>(AsyncListAssetsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::livestream::v1::ListAssetsResponse>> PrepareAsyncListAssets(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::ListAssetsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::livestream::v1::ListAssetsResponse>>(PrepareAsyncListAssetsRaw(context, request, cq));
    }
    // Returns the specified pool.
    virtual ::grpc::Status GetPool(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetPoolRequest& request, ::google::cloud::video::livestream::v1::Pool* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::livestream::v1::Pool>> AsyncGetPool(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetPoolRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::livestream::v1::Pool>>(AsyncGetPoolRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::livestream::v1::Pool>> PrepareAsyncGetPool(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetPoolRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::livestream::v1::Pool>>(PrepareAsyncGetPoolRaw(context, request, cq));
    }
    // Updates the specified pool.
    virtual ::grpc::Status UpdatePool(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::UpdatePoolRequest& request, ::google::longrunning::Operation* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> AsyncUpdatePool(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::UpdatePoolRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(AsyncUpdatePoolRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>> PrepareAsyncUpdatePool(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::UpdatePoolRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>>(PrepareAsyncUpdatePoolRaw(context, request, cq));
    }
    class async_interface {
     public:
      virtual ~async_interface() {}
      // Creates a channel with the provided unique ID in the specified
      // region.
      virtual void CreateChannel(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::CreateChannelRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateChannel(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::CreateChannelRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Returns a list of all channels in the specified region.
      virtual void ListChannels(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::ListChannelsRequest* request, ::google::cloud::video::livestream::v1::ListChannelsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListChannels(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::ListChannelsRequest* request, ::google::cloud::video::livestream::v1::ListChannelsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Returns the specified channel.
      virtual void GetChannel(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetChannelRequest* request, ::google::cloud::video::livestream::v1::Channel* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetChannel(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetChannelRequest* request, ::google::cloud::video::livestream::v1::Channel* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes the specified channel.
      virtual void DeleteChannel(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::DeleteChannelRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteChannel(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::DeleteChannelRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates the specified channel.
      virtual void UpdateChannel(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::UpdateChannelRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateChannel(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::UpdateChannelRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Starts the specified channel. Part of the video pipeline will be created
      // only when the StartChannel request is received by the server.
      virtual void StartChannel(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::StartChannelRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void StartChannel(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::StartChannelRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Stops the specified channel. Part of the video pipeline will be released
      // when the StopChannel request is received by the server.
      virtual void StopChannel(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::StopChannelRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void StopChannel(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::StopChannelRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates an input with the provided unique ID in the specified region.
      virtual void CreateInput(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::CreateInputRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateInput(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::CreateInputRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Returns a list of all inputs in the specified region.
      virtual void ListInputs(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::ListInputsRequest* request, ::google::cloud::video::livestream::v1::ListInputsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListInputs(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::ListInputsRequest* request, ::google::cloud::video::livestream::v1::ListInputsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Returns the specified input.
      virtual void GetInput(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetInputRequest* request, ::google::cloud::video::livestream::v1::Input* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetInput(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetInputRequest* request, ::google::cloud::video::livestream::v1::Input* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes the specified input.
      virtual void DeleteInput(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::DeleteInputRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteInput(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::DeleteInputRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates the specified input.
      virtual void UpdateInput(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::UpdateInputRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdateInput(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::UpdateInputRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates an event with the provided unique ID in the specified channel.
      virtual void CreateEvent(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::CreateEventRequest* request, ::google::cloud::video::livestream::v1::Event* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateEvent(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::CreateEventRequest* request, ::google::cloud::video::livestream::v1::Event* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Returns a list of all events in the specified channel.
      virtual void ListEvents(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::ListEventsRequest* request, ::google::cloud::video::livestream::v1::ListEventsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListEvents(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::ListEventsRequest* request, ::google::cloud::video::livestream::v1::ListEventsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Returns the specified event.
      virtual void GetEvent(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetEventRequest* request, ::google::cloud::video::livestream::v1::Event* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetEvent(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetEventRequest* request, ::google::cloud::video::livestream::v1::Event* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes the specified event.
      virtual void DeleteEvent(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::DeleteEventRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteEvent(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::DeleteEventRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Returns a list of all clips in the specified channel.
      virtual void ListClips(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::ListClipsRequest* request, ::google::cloud::video::livestream::v1::ListClipsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListClips(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::ListClipsRequest* request, ::google::cloud::video::livestream::v1::ListClipsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Returns the specified clip.
      virtual void GetClip(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetClipRequest* request, ::google::cloud::video::livestream::v1::Clip* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetClip(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetClipRequest* request, ::google::cloud::video::livestream::v1::Clip* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a clip with the provided clip ID in the specified channel.
      virtual void CreateClip(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::CreateClipRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateClip(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::CreateClipRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes the specified clip job resource. This method only deletes the clip
      // job and does not delete the VOD clip stored in the GCS.
      virtual void DeleteClip(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::DeleteClipRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteClip(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::DeleteClipRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Creates a Asset with the provided unique ID in the specified
      // region.
      virtual void CreateAsset(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::CreateAssetRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void CreateAsset(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::CreateAssetRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Deletes the specified asset if it is not used.
      virtual void DeleteAsset(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::DeleteAssetRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void DeleteAsset(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::DeleteAssetRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Returns the specified asset.
      virtual void GetAsset(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetAssetRequest* request, ::google::cloud::video::livestream::v1::Asset* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetAsset(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetAssetRequest* request, ::google::cloud::video::livestream::v1::Asset* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Returns a list of all assets in the specified region.
      virtual void ListAssets(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::ListAssetsRequest* request, ::google::cloud::video::livestream::v1::ListAssetsResponse* response, std::function<void(::grpc::Status)>) = 0;
      virtual void ListAssets(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::ListAssetsRequest* request, ::google::cloud::video::livestream::v1::ListAssetsResponse* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Returns the specified pool.
      virtual void GetPool(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetPoolRequest* request, ::google::cloud::video::livestream::v1::Pool* response, std::function<void(::grpc::Status)>) = 0;
      virtual void GetPool(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetPoolRequest* request, ::google::cloud::video::livestream::v1::Pool* response, ::grpc::ClientUnaryReactor* reactor) = 0;
      // Updates the specified pool.
      virtual void UpdatePool(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::UpdatePoolRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) = 0;
      virtual void UpdatePool(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::UpdatePoolRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) = 0;
    };
    typedef class async_interface experimental_async_interface;
    virtual class async_interface* async() { return nullptr; }
    class async_interface* experimental_async() { return async(); }
   private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateChannelRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::CreateChannelRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateChannelRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::CreateChannelRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::livestream::v1::ListChannelsResponse>* AsyncListChannelsRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::ListChannelsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::livestream::v1::ListChannelsResponse>* PrepareAsyncListChannelsRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::ListChannelsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::livestream::v1::Channel>* AsyncGetChannelRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetChannelRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::livestream::v1::Channel>* PrepareAsyncGetChannelRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetChannelRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteChannelRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::DeleteChannelRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteChannelRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::DeleteChannelRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateChannelRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::UpdateChannelRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateChannelRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::UpdateChannelRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncStartChannelRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::StartChannelRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncStartChannelRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::StartChannelRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncStopChannelRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::StopChannelRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncStopChannelRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::StopChannelRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateInputRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::CreateInputRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateInputRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::CreateInputRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::livestream::v1::ListInputsResponse>* AsyncListInputsRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::ListInputsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::livestream::v1::ListInputsResponse>* PrepareAsyncListInputsRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::ListInputsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::livestream::v1::Input>* AsyncGetInputRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetInputRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::livestream::v1::Input>* PrepareAsyncGetInputRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetInputRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteInputRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::DeleteInputRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteInputRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::DeleteInputRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdateInputRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::UpdateInputRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdateInputRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::UpdateInputRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::livestream::v1::Event>* AsyncCreateEventRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::CreateEventRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::livestream::v1::Event>* PrepareAsyncCreateEventRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::CreateEventRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::livestream::v1::ListEventsResponse>* AsyncListEventsRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::ListEventsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::livestream::v1::ListEventsResponse>* PrepareAsyncListEventsRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::ListEventsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::livestream::v1::Event>* AsyncGetEventRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetEventRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::livestream::v1::Event>* PrepareAsyncGetEventRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetEventRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* AsyncDeleteEventRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::DeleteEventRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::protobuf::Empty>* PrepareAsyncDeleteEventRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::DeleteEventRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::livestream::v1::ListClipsResponse>* AsyncListClipsRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::ListClipsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::livestream::v1::ListClipsResponse>* PrepareAsyncListClipsRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::ListClipsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::livestream::v1::Clip>* AsyncGetClipRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetClipRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::livestream::v1::Clip>* PrepareAsyncGetClipRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetClipRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateClipRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::CreateClipRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateClipRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::CreateClipRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteClipRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::DeleteClipRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteClipRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::DeleteClipRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncCreateAssetRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::CreateAssetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncCreateAssetRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::CreateAssetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncDeleteAssetRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::DeleteAssetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncDeleteAssetRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::DeleteAssetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::livestream::v1::Asset>* AsyncGetAssetRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetAssetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::livestream::v1::Asset>* PrepareAsyncGetAssetRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetAssetRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::livestream::v1::ListAssetsResponse>* AsyncListAssetsRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::ListAssetsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::livestream::v1::ListAssetsResponse>* PrepareAsyncListAssetsRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::ListAssetsRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::livestream::v1::Pool>* AsyncGetPoolRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetPoolRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::cloud::video::livestream::v1::Pool>* PrepareAsyncGetPoolRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetPoolRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* AsyncUpdatePoolRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::UpdatePoolRequest& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::google::longrunning::Operation>* PrepareAsyncUpdatePoolRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::UpdatePoolRequest& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());
    ::grpc::Status CreateChannel(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::CreateChannelRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateChannel(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::CreateChannelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateChannelRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateChannel(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::CreateChannelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateChannelRaw(context, request, cq));
    }
    ::grpc::Status ListChannels(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::ListChannelsRequest& request, ::google::cloud::video::livestream::v1::ListChannelsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::livestream::v1::ListChannelsResponse>> AsyncListChannels(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::ListChannelsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::livestream::v1::ListChannelsResponse>>(AsyncListChannelsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::livestream::v1::ListChannelsResponse>> PrepareAsyncListChannels(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::ListChannelsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::livestream::v1::ListChannelsResponse>>(PrepareAsyncListChannelsRaw(context, request, cq));
    }
    ::grpc::Status GetChannel(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetChannelRequest& request, ::google::cloud::video::livestream::v1::Channel* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::livestream::v1::Channel>> AsyncGetChannel(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetChannelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::livestream::v1::Channel>>(AsyncGetChannelRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::livestream::v1::Channel>> PrepareAsyncGetChannel(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetChannelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::livestream::v1::Channel>>(PrepareAsyncGetChannelRaw(context, request, cq));
    }
    ::grpc::Status DeleteChannel(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::DeleteChannelRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteChannel(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::DeleteChannelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteChannelRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteChannel(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::DeleteChannelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteChannelRaw(context, request, cq));
    }
    ::grpc::Status UpdateChannel(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::UpdateChannelRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateChannel(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::UpdateChannelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateChannelRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateChannel(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::UpdateChannelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateChannelRaw(context, request, cq));
    }
    ::grpc::Status StartChannel(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::StartChannelRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncStartChannel(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::StartChannelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncStartChannelRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncStartChannel(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::StartChannelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncStartChannelRaw(context, request, cq));
    }
    ::grpc::Status StopChannel(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::StopChannelRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncStopChannel(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::StopChannelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncStopChannelRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncStopChannel(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::StopChannelRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncStopChannelRaw(context, request, cq));
    }
    ::grpc::Status CreateInput(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::CreateInputRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateInput(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::CreateInputRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateInputRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateInput(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::CreateInputRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateInputRaw(context, request, cq));
    }
    ::grpc::Status ListInputs(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::ListInputsRequest& request, ::google::cloud::video::livestream::v1::ListInputsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::livestream::v1::ListInputsResponse>> AsyncListInputs(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::ListInputsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::livestream::v1::ListInputsResponse>>(AsyncListInputsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::livestream::v1::ListInputsResponse>> PrepareAsyncListInputs(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::ListInputsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::livestream::v1::ListInputsResponse>>(PrepareAsyncListInputsRaw(context, request, cq));
    }
    ::grpc::Status GetInput(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetInputRequest& request, ::google::cloud::video::livestream::v1::Input* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::livestream::v1::Input>> AsyncGetInput(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetInputRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::livestream::v1::Input>>(AsyncGetInputRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::livestream::v1::Input>> PrepareAsyncGetInput(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetInputRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::livestream::v1::Input>>(PrepareAsyncGetInputRaw(context, request, cq));
    }
    ::grpc::Status DeleteInput(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::DeleteInputRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteInput(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::DeleteInputRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteInputRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteInput(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::DeleteInputRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteInputRaw(context, request, cq));
    }
    ::grpc::Status UpdateInput(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::UpdateInputRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdateInput(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::UpdateInputRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdateInputRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdateInput(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::UpdateInputRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdateInputRaw(context, request, cq));
    }
    ::grpc::Status CreateEvent(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::CreateEventRequest& request, ::google::cloud::video::livestream::v1::Event* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::livestream::v1::Event>> AsyncCreateEvent(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::CreateEventRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::livestream::v1::Event>>(AsyncCreateEventRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::livestream::v1::Event>> PrepareAsyncCreateEvent(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::CreateEventRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::livestream::v1::Event>>(PrepareAsyncCreateEventRaw(context, request, cq));
    }
    ::grpc::Status ListEvents(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::ListEventsRequest& request, ::google::cloud::video::livestream::v1::ListEventsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::livestream::v1::ListEventsResponse>> AsyncListEvents(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::ListEventsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::livestream::v1::ListEventsResponse>>(AsyncListEventsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::livestream::v1::ListEventsResponse>> PrepareAsyncListEvents(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::ListEventsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::livestream::v1::ListEventsResponse>>(PrepareAsyncListEventsRaw(context, request, cq));
    }
    ::grpc::Status GetEvent(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetEventRequest& request, ::google::cloud::video::livestream::v1::Event* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::livestream::v1::Event>> AsyncGetEvent(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetEventRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::livestream::v1::Event>>(AsyncGetEventRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::livestream::v1::Event>> PrepareAsyncGetEvent(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetEventRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::livestream::v1::Event>>(PrepareAsyncGetEventRaw(context, request, cq));
    }
    ::grpc::Status DeleteEvent(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::DeleteEventRequest& request, ::google::protobuf::Empty* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> AsyncDeleteEvent(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::DeleteEventRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(AsyncDeleteEventRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>> PrepareAsyncDeleteEvent(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::DeleteEventRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>>(PrepareAsyncDeleteEventRaw(context, request, cq));
    }
    ::grpc::Status ListClips(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::ListClipsRequest& request, ::google::cloud::video::livestream::v1::ListClipsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::livestream::v1::ListClipsResponse>> AsyncListClips(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::ListClipsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::livestream::v1::ListClipsResponse>>(AsyncListClipsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::livestream::v1::ListClipsResponse>> PrepareAsyncListClips(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::ListClipsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::livestream::v1::ListClipsResponse>>(PrepareAsyncListClipsRaw(context, request, cq));
    }
    ::grpc::Status GetClip(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetClipRequest& request, ::google::cloud::video::livestream::v1::Clip* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::livestream::v1::Clip>> AsyncGetClip(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetClipRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::livestream::v1::Clip>>(AsyncGetClipRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::livestream::v1::Clip>> PrepareAsyncGetClip(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetClipRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::livestream::v1::Clip>>(PrepareAsyncGetClipRaw(context, request, cq));
    }
    ::grpc::Status CreateClip(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::CreateClipRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateClip(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::CreateClipRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateClipRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateClip(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::CreateClipRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateClipRaw(context, request, cq));
    }
    ::grpc::Status DeleteClip(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::DeleteClipRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteClip(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::DeleteClipRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteClipRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteClip(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::DeleteClipRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteClipRaw(context, request, cq));
    }
    ::grpc::Status CreateAsset(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::CreateAssetRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncCreateAsset(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::CreateAssetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncCreateAssetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncCreateAsset(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::CreateAssetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncCreateAssetRaw(context, request, cq));
    }
    ::grpc::Status DeleteAsset(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::DeleteAssetRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncDeleteAsset(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::DeleteAssetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncDeleteAssetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncDeleteAsset(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::DeleteAssetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncDeleteAssetRaw(context, request, cq));
    }
    ::grpc::Status GetAsset(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetAssetRequest& request, ::google::cloud::video::livestream::v1::Asset* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::livestream::v1::Asset>> AsyncGetAsset(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetAssetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::livestream::v1::Asset>>(AsyncGetAssetRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::livestream::v1::Asset>> PrepareAsyncGetAsset(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetAssetRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::livestream::v1::Asset>>(PrepareAsyncGetAssetRaw(context, request, cq));
    }
    ::grpc::Status ListAssets(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::ListAssetsRequest& request, ::google::cloud::video::livestream::v1::ListAssetsResponse* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::livestream::v1::ListAssetsResponse>> AsyncListAssets(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::ListAssetsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::livestream::v1::ListAssetsResponse>>(AsyncListAssetsRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::livestream::v1::ListAssetsResponse>> PrepareAsyncListAssets(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::ListAssetsRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::livestream::v1::ListAssetsResponse>>(PrepareAsyncListAssetsRaw(context, request, cq));
    }
    ::grpc::Status GetPool(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetPoolRequest& request, ::google::cloud::video::livestream::v1::Pool* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::livestream::v1::Pool>> AsyncGetPool(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetPoolRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::livestream::v1::Pool>>(AsyncGetPoolRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::livestream::v1::Pool>> PrepareAsyncGetPool(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetPoolRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::cloud::video::livestream::v1::Pool>>(PrepareAsyncGetPoolRaw(context, request, cq));
    }
    ::grpc::Status UpdatePool(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::UpdatePoolRequest& request, ::google::longrunning::Operation* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> AsyncUpdatePool(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::UpdatePoolRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(AsyncUpdatePoolRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>> PrepareAsyncUpdatePool(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::UpdatePoolRequest& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>>(PrepareAsyncUpdatePoolRaw(context, request, cq));
    }
    class async final :
      public StubInterface::async_interface {
     public:
      void CreateChannel(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::CreateChannelRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateChannel(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::CreateChannelRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListChannels(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::ListChannelsRequest* request, ::google::cloud::video::livestream::v1::ListChannelsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListChannels(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::ListChannelsRequest* request, ::google::cloud::video::livestream::v1::ListChannelsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetChannel(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetChannelRequest* request, ::google::cloud::video::livestream::v1::Channel* response, std::function<void(::grpc::Status)>) override;
      void GetChannel(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetChannelRequest* request, ::google::cloud::video::livestream::v1::Channel* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteChannel(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::DeleteChannelRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteChannel(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::DeleteChannelRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateChannel(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::UpdateChannelRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateChannel(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::UpdateChannelRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void StartChannel(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::StartChannelRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void StartChannel(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::StartChannelRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void StopChannel(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::StopChannelRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void StopChannel(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::StopChannelRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateInput(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::CreateInputRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateInput(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::CreateInputRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListInputs(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::ListInputsRequest* request, ::google::cloud::video::livestream::v1::ListInputsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListInputs(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::ListInputsRequest* request, ::google::cloud::video::livestream::v1::ListInputsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetInput(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetInputRequest* request, ::google::cloud::video::livestream::v1::Input* response, std::function<void(::grpc::Status)>) override;
      void GetInput(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetInputRequest* request, ::google::cloud::video::livestream::v1::Input* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteInput(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::DeleteInputRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteInput(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::DeleteInputRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdateInput(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::UpdateInputRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdateInput(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::UpdateInputRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateEvent(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::CreateEventRequest* request, ::google::cloud::video::livestream::v1::Event* response, std::function<void(::grpc::Status)>) override;
      void CreateEvent(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::CreateEventRequest* request, ::google::cloud::video::livestream::v1::Event* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListEvents(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::ListEventsRequest* request, ::google::cloud::video::livestream::v1::ListEventsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListEvents(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::ListEventsRequest* request, ::google::cloud::video::livestream::v1::ListEventsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetEvent(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetEventRequest* request, ::google::cloud::video::livestream::v1::Event* response, std::function<void(::grpc::Status)>) override;
      void GetEvent(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetEventRequest* request, ::google::cloud::video::livestream::v1::Event* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteEvent(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::DeleteEventRequest* request, ::google::protobuf::Empty* response, std::function<void(::grpc::Status)>) override;
      void DeleteEvent(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::DeleteEventRequest* request, ::google::protobuf::Empty* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListClips(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::ListClipsRequest* request, ::google::cloud::video::livestream::v1::ListClipsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListClips(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::ListClipsRequest* request, ::google::cloud::video::livestream::v1::ListClipsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetClip(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetClipRequest* request, ::google::cloud::video::livestream::v1::Clip* response, std::function<void(::grpc::Status)>) override;
      void GetClip(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetClipRequest* request, ::google::cloud::video::livestream::v1::Clip* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateClip(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::CreateClipRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateClip(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::CreateClipRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteClip(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::DeleteClipRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteClip(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::DeleteClipRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void CreateAsset(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::CreateAssetRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void CreateAsset(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::CreateAssetRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void DeleteAsset(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::DeleteAssetRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void DeleteAsset(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::DeleteAssetRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetAsset(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetAssetRequest* request, ::google::cloud::video::livestream::v1::Asset* response, std::function<void(::grpc::Status)>) override;
      void GetAsset(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetAssetRequest* request, ::google::cloud::video::livestream::v1::Asset* response, ::grpc::ClientUnaryReactor* reactor) override;
      void ListAssets(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::ListAssetsRequest* request, ::google::cloud::video::livestream::v1::ListAssetsResponse* response, std::function<void(::grpc::Status)>) override;
      void ListAssets(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::ListAssetsRequest* request, ::google::cloud::video::livestream::v1::ListAssetsResponse* response, ::grpc::ClientUnaryReactor* reactor) override;
      void GetPool(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetPoolRequest* request, ::google::cloud::video::livestream::v1::Pool* response, std::function<void(::grpc::Status)>) override;
      void GetPool(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetPoolRequest* request, ::google::cloud::video::livestream::v1::Pool* response, ::grpc::ClientUnaryReactor* reactor) override;
      void UpdatePool(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::UpdatePoolRequest* request, ::google::longrunning::Operation* response, std::function<void(::grpc::Status)>) override;
      void UpdatePool(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::UpdatePoolRequest* request, ::google::longrunning::Operation* response, ::grpc::ClientUnaryReactor* reactor) override;
     private:
      friend class Stub;
      explicit async(Stub* stub): stub_(stub) { }
      Stub* stub() { return stub_; }
      Stub* stub_;
    };
    class async* async() override { return &async_stub_; }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    class async async_stub_{this};
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateChannelRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::CreateChannelRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateChannelRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::CreateChannelRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::video::livestream::v1::ListChannelsResponse>* AsyncListChannelsRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::ListChannelsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::video::livestream::v1::ListChannelsResponse>* PrepareAsyncListChannelsRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::ListChannelsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::video::livestream::v1::Channel>* AsyncGetChannelRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetChannelRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::video::livestream::v1::Channel>* PrepareAsyncGetChannelRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetChannelRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteChannelRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::DeleteChannelRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteChannelRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::DeleteChannelRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateChannelRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::UpdateChannelRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateChannelRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::UpdateChannelRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncStartChannelRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::StartChannelRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncStartChannelRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::StartChannelRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncStopChannelRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::StopChannelRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncStopChannelRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::StopChannelRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateInputRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::CreateInputRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateInputRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::CreateInputRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::video::livestream::v1::ListInputsResponse>* AsyncListInputsRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::ListInputsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::video::livestream::v1::ListInputsResponse>* PrepareAsyncListInputsRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::ListInputsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::video::livestream::v1::Input>* AsyncGetInputRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetInputRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::video::livestream::v1::Input>* PrepareAsyncGetInputRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetInputRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteInputRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::DeleteInputRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteInputRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::DeleteInputRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdateInputRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::UpdateInputRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdateInputRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::UpdateInputRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::video::livestream::v1::Event>* AsyncCreateEventRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::CreateEventRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::video::livestream::v1::Event>* PrepareAsyncCreateEventRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::CreateEventRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::video::livestream::v1::ListEventsResponse>* AsyncListEventsRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::ListEventsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::video::livestream::v1::ListEventsResponse>* PrepareAsyncListEventsRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::ListEventsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::video::livestream::v1::Event>* AsyncGetEventRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetEventRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::video::livestream::v1::Event>* PrepareAsyncGetEventRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetEventRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* AsyncDeleteEventRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::DeleteEventRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::protobuf::Empty>* PrepareAsyncDeleteEventRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::DeleteEventRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::video::livestream::v1::ListClipsResponse>* AsyncListClipsRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::ListClipsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::video::livestream::v1::ListClipsResponse>* PrepareAsyncListClipsRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::ListClipsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::video::livestream::v1::Clip>* AsyncGetClipRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetClipRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::video::livestream::v1::Clip>* PrepareAsyncGetClipRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetClipRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateClipRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::CreateClipRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateClipRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::CreateClipRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteClipRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::DeleteClipRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteClipRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::DeleteClipRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncCreateAssetRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::CreateAssetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncCreateAssetRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::CreateAssetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncDeleteAssetRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::DeleteAssetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncDeleteAssetRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::DeleteAssetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::video::livestream::v1::Asset>* AsyncGetAssetRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetAssetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::video::livestream::v1::Asset>* PrepareAsyncGetAssetRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetAssetRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::video::livestream::v1::ListAssetsResponse>* AsyncListAssetsRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::ListAssetsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::video::livestream::v1::ListAssetsResponse>* PrepareAsyncListAssetsRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::ListAssetsRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::video::livestream::v1::Pool>* AsyncGetPoolRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetPoolRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::cloud::video::livestream::v1::Pool>* PrepareAsyncGetPoolRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::GetPoolRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* AsyncUpdatePoolRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::UpdatePoolRequest& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::google::longrunning::Operation>* PrepareAsyncUpdatePoolRaw(::grpc::ClientContext* context, const ::google::cloud::video::livestream::v1::UpdatePoolRequest& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_CreateChannel_;
    const ::grpc::internal::RpcMethod rpcmethod_ListChannels_;
    const ::grpc::internal::RpcMethod rpcmethod_GetChannel_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteChannel_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateChannel_;
    const ::grpc::internal::RpcMethod rpcmethod_StartChannel_;
    const ::grpc::internal::RpcMethod rpcmethod_StopChannel_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateInput_;
    const ::grpc::internal::RpcMethod rpcmethod_ListInputs_;
    const ::grpc::internal::RpcMethod rpcmethod_GetInput_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteInput_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdateInput_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateEvent_;
    const ::grpc::internal::RpcMethod rpcmethod_ListEvents_;
    const ::grpc::internal::RpcMethod rpcmethod_GetEvent_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteEvent_;
    const ::grpc::internal::RpcMethod rpcmethod_ListClips_;
    const ::grpc::internal::RpcMethod rpcmethod_GetClip_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateClip_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteClip_;
    const ::grpc::internal::RpcMethod rpcmethod_CreateAsset_;
    const ::grpc::internal::RpcMethod rpcmethod_DeleteAsset_;
    const ::grpc::internal::RpcMethod rpcmethod_GetAsset_;
    const ::grpc::internal::RpcMethod rpcmethod_ListAssets_;
    const ::grpc::internal::RpcMethod rpcmethod_GetPool_;
    const ::grpc::internal::RpcMethod rpcmethod_UpdatePool_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    // Creates a channel with the provided unique ID in the specified
    // region.
    virtual ::grpc::Status CreateChannel(::grpc::ServerContext* context, const ::google::cloud::video::livestream::v1::CreateChannelRequest* request, ::google::longrunning::Operation* response);
    // Returns a list of all channels in the specified region.
    virtual ::grpc::Status ListChannels(::grpc::ServerContext* context, const ::google::cloud::video::livestream::v1::ListChannelsRequest* request, ::google::cloud::video::livestream::v1::ListChannelsResponse* response);
    // Returns the specified channel.
    virtual ::grpc::Status GetChannel(::grpc::ServerContext* context, const ::google::cloud::video::livestream::v1::GetChannelRequest* request, ::google::cloud::video::livestream::v1::Channel* response);
    // Deletes the specified channel.
    virtual ::grpc::Status DeleteChannel(::grpc::ServerContext* context, const ::google::cloud::video::livestream::v1::DeleteChannelRequest* request, ::google::longrunning::Operation* response);
    // Updates the specified channel.
    virtual ::grpc::Status UpdateChannel(::grpc::ServerContext* context, const ::google::cloud::video::livestream::v1::UpdateChannelRequest* request, ::google::longrunning::Operation* response);
    // Starts the specified channel. Part of the video pipeline will be created
    // only when the StartChannel request is received by the server.
    virtual ::grpc::Status StartChannel(::grpc::ServerContext* context, const ::google::cloud::video::livestream::v1::StartChannelRequest* request, ::google::longrunning::Operation* response);
    // Stops the specified channel. Part of the video pipeline will be released
    // when the StopChannel request is received by the server.
    virtual ::grpc::Status StopChannel(::grpc::ServerContext* context, const ::google::cloud::video::livestream::v1::StopChannelRequest* request, ::google::longrunning::Operation* response);
    // Creates an input with the provided unique ID in the specified region.
    virtual ::grpc::Status CreateInput(::grpc::ServerContext* context, const ::google::cloud::video::livestream::v1::CreateInputRequest* request, ::google::longrunning::Operation* response);
    // Returns a list of all inputs in the specified region.
    virtual ::grpc::Status ListInputs(::grpc::ServerContext* context, const ::google::cloud::video::livestream::v1::ListInputsRequest* request, ::google::cloud::video::livestream::v1::ListInputsResponse* response);
    // Returns the specified input.
    virtual ::grpc::Status GetInput(::grpc::ServerContext* context, const ::google::cloud::video::livestream::v1::GetInputRequest* request, ::google::cloud::video::livestream::v1::Input* response);
    // Deletes the specified input.
    virtual ::grpc::Status DeleteInput(::grpc::ServerContext* context, const ::google::cloud::video::livestream::v1::DeleteInputRequest* request, ::google::longrunning::Operation* response);
    // Updates the specified input.
    virtual ::grpc::Status UpdateInput(::grpc::ServerContext* context, const ::google::cloud::video::livestream::v1::UpdateInputRequest* request, ::google::longrunning::Operation* response);
    // Creates an event with the provided unique ID in the specified channel.
    virtual ::grpc::Status CreateEvent(::grpc::ServerContext* context, const ::google::cloud::video::livestream::v1::CreateEventRequest* request, ::google::cloud::video::livestream::v1::Event* response);
    // Returns a list of all events in the specified channel.
    virtual ::grpc::Status ListEvents(::grpc::ServerContext* context, const ::google::cloud::video::livestream::v1::ListEventsRequest* request, ::google::cloud::video::livestream::v1::ListEventsResponse* response);
    // Returns the specified event.
    virtual ::grpc::Status GetEvent(::grpc::ServerContext* context, const ::google::cloud::video::livestream::v1::GetEventRequest* request, ::google::cloud::video::livestream::v1::Event* response);
    // Deletes the specified event.
    virtual ::grpc::Status DeleteEvent(::grpc::ServerContext* context, const ::google::cloud::video::livestream::v1::DeleteEventRequest* request, ::google::protobuf::Empty* response);
    // Returns a list of all clips in the specified channel.
    virtual ::grpc::Status ListClips(::grpc::ServerContext* context, const ::google::cloud::video::livestream::v1::ListClipsRequest* request, ::google::cloud::video::livestream::v1::ListClipsResponse* response);
    // Returns the specified clip.
    virtual ::grpc::Status GetClip(::grpc::ServerContext* context, const ::google::cloud::video::livestream::v1::GetClipRequest* request, ::google::cloud::video::livestream::v1::Clip* response);
    // Creates a clip with the provided clip ID in the specified channel.
    virtual ::grpc::Status CreateClip(::grpc::ServerContext* context, const ::google::cloud::video::livestream::v1::CreateClipRequest* request, ::google::longrunning::Operation* response);
    // Deletes the specified clip job resource. This method only deletes the clip
    // job and does not delete the VOD clip stored in the GCS.
    virtual ::grpc::Status DeleteClip(::grpc::ServerContext* context, const ::google::cloud::video::livestream::v1::DeleteClipRequest* request, ::google::longrunning::Operation* response);
    // Creates a Asset with the provided unique ID in the specified
    // region.
    virtual ::grpc::Status CreateAsset(::grpc::ServerContext* context, const ::google::cloud::video::livestream::v1::CreateAssetRequest* request, ::google::longrunning::Operation* response);
    // Deletes the specified asset if it is not used.
    virtual ::grpc::Status DeleteAsset(::grpc::ServerContext* context, const ::google::cloud::video::livestream::v1::DeleteAssetRequest* request, ::google::longrunning::Operation* response);
    // Returns the specified asset.
    virtual ::grpc::Status GetAsset(::grpc::ServerContext* context, const ::google::cloud::video::livestream::v1::GetAssetRequest* request, ::google::cloud::video::livestream::v1::Asset* response);
    // Returns a list of all assets in the specified region.
    virtual ::grpc::Status ListAssets(::grpc::ServerContext* context, const ::google::cloud::video::livestream::v1::ListAssetsRequest* request, ::google::cloud::video::livestream::v1::ListAssetsResponse* response);
    // Returns the specified pool.
    virtual ::grpc::Status GetPool(::grpc::ServerContext* context, const ::google::cloud::video::livestream::v1::GetPoolRequest* request, ::google::cloud::video::livestream::v1::Pool* response);
    // Updates the specified pool.
    virtual ::grpc::Status UpdatePool(::grpc::ServerContext* context, const ::google::cloud::video::livestream::v1::UpdatePoolRequest* request, ::google::longrunning::Operation* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateChannel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateChannel() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_CreateChannel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateChannel(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::CreateChannelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateChannel(::grpc::ServerContext* context, ::google::cloud::video::livestream::v1::CreateChannelRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListChannels : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListChannels() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_ListChannels() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListChannels(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::ListChannelsRequest* /*request*/, ::google::cloud::video::livestream::v1::ListChannelsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListChannels(::grpc::ServerContext* context, ::google::cloud::video::livestream::v1::ListChannelsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::video::livestream::v1::ListChannelsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetChannel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetChannel() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_GetChannel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetChannel(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::GetChannelRequest* /*request*/, ::google::cloud::video::livestream::v1::Channel* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetChannel(::grpc::ServerContext* context, ::google::cloud::video::livestream::v1::GetChannelRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::video::livestream::v1::Channel>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteChannel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteChannel() {
      ::grpc::Service::MarkMethodAsync(3);
    }
    ~WithAsyncMethod_DeleteChannel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteChannel(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::DeleteChannelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteChannel(::grpc::ServerContext* context, ::google::cloud::video::livestream::v1::DeleteChannelRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateChannel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateChannel() {
      ::grpc::Service::MarkMethodAsync(4);
    }
    ~WithAsyncMethod_UpdateChannel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateChannel(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::UpdateChannelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateChannel(::grpc::ServerContext* context, ::google::cloud::video::livestream::v1::UpdateChannelRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_StartChannel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_StartChannel() {
      ::grpc::Service::MarkMethodAsync(5);
    }
    ~WithAsyncMethod_StartChannel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StartChannel(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::StartChannelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestStartChannel(::grpc::ServerContext* context, ::google::cloud::video::livestream::v1::StartChannelRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_StopChannel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_StopChannel() {
      ::grpc::Service::MarkMethodAsync(6);
    }
    ~WithAsyncMethod_StopChannel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StopChannel(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::StopChannelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestStopChannel(::grpc::ServerContext* context, ::google::cloud::video::livestream::v1::StopChannelRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateInput : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateInput() {
      ::grpc::Service::MarkMethodAsync(7);
    }
    ~WithAsyncMethod_CreateInput() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateInput(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::CreateInputRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateInput(::grpc::ServerContext* context, ::google::cloud::video::livestream::v1::CreateInputRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListInputs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListInputs() {
      ::grpc::Service::MarkMethodAsync(8);
    }
    ~WithAsyncMethod_ListInputs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInputs(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::ListInputsRequest* /*request*/, ::google::cloud::video::livestream::v1::ListInputsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListInputs(::grpc::ServerContext* context, ::google::cloud::video::livestream::v1::ListInputsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::video::livestream::v1::ListInputsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetInput : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetInput() {
      ::grpc::Service::MarkMethodAsync(9);
    }
    ~WithAsyncMethod_GetInput() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInput(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::GetInputRequest* /*request*/, ::google::cloud::video::livestream::v1::Input* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetInput(::grpc::ServerContext* context, ::google::cloud::video::livestream::v1::GetInputRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::video::livestream::v1::Input>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteInput : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteInput() {
      ::grpc::Service::MarkMethodAsync(10);
    }
    ~WithAsyncMethod_DeleteInput() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteInput(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::DeleteInputRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteInput(::grpc::ServerContext* context, ::google::cloud::video::livestream::v1::DeleteInputRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdateInput : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdateInput() {
      ::grpc::Service::MarkMethodAsync(11);
    }
    ~WithAsyncMethod_UpdateInput() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateInput(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::UpdateInputRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateInput(::grpc::ServerContext* context, ::google::cloud::video::livestream::v1::UpdateInputRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateEvent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateEvent() {
      ::grpc::Service::MarkMethodAsync(12);
    }
    ~WithAsyncMethod_CreateEvent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateEvent(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::CreateEventRequest* /*request*/, ::google::cloud::video::livestream::v1::Event* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateEvent(::grpc::ServerContext* context, ::google::cloud::video::livestream::v1::CreateEventRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::video::livestream::v1::Event>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListEvents : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListEvents() {
      ::grpc::Service::MarkMethodAsync(13);
    }
    ~WithAsyncMethod_ListEvents() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListEvents(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::ListEventsRequest* /*request*/, ::google::cloud::video::livestream::v1::ListEventsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListEvents(::grpc::ServerContext* context, ::google::cloud::video::livestream::v1::ListEventsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::video::livestream::v1::ListEventsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetEvent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetEvent() {
      ::grpc::Service::MarkMethodAsync(14);
    }
    ~WithAsyncMethod_GetEvent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEvent(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::GetEventRequest* /*request*/, ::google::cloud::video::livestream::v1::Event* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetEvent(::grpc::ServerContext* context, ::google::cloud::video::livestream::v1::GetEventRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::video::livestream::v1::Event>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(14, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteEvent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteEvent() {
      ::grpc::Service::MarkMethodAsync(15);
    }
    ~WithAsyncMethod_DeleteEvent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteEvent(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::DeleteEventRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteEvent(::grpc::ServerContext* context, ::google::cloud::video::livestream::v1::DeleteEventRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::protobuf::Empty>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(15, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListClips : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListClips() {
      ::grpc::Service::MarkMethodAsync(16);
    }
    ~WithAsyncMethod_ListClips() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListClips(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::ListClipsRequest* /*request*/, ::google::cloud::video::livestream::v1::ListClipsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListClips(::grpc::ServerContext* context, ::google::cloud::video::livestream::v1::ListClipsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::video::livestream::v1::ListClipsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(16, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetClip : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetClip() {
      ::grpc::Service::MarkMethodAsync(17);
    }
    ~WithAsyncMethod_GetClip() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetClip(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::GetClipRequest* /*request*/, ::google::cloud::video::livestream::v1::Clip* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetClip(::grpc::ServerContext* context, ::google::cloud::video::livestream::v1::GetClipRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::video::livestream::v1::Clip>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(17, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateClip : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateClip() {
      ::grpc::Service::MarkMethodAsync(18);
    }
    ~WithAsyncMethod_CreateClip() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateClip(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::CreateClipRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateClip(::grpc::ServerContext* context, ::google::cloud::video::livestream::v1::CreateClipRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(18, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteClip : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteClip() {
      ::grpc::Service::MarkMethodAsync(19);
    }
    ~WithAsyncMethod_DeleteClip() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteClip(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::DeleteClipRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteClip(::grpc::ServerContext* context, ::google::cloud::video::livestream::v1::DeleteClipRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(19, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_CreateAsset : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_CreateAsset() {
      ::grpc::Service::MarkMethodAsync(20);
    }
    ~WithAsyncMethod_CreateAsset() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAsset(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::CreateAssetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateAsset(::grpc::ServerContext* context, ::google::cloud::video::livestream::v1::CreateAssetRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(20, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_DeleteAsset : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_DeleteAsset() {
      ::grpc::Service::MarkMethodAsync(21);
    }
    ~WithAsyncMethod_DeleteAsset() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAsset(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::DeleteAssetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteAsset(::grpc::ServerContext* context, ::google::cloud::video::livestream::v1::DeleteAssetRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(21, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetAsset : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetAsset() {
      ::grpc::Service::MarkMethodAsync(22);
    }
    ~WithAsyncMethod_GetAsset() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAsset(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::GetAssetRequest* /*request*/, ::google::cloud::video::livestream::v1::Asset* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetAsset(::grpc::ServerContext* context, ::google::cloud::video::livestream::v1::GetAssetRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::video::livestream::v1::Asset>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(22, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ListAssets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_ListAssets() {
      ::grpc::Service::MarkMethodAsync(23);
    }
    ~WithAsyncMethod_ListAssets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAssets(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::ListAssetsRequest* /*request*/, ::google::cloud::video::livestream::v1::ListAssetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListAssets(::grpc::ServerContext* context, ::google::cloud::video::livestream::v1::ListAssetsRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::video::livestream::v1::ListAssetsResponse>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(23, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_GetPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_GetPool() {
      ::grpc::Service::MarkMethodAsync(24);
    }
    ~WithAsyncMethod_GetPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPool(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::GetPoolRequest* /*request*/, ::google::cloud::video::livestream::v1::Pool* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetPool(::grpc::ServerContext* context, ::google::cloud::video::livestream::v1::GetPoolRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::cloud::video::livestream::v1::Pool>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(24, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_UpdatePool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithAsyncMethod_UpdatePool() {
      ::grpc::Service::MarkMethodAsync(25);
    }
    ~WithAsyncMethod_UpdatePool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdatePool(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::UpdatePoolRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdatePool(::grpc::ServerContext* context, ::google::cloud::video::livestream::v1::UpdatePoolRequest* request, ::grpc::ServerAsyncResponseWriter< ::google::longrunning::Operation>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(25, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_CreateChannel<WithAsyncMethod_ListChannels<WithAsyncMethod_GetChannel<WithAsyncMethod_DeleteChannel<WithAsyncMethod_UpdateChannel<WithAsyncMethod_StartChannel<WithAsyncMethod_StopChannel<WithAsyncMethod_CreateInput<WithAsyncMethod_ListInputs<WithAsyncMethod_GetInput<WithAsyncMethod_DeleteInput<WithAsyncMethod_UpdateInput<WithAsyncMethod_CreateEvent<WithAsyncMethod_ListEvents<WithAsyncMethod_GetEvent<WithAsyncMethod_DeleteEvent<WithAsyncMethod_ListClips<WithAsyncMethod_GetClip<WithAsyncMethod_CreateClip<WithAsyncMethod_DeleteClip<WithAsyncMethod_CreateAsset<WithAsyncMethod_DeleteAsset<WithAsyncMethod_GetAsset<WithAsyncMethod_ListAssets<WithAsyncMethod_GetPool<WithAsyncMethod_UpdatePool<Service > > > > > > > > > > > > > > > > > > > > > > > > > > AsyncService;
  template <class BaseClass>
  class WithCallbackMethod_CreateChannel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateChannel() {
      ::grpc::Service::MarkMethodCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::livestream::v1::CreateChannelRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::video::livestream::v1::CreateChannelRequest* request, ::google::longrunning::Operation* response) { return this->CreateChannel(context, request, response); }));}
    void SetMessageAllocatorFor_CreateChannel(
        ::grpc::MessageAllocator< ::google::cloud::video::livestream::v1::CreateChannelRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(0);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::livestream::v1::CreateChannelRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateChannel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateChannel(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::CreateChannelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateChannel(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::video::livestream::v1::CreateChannelRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListChannels : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListChannels() {
      ::grpc::Service::MarkMethodCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::livestream::v1::ListChannelsRequest, ::google::cloud::video::livestream::v1::ListChannelsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::video::livestream::v1::ListChannelsRequest* request, ::google::cloud::video::livestream::v1::ListChannelsResponse* response) { return this->ListChannels(context, request, response); }));}
    void SetMessageAllocatorFor_ListChannels(
        ::grpc::MessageAllocator< ::google::cloud::video::livestream::v1::ListChannelsRequest, ::google::cloud::video::livestream::v1::ListChannelsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(1);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::livestream::v1::ListChannelsRequest, ::google::cloud::video::livestream::v1::ListChannelsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListChannels() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListChannels(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::ListChannelsRequest* /*request*/, ::google::cloud::video::livestream::v1::ListChannelsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListChannels(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::video::livestream::v1::ListChannelsRequest* /*request*/, ::google::cloud::video::livestream::v1::ListChannelsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetChannel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetChannel() {
      ::grpc::Service::MarkMethodCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::livestream::v1::GetChannelRequest, ::google::cloud::video::livestream::v1::Channel>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::video::livestream::v1::GetChannelRequest* request, ::google::cloud::video::livestream::v1::Channel* response) { return this->GetChannel(context, request, response); }));}
    void SetMessageAllocatorFor_GetChannel(
        ::grpc::MessageAllocator< ::google::cloud::video::livestream::v1::GetChannelRequest, ::google::cloud::video::livestream::v1::Channel>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(2);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::livestream::v1::GetChannelRequest, ::google::cloud::video::livestream::v1::Channel>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetChannel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetChannel(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::GetChannelRequest* /*request*/, ::google::cloud::video::livestream::v1::Channel* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetChannel(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::video::livestream::v1::GetChannelRequest* /*request*/, ::google::cloud::video::livestream::v1::Channel* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteChannel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteChannel() {
      ::grpc::Service::MarkMethodCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::livestream::v1::DeleteChannelRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::video::livestream::v1::DeleteChannelRequest* request, ::google::longrunning::Operation* response) { return this->DeleteChannel(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteChannel(
        ::grpc::MessageAllocator< ::google::cloud::video::livestream::v1::DeleteChannelRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(3);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::livestream::v1::DeleteChannelRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteChannel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteChannel(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::DeleteChannelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteChannel(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::video::livestream::v1::DeleteChannelRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateChannel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateChannel() {
      ::grpc::Service::MarkMethodCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::livestream::v1::UpdateChannelRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::video::livestream::v1::UpdateChannelRequest* request, ::google::longrunning::Operation* response) { return this->UpdateChannel(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateChannel(
        ::grpc::MessageAllocator< ::google::cloud::video::livestream::v1::UpdateChannelRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(4);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::livestream::v1::UpdateChannelRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateChannel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateChannel(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::UpdateChannelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateChannel(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::video::livestream::v1::UpdateChannelRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_StartChannel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_StartChannel() {
      ::grpc::Service::MarkMethodCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::livestream::v1::StartChannelRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::video::livestream::v1::StartChannelRequest* request, ::google::longrunning::Operation* response) { return this->StartChannel(context, request, response); }));}
    void SetMessageAllocatorFor_StartChannel(
        ::grpc::MessageAllocator< ::google::cloud::video::livestream::v1::StartChannelRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(5);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::livestream::v1::StartChannelRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_StartChannel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StartChannel(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::StartChannelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* StartChannel(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::video::livestream::v1::StartChannelRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_StopChannel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_StopChannel() {
      ::grpc::Service::MarkMethodCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::livestream::v1::StopChannelRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::video::livestream::v1::StopChannelRequest* request, ::google::longrunning::Operation* response) { return this->StopChannel(context, request, response); }));}
    void SetMessageAllocatorFor_StopChannel(
        ::grpc::MessageAllocator< ::google::cloud::video::livestream::v1::StopChannelRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(6);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::livestream::v1::StopChannelRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_StopChannel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StopChannel(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::StopChannelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* StopChannel(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::video::livestream::v1::StopChannelRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateInput : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateInput() {
      ::grpc::Service::MarkMethodCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::livestream::v1::CreateInputRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::video::livestream::v1::CreateInputRequest* request, ::google::longrunning::Operation* response) { return this->CreateInput(context, request, response); }));}
    void SetMessageAllocatorFor_CreateInput(
        ::grpc::MessageAllocator< ::google::cloud::video::livestream::v1::CreateInputRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(7);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::livestream::v1::CreateInputRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateInput() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateInput(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::CreateInputRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateInput(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::video::livestream::v1::CreateInputRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListInputs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListInputs() {
      ::grpc::Service::MarkMethodCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::livestream::v1::ListInputsRequest, ::google::cloud::video::livestream::v1::ListInputsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::video::livestream::v1::ListInputsRequest* request, ::google::cloud::video::livestream::v1::ListInputsResponse* response) { return this->ListInputs(context, request, response); }));}
    void SetMessageAllocatorFor_ListInputs(
        ::grpc::MessageAllocator< ::google::cloud::video::livestream::v1::ListInputsRequest, ::google::cloud::video::livestream::v1::ListInputsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(8);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::livestream::v1::ListInputsRequest, ::google::cloud::video::livestream::v1::ListInputsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListInputs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInputs(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::ListInputsRequest* /*request*/, ::google::cloud::video::livestream::v1::ListInputsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListInputs(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::video::livestream::v1::ListInputsRequest* /*request*/, ::google::cloud::video::livestream::v1::ListInputsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetInput : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetInput() {
      ::grpc::Service::MarkMethodCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::livestream::v1::GetInputRequest, ::google::cloud::video::livestream::v1::Input>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::video::livestream::v1::GetInputRequest* request, ::google::cloud::video::livestream::v1::Input* response) { return this->GetInput(context, request, response); }));}
    void SetMessageAllocatorFor_GetInput(
        ::grpc::MessageAllocator< ::google::cloud::video::livestream::v1::GetInputRequest, ::google::cloud::video::livestream::v1::Input>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(9);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::livestream::v1::GetInputRequest, ::google::cloud::video::livestream::v1::Input>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetInput() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInput(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::GetInputRequest* /*request*/, ::google::cloud::video::livestream::v1::Input* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetInput(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::video::livestream::v1::GetInputRequest* /*request*/, ::google::cloud::video::livestream::v1::Input* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteInput : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteInput() {
      ::grpc::Service::MarkMethodCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::livestream::v1::DeleteInputRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::video::livestream::v1::DeleteInputRequest* request, ::google::longrunning::Operation* response) { return this->DeleteInput(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteInput(
        ::grpc::MessageAllocator< ::google::cloud::video::livestream::v1::DeleteInputRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(10);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::livestream::v1::DeleteInputRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteInput() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteInput(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::DeleteInputRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteInput(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::video::livestream::v1::DeleteInputRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdateInput : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdateInput() {
      ::grpc::Service::MarkMethodCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::livestream::v1::UpdateInputRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::video::livestream::v1::UpdateInputRequest* request, ::google::longrunning::Operation* response) { return this->UpdateInput(context, request, response); }));}
    void SetMessageAllocatorFor_UpdateInput(
        ::grpc::MessageAllocator< ::google::cloud::video::livestream::v1::UpdateInputRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(11);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::livestream::v1::UpdateInputRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdateInput() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateInput(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::UpdateInputRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateInput(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::video::livestream::v1::UpdateInputRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateEvent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateEvent() {
      ::grpc::Service::MarkMethodCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::livestream::v1::CreateEventRequest, ::google::cloud::video::livestream::v1::Event>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::video::livestream::v1::CreateEventRequest* request, ::google::cloud::video::livestream::v1::Event* response) { return this->CreateEvent(context, request, response); }));}
    void SetMessageAllocatorFor_CreateEvent(
        ::grpc::MessageAllocator< ::google::cloud::video::livestream::v1::CreateEventRequest, ::google::cloud::video::livestream::v1::Event>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(12);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::livestream::v1::CreateEventRequest, ::google::cloud::video::livestream::v1::Event>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateEvent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateEvent(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::CreateEventRequest* /*request*/, ::google::cloud::video::livestream::v1::Event* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateEvent(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::video::livestream::v1::CreateEventRequest* /*request*/, ::google::cloud::video::livestream::v1::Event* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListEvents : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListEvents() {
      ::grpc::Service::MarkMethodCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::livestream::v1::ListEventsRequest, ::google::cloud::video::livestream::v1::ListEventsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::video::livestream::v1::ListEventsRequest* request, ::google::cloud::video::livestream::v1::ListEventsResponse* response) { return this->ListEvents(context, request, response); }));}
    void SetMessageAllocatorFor_ListEvents(
        ::grpc::MessageAllocator< ::google::cloud::video::livestream::v1::ListEventsRequest, ::google::cloud::video::livestream::v1::ListEventsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(13);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::livestream::v1::ListEventsRequest, ::google::cloud::video::livestream::v1::ListEventsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListEvents() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListEvents(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::ListEventsRequest* /*request*/, ::google::cloud::video::livestream::v1::ListEventsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListEvents(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::video::livestream::v1::ListEventsRequest* /*request*/, ::google::cloud::video::livestream::v1::ListEventsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetEvent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetEvent() {
      ::grpc::Service::MarkMethodCallback(14,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::livestream::v1::GetEventRequest, ::google::cloud::video::livestream::v1::Event>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::video::livestream::v1::GetEventRequest* request, ::google::cloud::video::livestream::v1::Event* response) { return this->GetEvent(context, request, response); }));}
    void SetMessageAllocatorFor_GetEvent(
        ::grpc::MessageAllocator< ::google::cloud::video::livestream::v1::GetEventRequest, ::google::cloud::video::livestream::v1::Event>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(14);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::livestream::v1::GetEventRequest, ::google::cloud::video::livestream::v1::Event>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetEvent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEvent(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::GetEventRequest* /*request*/, ::google::cloud::video::livestream::v1::Event* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetEvent(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::video::livestream::v1::GetEventRequest* /*request*/, ::google::cloud::video::livestream::v1::Event* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteEvent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteEvent() {
      ::grpc::Service::MarkMethodCallback(15,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::livestream::v1::DeleteEventRequest, ::google::protobuf::Empty>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::video::livestream::v1::DeleteEventRequest* request, ::google::protobuf::Empty* response) { return this->DeleteEvent(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteEvent(
        ::grpc::MessageAllocator< ::google::cloud::video::livestream::v1::DeleteEventRequest, ::google::protobuf::Empty>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(15);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::livestream::v1::DeleteEventRequest, ::google::protobuf::Empty>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteEvent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteEvent(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::DeleteEventRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteEvent(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::video::livestream::v1::DeleteEventRequest* /*request*/, ::google::protobuf::Empty* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListClips : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListClips() {
      ::grpc::Service::MarkMethodCallback(16,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::livestream::v1::ListClipsRequest, ::google::cloud::video::livestream::v1::ListClipsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::video::livestream::v1::ListClipsRequest* request, ::google::cloud::video::livestream::v1::ListClipsResponse* response) { return this->ListClips(context, request, response); }));}
    void SetMessageAllocatorFor_ListClips(
        ::grpc::MessageAllocator< ::google::cloud::video::livestream::v1::ListClipsRequest, ::google::cloud::video::livestream::v1::ListClipsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(16);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::livestream::v1::ListClipsRequest, ::google::cloud::video::livestream::v1::ListClipsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListClips() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListClips(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::ListClipsRequest* /*request*/, ::google::cloud::video::livestream::v1::ListClipsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListClips(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::video::livestream::v1::ListClipsRequest* /*request*/, ::google::cloud::video::livestream::v1::ListClipsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetClip : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetClip() {
      ::grpc::Service::MarkMethodCallback(17,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::livestream::v1::GetClipRequest, ::google::cloud::video::livestream::v1::Clip>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::video::livestream::v1::GetClipRequest* request, ::google::cloud::video::livestream::v1::Clip* response) { return this->GetClip(context, request, response); }));}
    void SetMessageAllocatorFor_GetClip(
        ::grpc::MessageAllocator< ::google::cloud::video::livestream::v1::GetClipRequest, ::google::cloud::video::livestream::v1::Clip>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(17);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::livestream::v1::GetClipRequest, ::google::cloud::video::livestream::v1::Clip>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetClip() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetClip(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::GetClipRequest* /*request*/, ::google::cloud::video::livestream::v1::Clip* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetClip(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::video::livestream::v1::GetClipRequest* /*request*/, ::google::cloud::video::livestream::v1::Clip* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateClip : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateClip() {
      ::grpc::Service::MarkMethodCallback(18,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::livestream::v1::CreateClipRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::video::livestream::v1::CreateClipRequest* request, ::google::longrunning::Operation* response) { return this->CreateClip(context, request, response); }));}
    void SetMessageAllocatorFor_CreateClip(
        ::grpc::MessageAllocator< ::google::cloud::video::livestream::v1::CreateClipRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(18);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::livestream::v1::CreateClipRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateClip() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateClip(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::CreateClipRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateClip(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::video::livestream::v1::CreateClipRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteClip : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteClip() {
      ::grpc::Service::MarkMethodCallback(19,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::livestream::v1::DeleteClipRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::video::livestream::v1::DeleteClipRequest* request, ::google::longrunning::Operation* response) { return this->DeleteClip(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteClip(
        ::grpc::MessageAllocator< ::google::cloud::video::livestream::v1::DeleteClipRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(19);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::livestream::v1::DeleteClipRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteClip() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteClip(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::DeleteClipRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteClip(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::video::livestream::v1::DeleteClipRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_CreateAsset : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_CreateAsset() {
      ::grpc::Service::MarkMethodCallback(20,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::livestream::v1::CreateAssetRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::video::livestream::v1::CreateAssetRequest* request, ::google::longrunning::Operation* response) { return this->CreateAsset(context, request, response); }));}
    void SetMessageAllocatorFor_CreateAsset(
        ::grpc::MessageAllocator< ::google::cloud::video::livestream::v1::CreateAssetRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(20);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::livestream::v1::CreateAssetRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_CreateAsset() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAsset(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::CreateAssetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateAsset(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::video::livestream::v1::CreateAssetRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_DeleteAsset : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_DeleteAsset() {
      ::grpc::Service::MarkMethodCallback(21,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::livestream::v1::DeleteAssetRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::video::livestream::v1::DeleteAssetRequest* request, ::google::longrunning::Operation* response) { return this->DeleteAsset(context, request, response); }));}
    void SetMessageAllocatorFor_DeleteAsset(
        ::grpc::MessageAllocator< ::google::cloud::video::livestream::v1::DeleteAssetRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(21);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::livestream::v1::DeleteAssetRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_DeleteAsset() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAsset(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::DeleteAssetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteAsset(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::video::livestream::v1::DeleteAssetRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetAsset : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetAsset() {
      ::grpc::Service::MarkMethodCallback(22,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::livestream::v1::GetAssetRequest, ::google::cloud::video::livestream::v1::Asset>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::video::livestream::v1::GetAssetRequest* request, ::google::cloud::video::livestream::v1::Asset* response) { return this->GetAsset(context, request, response); }));}
    void SetMessageAllocatorFor_GetAsset(
        ::grpc::MessageAllocator< ::google::cloud::video::livestream::v1::GetAssetRequest, ::google::cloud::video::livestream::v1::Asset>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(22);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::livestream::v1::GetAssetRequest, ::google::cloud::video::livestream::v1::Asset>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetAsset() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAsset(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::GetAssetRequest* /*request*/, ::google::cloud::video::livestream::v1::Asset* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetAsset(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::video::livestream::v1::GetAssetRequest* /*request*/, ::google::cloud::video::livestream::v1::Asset* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_ListAssets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_ListAssets() {
      ::grpc::Service::MarkMethodCallback(23,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::livestream::v1::ListAssetsRequest, ::google::cloud::video::livestream::v1::ListAssetsResponse>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::video::livestream::v1::ListAssetsRequest* request, ::google::cloud::video::livestream::v1::ListAssetsResponse* response) { return this->ListAssets(context, request, response); }));}
    void SetMessageAllocatorFor_ListAssets(
        ::grpc::MessageAllocator< ::google::cloud::video::livestream::v1::ListAssetsRequest, ::google::cloud::video::livestream::v1::ListAssetsResponse>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(23);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::livestream::v1::ListAssetsRequest, ::google::cloud::video::livestream::v1::ListAssetsResponse>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_ListAssets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAssets(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::ListAssetsRequest* /*request*/, ::google::cloud::video::livestream::v1::ListAssetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListAssets(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::video::livestream::v1::ListAssetsRequest* /*request*/, ::google::cloud::video::livestream::v1::ListAssetsResponse* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_GetPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_GetPool() {
      ::grpc::Service::MarkMethodCallback(24,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::livestream::v1::GetPoolRequest, ::google::cloud::video::livestream::v1::Pool>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::video::livestream::v1::GetPoolRequest* request, ::google::cloud::video::livestream::v1::Pool* response) { return this->GetPool(context, request, response); }));}
    void SetMessageAllocatorFor_GetPool(
        ::grpc::MessageAllocator< ::google::cloud::video::livestream::v1::GetPoolRequest, ::google::cloud::video::livestream::v1::Pool>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(24);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::livestream::v1::GetPoolRequest, ::google::cloud::video::livestream::v1::Pool>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_GetPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPool(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::GetPoolRequest* /*request*/, ::google::cloud::video::livestream::v1::Pool* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetPool(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::video::livestream::v1::GetPoolRequest* /*request*/, ::google::cloud::video::livestream::v1::Pool* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithCallbackMethod_UpdatePool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithCallbackMethod_UpdatePool() {
      ::grpc::Service::MarkMethodCallback(25,
          new ::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::livestream::v1::UpdatePoolRequest, ::google::longrunning::Operation>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::google::cloud::video::livestream::v1::UpdatePoolRequest* request, ::google::longrunning::Operation* response) { return this->UpdatePool(context, request, response); }));}
    void SetMessageAllocatorFor_UpdatePool(
        ::grpc::MessageAllocator< ::google::cloud::video::livestream::v1::UpdatePoolRequest, ::google::longrunning::Operation>* allocator) {
      ::grpc::internal::MethodHandler* const handler = ::grpc::Service::GetHandler(25);
      static_cast<::grpc::internal::CallbackUnaryHandler< ::google::cloud::video::livestream::v1::UpdatePoolRequest, ::google::longrunning::Operation>*>(handler)
              ->SetMessageAllocator(allocator);
    }
    ~WithCallbackMethod_UpdatePool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdatePool(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::UpdatePoolRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdatePool(
      ::grpc::CallbackServerContext* /*context*/, const ::google::cloud::video::livestream::v1::UpdatePoolRequest* /*request*/, ::google::longrunning::Operation* /*response*/)  { return nullptr; }
  };
  typedef WithCallbackMethod_CreateChannel<WithCallbackMethod_ListChannels<WithCallbackMethod_GetChannel<WithCallbackMethod_DeleteChannel<WithCallbackMethod_UpdateChannel<WithCallbackMethod_StartChannel<WithCallbackMethod_StopChannel<WithCallbackMethod_CreateInput<WithCallbackMethod_ListInputs<WithCallbackMethod_GetInput<WithCallbackMethod_DeleteInput<WithCallbackMethod_UpdateInput<WithCallbackMethod_CreateEvent<WithCallbackMethod_ListEvents<WithCallbackMethod_GetEvent<WithCallbackMethod_DeleteEvent<WithCallbackMethod_ListClips<WithCallbackMethod_GetClip<WithCallbackMethod_CreateClip<WithCallbackMethod_DeleteClip<WithCallbackMethod_CreateAsset<WithCallbackMethod_DeleteAsset<WithCallbackMethod_GetAsset<WithCallbackMethod_ListAssets<WithCallbackMethod_GetPool<WithCallbackMethod_UpdatePool<Service > > > > > > > > > > > > > > > > > > > > > > > > > > CallbackService;
  typedef CallbackService ExperimentalCallbackService;
  template <class BaseClass>
  class WithGenericMethod_CreateChannel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateChannel() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_CreateChannel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateChannel(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::CreateChannelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListChannels : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListChannels() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_ListChannels() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListChannels(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::ListChannelsRequest* /*request*/, ::google::cloud::video::livestream::v1::ListChannelsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetChannel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetChannel() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_GetChannel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetChannel(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::GetChannelRequest* /*request*/, ::google::cloud::video::livestream::v1::Channel* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteChannel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteChannel() {
      ::grpc::Service::MarkMethodGeneric(3);
    }
    ~WithGenericMethod_DeleteChannel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteChannel(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::DeleteChannelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateChannel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateChannel() {
      ::grpc::Service::MarkMethodGeneric(4);
    }
    ~WithGenericMethod_UpdateChannel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateChannel(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::UpdateChannelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_StartChannel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_StartChannel() {
      ::grpc::Service::MarkMethodGeneric(5);
    }
    ~WithGenericMethod_StartChannel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StartChannel(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::StartChannelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_StopChannel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_StopChannel() {
      ::grpc::Service::MarkMethodGeneric(6);
    }
    ~WithGenericMethod_StopChannel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StopChannel(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::StopChannelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateInput : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateInput() {
      ::grpc::Service::MarkMethodGeneric(7);
    }
    ~WithGenericMethod_CreateInput() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateInput(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::CreateInputRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListInputs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListInputs() {
      ::grpc::Service::MarkMethodGeneric(8);
    }
    ~WithGenericMethod_ListInputs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInputs(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::ListInputsRequest* /*request*/, ::google::cloud::video::livestream::v1::ListInputsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetInput : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetInput() {
      ::grpc::Service::MarkMethodGeneric(9);
    }
    ~WithGenericMethod_GetInput() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInput(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::GetInputRequest* /*request*/, ::google::cloud::video::livestream::v1::Input* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteInput : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteInput() {
      ::grpc::Service::MarkMethodGeneric(10);
    }
    ~WithGenericMethod_DeleteInput() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteInput(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::DeleteInputRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdateInput : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdateInput() {
      ::grpc::Service::MarkMethodGeneric(11);
    }
    ~WithGenericMethod_UpdateInput() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateInput(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::UpdateInputRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateEvent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateEvent() {
      ::grpc::Service::MarkMethodGeneric(12);
    }
    ~WithGenericMethod_CreateEvent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateEvent(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::CreateEventRequest* /*request*/, ::google::cloud::video::livestream::v1::Event* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListEvents : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListEvents() {
      ::grpc::Service::MarkMethodGeneric(13);
    }
    ~WithGenericMethod_ListEvents() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListEvents(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::ListEventsRequest* /*request*/, ::google::cloud::video::livestream::v1::ListEventsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetEvent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetEvent() {
      ::grpc::Service::MarkMethodGeneric(14);
    }
    ~WithGenericMethod_GetEvent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEvent(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::GetEventRequest* /*request*/, ::google::cloud::video::livestream::v1::Event* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteEvent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteEvent() {
      ::grpc::Service::MarkMethodGeneric(15);
    }
    ~WithGenericMethod_DeleteEvent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteEvent(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::DeleteEventRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListClips : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListClips() {
      ::grpc::Service::MarkMethodGeneric(16);
    }
    ~WithGenericMethod_ListClips() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListClips(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::ListClipsRequest* /*request*/, ::google::cloud::video::livestream::v1::ListClipsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetClip : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetClip() {
      ::grpc::Service::MarkMethodGeneric(17);
    }
    ~WithGenericMethod_GetClip() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetClip(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::GetClipRequest* /*request*/, ::google::cloud::video::livestream::v1::Clip* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateClip : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateClip() {
      ::grpc::Service::MarkMethodGeneric(18);
    }
    ~WithGenericMethod_CreateClip() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateClip(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::CreateClipRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteClip : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteClip() {
      ::grpc::Service::MarkMethodGeneric(19);
    }
    ~WithGenericMethod_DeleteClip() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteClip(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::DeleteClipRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_CreateAsset : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_CreateAsset() {
      ::grpc::Service::MarkMethodGeneric(20);
    }
    ~WithGenericMethod_CreateAsset() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAsset(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::CreateAssetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_DeleteAsset : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_DeleteAsset() {
      ::grpc::Service::MarkMethodGeneric(21);
    }
    ~WithGenericMethod_DeleteAsset() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAsset(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::DeleteAssetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetAsset : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetAsset() {
      ::grpc::Service::MarkMethodGeneric(22);
    }
    ~WithGenericMethod_GetAsset() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAsset(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::GetAssetRequest* /*request*/, ::google::cloud::video::livestream::v1::Asset* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ListAssets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_ListAssets() {
      ::grpc::Service::MarkMethodGeneric(23);
    }
    ~WithGenericMethod_ListAssets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAssets(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::ListAssetsRequest* /*request*/, ::google::cloud::video::livestream::v1::ListAssetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_GetPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_GetPool() {
      ::grpc::Service::MarkMethodGeneric(24);
    }
    ~WithGenericMethod_GetPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPool(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::GetPoolRequest* /*request*/, ::google::cloud::video::livestream::v1::Pool* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_UpdatePool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithGenericMethod_UpdatePool() {
      ::grpc::Service::MarkMethodGeneric(25);
    }
    ~WithGenericMethod_UpdatePool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdatePool(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::UpdatePoolRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateChannel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateChannel() {
      ::grpc::Service::MarkMethodRaw(0);
    }
    ~WithRawMethod_CreateChannel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateChannel(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::CreateChannelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateChannel(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListChannels : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListChannels() {
      ::grpc::Service::MarkMethodRaw(1);
    }
    ~WithRawMethod_ListChannels() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListChannels(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::ListChannelsRequest* /*request*/, ::google::cloud::video::livestream::v1::ListChannelsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListChannels(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetChannel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetChannel() {
      ::grpc::Service::MarkMethodRaw(2);
    }
    ~WithRawMethod_GetChannel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetChannel(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::GetChannelRequest* /*request*/, ::google::cloud::video::livestream::v1::Channel* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetChannel(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteChannel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteChannel() {
      ::grpc::Service::MarkMethodRaw(3);
    }
    ~WithRawMethod_DeleteChannel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteChannel(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::DeleteChannelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteChannel(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(3, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateChannel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateChannel() {
      ::grpc::Service::MarkMethodRaw(4);
    }
    ~WithRawMethod_UpdateChannel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateChannel(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::UpdateChannelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateChannel(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(4, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_StartChannel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_StartChannel() {
      ::grpc::Service::MarkMethodRaw(5);
    }
    ~WithRawMethod_StartChannel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StartChannel(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::StartChannelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestStartChannel(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(5, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_StopChannel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_StopChannel() {
      ::grpc::Service::MarkMethodRaw(6);
    }
    ~WithRawMethod_StopChannel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StopChannel(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::StopChannelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestStopChannel(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(6, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateInput : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateInput() {
      ::grpc::Service::MarkMethodRaw(7);
    }
    ~WithRawMethod_CreateInput() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateInput(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::CreateInputRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateInput(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(7, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListInputs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListInputs() {
      ::grpc::Service::MarkMethodRaw(8);
    }
    ~WithRawMethod_ListInputs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInputs(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::ListInputsRequest* /*request*/, ::google::cloud::video::livestream::v1::ListInputsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListInputs(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(8, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetInput : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetInput() {
      ::grpc::Service::MarkMethodRaw(9);
    }
    ~WithRawMethod_GetInput() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInput(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::GetInputRequest* /*request*/, ::google::cloud::video::livestream::v1::Input* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetInput(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(9, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteInput : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteInput() {
      ::grpc::Service::MarkMethodRaw(10);
    }
    ~WithRawMethod_DeleteInput() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteInput(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::DeleteInputRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteInput(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(10, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdateInput : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdateInput() {
      ::grpc::Service::MarkMethodRaw(11);
    }
    ~WithRawMethod_UpdateInput() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateInput(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::UpdateInputRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdateInput(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(11, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateEvent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateEvent() {
      ::grpc::Service::MarkMethodRaw(12);
    }
    ~WithRawMethod_CreateEvent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateEvent(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::CreateEventRequest* /*request*/, ::google::cloud::video::livestream::v1::Event* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateEvent(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(12, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListEvents : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListEvents() {
      ::grpc::Service::MarkMethodRaw(13);
    }
    ~WithRawMethod_ListEvents() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListEvents(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::ListEventsRequest* /*request*/, ::google::cloud::video::livestream::v1::ListEventsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListEvents(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(13, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetEvent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetEvent() {
      ::grpc::Service::MarkMethodRaw(14);
    }
    ~WithRawMethod_GetEvent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEvent(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::GetEventRequest* /*request*/, ::google::cloud::video::livestream::v1::Event* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetEvent(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(14, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteEvent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteEvent() {
      ::grpc::Service::MarkMethodRaw(15);
    }
    ~WithRawMethod_DeleteEvent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteEvent(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::DeleteEventRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteEvent(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(15, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListClips : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListClips() {
      ::grpc::Service::MarkMethodRaw(16);
    }
    ~WithRawMethod_ListClips() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListClips(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::ListClipsRequest* /*request*/, ::google::cloud::video::livestream::v1::ListClipsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListClips(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(16, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetClip : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetClip() {
      ::grpc::Service::MarkMethodRaw(17);
    }
    ~WithRawMethod_GetClip() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetClip(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::GetClipRequest* /*request*/, ::google::cloud::video::livestream::v1::Clip* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetClip(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(17, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateClip : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateClip() {
      ::grpc::Service::MarkMethodRaw(18);
    }
    ~WithRawMethod_CreateClip() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateClip(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::CreateClipRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateClip(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(18, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteClip : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteClip() {
      ::grpc::Service::MarkMethodRaw(19);
    }
    ~WithRawMethod_DeleteClip() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteClip(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::DeleteClipRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteClip(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(19, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_CreateAsset : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_CreateAsset() {
      ::grpc::Service::MarkMethodRaw(20);
    }
    ~WithRawMethod_CreateAsset() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAsset(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::CreateAssetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestCreateAsset(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(20, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_DeleteAsset : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_DeleteAsset() {
      ::grpc::Service::MarkMethodRaw(21);
    }
    ~WithRawMethod_DeleteAsset() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAsset(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::DeleteAssetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestDeleteAsset(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(21, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetAsset : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetAsset() {
      ::grpc::Service::MarkMethodRaw(22);
    }
    ~WithRawMethod_GetAsset() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAsset(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::GetAssetRequest* /*request*/, ::google::cloud::video::livestream::v1::Asset* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetAsset(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(22, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_ListAssets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_ListAssets() {
      ::grpc::Service::MarkMethodRaw(23);
    }
    ~WithRawMethod_ListAssets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAssets(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::ListAssetsRequest* /*request*/, ::google::cloud::video::livestream::v1::ListAssetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestListAssets(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(23, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_GetPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_GetPool() {
      ::grpc::Service::MarkMethodRaw(24);
    }
    ~WithRawMethod_GetPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPool(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::GetPoolRequest* /*request*/, ::google::cloud::video::livestream::v1::Pool* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestGetPool(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(24, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawMethod_UpdatePool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawMethod_UpdatePool() {
      ::grpc::Service::MarkMethodRaw(25);
    }
    ~WithRawMethod_UpdatePool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdatePool(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::UpdatePoolRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestUpdatePool(::grpc::ServerContext* context, ::grpc::ByteBuffer* request, ::grpc::ServerAsyncResponseWriter< ::grpc::ByteBuffer>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(25, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateChannel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateChannel() {
      ::grpc::Service::MarkMethodRawCallback(0,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateChannel(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateChannel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateChannel(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::CreateChannelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateChannel(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListChannels : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListChannels() {
      ::grpc::Service::MarkMethodRawCallback(1,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListChannels(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListChannels() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListChannels(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::ListChannelsRequest* /*request*/, ::google::cloud::video::livestream::v1::ListChannelsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListChannels(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetChannel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetChannel() {
      ::grpc::Service::MarkMethodRawCallback(2,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetChannel(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetChannel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetChannel(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::GetChannelRequest* /*request*/, ::google::cloud::video::livestream::v1::Channel* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetChannel(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteChannel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteChannel() {
      ::grpc::Service::MarkMethodRawCallback(3,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteChannel(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteChannel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteChannel(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::DeleteChannelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteChannel(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateChannel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateChannel() {
      ::grpc::Service::MarkMethodRawCallback(4,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateChannel(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateChannel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateChannel(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::UpdateChannelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateChannel(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_StartChannel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_StartChannel() {
      ::grpc::Service::MarkMethodRawCallback(5,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->StartChannel(context, request, response); }));
    }
    ~WithRawCallbackMethod_StartChannel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StartChannel(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::StartChannelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* StartChannel(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_StopChannel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_StopChannel() {
      ::grpc::Service::MarkMethodRawCallback(6,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->StopChannel(context, request, response); }));
    }
    ~WithRawCallbackMethod_StopChannel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status StopChannel(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::StopChannelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* StopChannel(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateInput : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateInput() {
      ::grpc::Service::MarkMethodRawCallback(7,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateInput(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateInput() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateInput(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::CreateInputRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateInput(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListInputs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListInputs() {
      ::grpc::Service::MarkMethodRawCallback(8,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListInputs(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListInputs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListInputs(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::ListInputsRequest* /*request*/, ::google::cloud::video::livestream::v1::ListInputsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListInputs(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetInput : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetInput() {
      ::grpc::Service::MarkMethodRawCallback(9,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetInput(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetInput() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetInput(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::GetInputRequest* /*request*/, ::google::cloud::video::livestream::v1::Input* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetInput(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteInput : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteInput() {
      ::grpc::Service::MarkMethodRawCallback(10,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteInput(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteInput() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteInput(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::DeleteInputRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteInput(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdateInput : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdateInput() {
      ::grpc::Service::MarkMethodRawCallback(11,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdateInput(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdateInput() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdateInput(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::UpdateInputRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdateInput(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateEvent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateEvent() {
      ::grpc::Service::MarkMethodRawCallback(12,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateEvent(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateEvent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateEvent(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::CreateEventRequest* /*request*/, ::google::cloud::video::livestream::v1::Event* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateEvent(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListEvents : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListEvents() {
      ::grpc::Service::MarkMethodRawCallback(13,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListEvents(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListEvents() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListEvents(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::ListEventsRequest* /*request*/, ::google::cloud::video::livestream::v1::ListEventsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListEvents(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetEvent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetEvent() {
      ::grpc::Service::MarkMethodRawCallback(14,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetEvent(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetEvent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetEvent(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::GetEventRequest* /*request*/, ::google::cloud::video::livestream::v1::Event* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetEvent(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteEvent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteEvent() {
      ::grpc::Service::MarkMethodRawCallback(15,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteEvent(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteEvent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteEvent(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::DeleteEventRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteEvent(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListClips : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListClips() {
      ::grpc::Service::MarkMethodRawCallback(16,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListClips(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListClips() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListClips(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::ListClipsRequest* /*request*/, ::google::cloud::video::livestream::v1::ListClipsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListClips(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetClip : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetClip() {
      ::grpc::Service::MarkMethodRawCallback(17,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetClip(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetClip() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetClip(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::GetClipRequest* /*request*/, ::google::cloud::video::livestream::v1::Clip* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetClip(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateClip : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateClip() {
      ::grpc::Service::MarkMethodRawCallback(18,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateClip(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateClip() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateClip(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::CreateClipRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateClip(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteClip : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteClip() {
      ::grpc::Service::MarkMethodRawCallback(19,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteClip(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteClip() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteClip(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::DeleteClipRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteClip(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_CreateAsset : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_CreateAsset() {
      ::grpc::Service::MarkMethodRawCallback(20,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->CreateAsset(context, request, response); }));
    }
    ~WithRawCallbackMethod_CreateAsset() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status CreateAsset(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::CreateAssetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* CreateAsset(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_DeleteAsset : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_DeleteAsset() {
      ::grpc::Service::MarkMethodRawCallback(21,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->DeleteAsset(context, request, response); }));
    }
    ~WithRawCallbackMethod_DeleteAsset() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status DeleteAsset(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::DeleteAssetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* DeleteAsset(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetAsset : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetAsset() {
      ::grpc::Service::MarkMethodRawCallback(22,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetAsset(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetAsset() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetAsset(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::GetAssetRequest* /*request*/, ::google::cloud::video::livestream::v1::Asset* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetAsset(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_ListAssets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_ListAssets() {
      ::grpc::Service::MarkMethodRawCallback(23,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->ListAssets(context, request, response); }));
    }
    ~WithRawCallbackMethod_ListAssets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ListAssets(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::ListAssetsRequest* /*request*/, ::google::cloud::video::livestream::v1::ListAssetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* ListAssets(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_GetPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_GetPool() {
      ::grpc::Service::MarkMethodRawCallback(24,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->GetPool(context, request, response); }));
    }
    ~WithRawCallbackMethod_GetPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status GetPool(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::GetPoolRequest* /*request*/, ::google::cloud::video::livestream::v1::Pool* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* GetPool(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithRawCallbackMethod_UpdatePool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithRawCallbackMethod_UpdatePool() {
      ::grpc::Service::MarkMethodRawCallback(25,
          new ::grpc::internal::CallbackUnaryHandler< ::grpc::ByteBuffer, ::grpc::ByteBuffer>(
            [this](
                   ::grpc::CallbackServerContext* context, const ::grpc::ByteBuffer* request, ::grpc::ByteBuffer* response) { return this->UpdatePool(context, request, response); }));
    }
    ~WithRawCallbackMethod_UpdatePool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status UpdatePool(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::UpdatePoolRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    virtual ::grpc::ServerUnaryReactor* UpdatePool(
      ::grpc::CallbackServerContext* /*context*/, const ::grpc::ByteBuffer* /*request*/, ::grpc::ByteBuffer* /*response*/)  { return nullptr; }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateChannel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateChannel() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::video::livestream::v1::CreateChannelRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::video::livestream::v1::CreateChannelRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateChannel(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateChannel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateChannel(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::CreateChannelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateChannel(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::video::livestream::v1::CreateChannelRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListChannels : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListChannels() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::video::livestream::v1::ListChannelsRequest, ::google::cloud::video::livestream::v1::ListChannelsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::video::livestream::v1::ListChannelsRequest, ::google::cloud::video::livestream::v1::ListChannelsResponse>* streamer) {
                       return this->StreamedListChannels(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListChannels() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListChannels(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::ListChannelsRequest* /*request*/, ::google::cloud::video::livestream::v1::ListChannelsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListChannels(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::video::livestream::v1::ListChannelsRequest,::google::cloud::video::livestream::v1::ListChannelsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetChannel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetChannel() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::video::livestream::v1::GetChannelRequest, ::google::cloud::video::livestream::v1::Channel>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::video::livestream::v1::GetChannelRequest, ::google::cloud::video::livestream::v1::Channel>* streamer) {
                       return this->StreamedGetChannel(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetChannel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetChannel(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::GetChannelRequest* /*request*/, ::google::cloud::video::livestream::v1::Channel* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetChannel(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::video::livestream::v1::GetChannelRequest,::google::cloud::video::livestream::v1::Channel>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteChannel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteChannel() {
      ::grpc::Service::MarkMethodStreamed(3,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::video::livestream::v1::DeleteChannelRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::video::livestream::v1::DeleteChannelRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteChannel(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteChannel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteChannel(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::DeleteChannelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteChannel(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::video::livestream::v1::DeleteChannelRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateChannel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateChannel() {
      ::grpc::Service::MarkMethodStreamed(4,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::video::livestream::v1::UpdateChannelRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::video::livestream::v1::UpdateChannelRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateChannel(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateChannel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateChannel(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::UpdateChannelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateChannel(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::video::livestream::v1::UpdateChannelRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_StartChannel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_StartChannel() {
      ::grpc::Service::MarkMethodStreamed(5,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::video::livestream::v1::StartChannelRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::video::livestream::v1::StartChannelRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedStartChannel(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_StartChannel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status StartChannel(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::StartChannelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedStartChannel(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::video::livestream::v1::StartChannelRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_StopChannel : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_StopChannel() {
      ::grpc::Service::MarkMethodStreamed(6,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::video::livestream::v1::StopChannelRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::video::livestream::v1::StopChannelRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedStopChannel(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_StopChannel() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status StopChannel(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::StopChannelRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedStopChannel(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::video::livestream::v1::StopChannelRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateInput : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateInput() {
      ::grpc::Service::MarkMethodStreamed(7,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::video::livestream::v1::CreateInputRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::video::livestream::v1::CreateInputRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateInput(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateInput() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateInput(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::CreateInputRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateInput(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::video::livestream::v1::CreateInputRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListInputs : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListInputs() {
      ::grpc::Service::MarkMethodStreamed(8,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::video::livestream::v1::ListInputsRequest, ::google::cloud::video::livestream::v1::ListInputsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::video::livestream::v1::ListInputsRequest, ::google::cloud::video::livestream::v1::ListInputsResponse>* streamer) {
                       return this->StreamedListInputs(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListInputs() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListInputs(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::ListInputsRequest* /*request*/, ::google::cloud::video::livestream::v1::ListInputsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListInputs(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::video::livestream::v1::ListInputsRequest,::google::cloud::video::livestream::v1::ListInputsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetInput : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetInput() {
      ::grpc::Service::MarkMethodStreamed(9,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::video::livestream::v1::GetInputRequest, ::google::cloud::video::livestream::v1::Input>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::video::livestream::v1::GetInputRequest, ::google::cloud::video::livestream::v1::Input>* streamer) {
                       return this->StreamedGetInput(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetInput() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetInput(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::GetInputRequest* /*request*/, ::google::cloud::video::livestream::v1::Input* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetInput(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::video::livestream::v1::GetInputRequest,::google::cloud::video::livestream::v1::Input>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteInput : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteInput() {
      ::grpc::Service::MarkMethodStreamed(10,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::video::livestream::v1::DeleteInputRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::video::livestream::v1::DeleteInputRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteInput(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteInput() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteInput(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::DeleteInputRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteInput(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::video::livestream::v1::DeleteInputRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdateInput : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdateInput() {
      ::grpc::Service::MarkMethodStreamed(11,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::video::livestream::v1::UpdateInputRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::video::livestream::v1::UpdateInputRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdateInput(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdateInput() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdateInput(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::UpdateInputRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdateInput(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::video::livestream::v1::UpdateInputRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateEvent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateEvent() {
      ::grpc::Service::MarkMethodStreamed(12,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::video::livestream::v1::CreateEventRequest, ::google::cloud::video::livestream::v1::Event>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::video::livestream::v1::CreateEventRequest, ::google::cloud::video::livestream::v1::Event>* streamer) {
                       return this->StreamedCreateEvent(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateEvent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateEvent(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::CreateEventRequest* /*request*/, ::google::cloud::video::livestream::v1::Event* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateEvent(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::video::livestream::v1::CreateEventRequest,::google::cloud::video::livestream::v1::Event>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListEvents : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListEvents() {
      ::grpc::Service::MarkMethodStreamed(13,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::video::livestream::v1::ListEventsRequest, ::google::cloud::video::livestream::v1::ListEventsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::video::livestream::v1::ListEventsRequest, ::google::cloud::video::livestream::v1::ListEventsResponse>* streamer) {
                       return this->StreamedListEvents(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListEvents() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListEvents(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::ListEventsRequest* /*request*/, ::google::cloud::video::livestream::v1::ListEventsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListEvents(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::video::livestream::v1::ListEventsRequest,::google::cloud::video::livestream::v1::ListEventsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetEvent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetEvent() {
      ::grpc::Service::MarkMethodStreamed(14,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::video::livestream::v1::GetEventRequest, ::google::cloud::video::livestream::v1::Event>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::video::livestream::v1::GetEventRequest, ::google::cloud::video::livestream::v1::Event>* streamer) {
                       return this->StreamedGetEvent(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetEvent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetEvent(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::GetEventRequest* /*request*/, ::google::cloud::video::livestream::v1::Event* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetEvent(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::video::livestream::v1::GetEventRequest,::google::cloud::video::livestream::v1::Event>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteEvent : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteEvent() {
      ::grpc::Service::MarkMethodStreamed(15,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::video::livestream::v1::DeleteEventRequest, ::google::protobuf::Empty>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::video::livestream::v1::DeleteEventRequest, ::google::protobuf::Empty>* streamer) {
                       return this->StreamedDeleteEvent(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteEvent() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteEvent(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::DeleteEventRequest* /*request*/, ::google::protobuf::Empty* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteEvent(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::video::livestream::v1::DeleteEventRequest,::google::protobuf::Empty>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListClips : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListClips() {
      ::grpc::Service::MarkMethodStreamed(16,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::video::livestream::v1::ListClipsRequest, ::google::cloud::video::livestream::v1::ListClipsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::video::livestream::v1::ListClipsRequest, ::google::cloud::video::livestream::v1::ListClipsResponse>* streamer) {
                       return this->StreamedListClips(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListClips() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListClips(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::ListClipsRequest* /*request*/, ::google::cloud::video::livestream::v1::ListClipsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListClips(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::video::livestream::v1::ListClipsRequest,::google::cloud::video::livestream::v1::ListClipsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetClip : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetClip() {
      ::grpc::Service::MarkMethodStreamed(17,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::video::livestream::v1::GetClipRequest, ::google::cloud::video::livestream::v1::Clip>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::video::livestream::v1::GetClipRequest, ::google::cloud::video::livestream::v1::Clip>* streamer) {
                       return this->StreamedGetClip(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetClip() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetClip(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::GetClipRequest* /*request*/, ::google::cloud::video::livestream::v1::Clip* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetClip(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::video::livestream::v1::GetClipRequest,::google::cloud::video::livestream::v1::Clip>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateClip : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateClip() {
      ::grpc::Service::MarkMethodStreamed(18,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::video::livestream::v1::CreateClipRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::video::livestream::v1::CreateClipRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateClip(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateClip() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateClip(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::CreateClipRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateClip(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::video::livestream::v1::CreateClipRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteClip : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteClip() {
      ::grpc::Service::MarkMethodStreamed(19,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::video::livestream::v1::DeleteClipRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::video::livestream::v1::DeleteClipRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteClip(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteClip() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteClip(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::DeleteClipRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteClip(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::video::livestream::v1::DeleteClipRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_CreateAsset : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_CreateAsset() {
      ::grpc::Service::MarkMethodStreamed(20,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::video::livestream::v1::CreateAssetRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::video::livestream::v1::CreateAssetRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedCreateAsset(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_CreateAsset() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status CreateAsset(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::CreateAssetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedCreateAsset(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::video::livestream::v1::CreateAssetRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_DeleteAsset : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_DeleteAsset() {
      ::grpc::Service::MarkMethodStreamed(21,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::video::livestream::v1::DeleteAssetRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::video::livestream::v1::DeleteAssetRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedDeleteAsset(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_DeleteAsset() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status DeleteAsset(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::DeleteAssetRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedDeleteAsset(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::video::livestream::v1::DeleteAssetRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetAsset : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetAsset() {
      ::grpc::Service::MarkMethodStreamed(22,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::video::livestream::v1::GetAssetRequest, ::google::cloud::video::livestream::v1::Asset>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::video::livestream::v1::GetAssetRequest, ::google::cloud::video::livestream::v1::Asset>* streamer) {
                       return this->StreamedGetAsset(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetAsset() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetAsset(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::GetAssetRequest* /*request*/, ::google::cloud::video::livestream::v1::Asset* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetAsset(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::video::livestream::v1::GetAssetRequest,::google::cloud::video::livestream::v1::Asset>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ListAssets : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_ListAssets() {
      ::grpc::Service::MarkMethodStreamed(23,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::video::livestream::v1::ListAssetsRequest, ::google::cloud::video::livestream::v1::ListAssetsResponse>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::video::livestream::v1::ListAssetsRequest, ::google::cloud::video::livestream::v1::ListAssetsResponse>* streamer) {
                       return this->StreamedListAssets(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_ListAssets() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ListAssets(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::ListAssetsRequest* /*request*/, ::google::cloud::video::livestream::v1::ListAssetsResponse* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedListAssets(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::video::livestream::v1::ListAssetsRequest,::google::cloud::video::livestream::v1::ListAssetsResponse>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_GetPool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_GetPool() {
      ::grpc::Service::MarkMethodStreamed(24,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::video::livestream::v1::GetPoolRequest, ::google::cloud::video::livestream::v1::Pool>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::video::livestream::v1::GetPoolRequest, ::google::cloud::video::livestream::v1::Pool>* streamer) {
                       return this->StreamedGetPool(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_GetPool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status GetPool(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::GetPoolRequest* /*request*/, ::google::cloud::video::livestream::v1::Pool* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedGetPool(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::video::livestream::v1::GetPoolRequest,::google::cloud::video::livestream::v1::Pool>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_UpdatePool : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service* /*service*/) {}
   public:
    WithStreamedUnaryMethod_UpdatePool() {
      ::grpc::Service::MarkMethodStreamed(25,
        new ::grpc::internal::StreamedUnaryHandler<
          ::google::cloud::video::livestream::v1::UpdatePoolRequest, ::google::longrunning::Operation>(
            [this](::grpc::ServerContext* context,
                   ::grpc::ServerUnaryStreamer<
                     ::google::cloud::video::livestream::v1::UpdatePoolRequest, ::google::longrunning::Operation>* streamer) {
                       return this->StreamedUpdatePool(context,
                         streamer);
                  }));
    }
    ~WithStreamedUnaryMethod_UpdatePool() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status UpdatePool(::grpc::ServerContext* /*context*/, const ::google::cloud::video::livestream::v1::UpdatePoolRequest* /*request*/, ::google::longrunning::Operation* /*response*/) override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedUpdatePool(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::google::cloud::video::livestream::v1::UpdatePoolRequest,::google::longrunning::Operation>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_CreateChannel<WithStreamedUnaryMethod_ListChannels<WithStreamedUnaryMethod_GetChannel<WithStreamedUnaryMethod_DeleteChannel<WithStreamedUnaryMethod_UpdateChannel<WithStreamedUnaryMethod_StartChannel<WithStreamedUnaryMethod_StopChannel<WithStreamedUnaryMethod_CreateInput<WithStreamedUnaryMethod_ListInputs<WithStreamedUnaryMethod_GetInput<WithStreamedUnaryMethod_DeleteInput<WithStreamedUnaryMethod_UpdateInput<WithStreamedUnaryMethod_CreateEvent<WithStreamedUnaryMethod_ListEvents<WithStreamedUnaryMethod_GetEvent<WithStreamedUnaryMethod_DeleteEvent<WithStreamedUnaryMethod_ListClips<WithStreamedUnaryMethod_GetClip<WithStreamedUnaryMethod_CreateClip<WithStreamedUnaryMethod_DeleteClip<WithStreamedUnaryMethod_CreateAsset<WithStreamedUnaryMethod_DeleteAsset<WithStreamedUnaryMethod_GetAsset<WithStreamedUnaryMethod_ListAssets<WithStreamedUnaryMethod_GetPool<WithStreamedUnaryMethod_UpdatePool<Service > > > > > > > > > > > > > > > > > > > > > > > > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_CreateChannel<WithStreamedUnaryMethod_ListChannels<WithStreamedUnaryMethod_GetChannel<WithStreamedUnaryMethod_DeleteChannel<WithStreamedUnaryMethod_UpdateChannel<WithStreamedUnaryMethod_StartChannel<WithStreamedUnaryMethod_StopChannel<WithStreamedUnaryMethod_CreateInput<WithStreamedUnaryMethod_ListInputs<WithStreamedUnaryMethod_GetInput<WithStreamedUnaryMethod_DeleteInput<WithStreamedUnaryMethod_UpdateInput<WithStreamedUnaryMethod_CreateEvent<WithStreamedUnaryMethod_ListEvents<WithStreamedUnaryMethod_GetEvent<WithStreamedUnaryMethod_DeleteEvent<WithStreamedUnaryMethod_ListClips<WithStreamedUnaryMethod_GetClip<WithStreamedUnaryMethod_CreateClip<WithStreamedUnaryMethod_DeleteClip<WithStreamedUnaryMethod_CreateAsset<WithStreamedUnaryMethod_DeleteAsset<WithStreamedUnaryMethod_GetAsset<WithStreamedUnaryMethod_ListAssets<WithStreamedUnaryMethod_GetPool<WithStreamedUnaryMethod_UpdatePool<Service > > > > > > > > > > > > > > > > > > > > > > > > > > StreamedService;
};

}  // namespace v1
}  // namespace livestream
}  // namespace video
}  // namespace cloud
}  // namespace google


#include <grpcpp/ports_undef.inc>
#endif  // GRPC_google_2fcloud_2fvideo_2flivestream_2fv1_2fservice_2eproto__INCLUDED
